var MEArticleSelector = function() {
}

MEArticleSelector.prototype = {
	target: null,	
	domHelper: null,
	maxItems: 0,
	
	STRINGS: {
		REMOVE: 'Remove'
	},
	
	CLASSES: {
		A: 'article_selector_a',
		SPAN: 'article_selector_span'
	},
	
	bind: function(domHelper) {
		this.domHelper = domHelper;
		domHelper.parent = this;
	},
	
	itemExists: function(id) {
		return this.domHelper.getArticleElement(id);
	},
	
	getArticleIds: function() {
		return this.domHelper.getArticleIds();
	},
	
	addArticle: function(id, title) {
		if (this.maxItems == 1) {
			this.domHelper.clear();
			this._createArticleElement(id, title);
			return;
		}
		
		if (this.domHelper.count >= this.maxItems) {
			return false;
		}
		this._createArticleElement(id, title);
	},

	removeArticle: function(id) {
		this.domHelper.removeArticleElement(id);
	},

	_createArticleElement: function(id, title) {
		return this.domHelper.createElement(id, title);
	}
}

var MEArticleSelectorDomHelper = function(container) {
	this.container = container;
	this.addedRecords = {};
	this.titles = {};
	this.params = {};
	this.count = 0;
}

MEArticleSelectorDomHelper.prototype = {
	parent: null,
	count: null,
	addedRecords: null,
	titles: null,
	params: null,
	
	// event
	onArticleRemove: null,
	
	createElement: function(id, title) {
		if (this.getArticleElement(id))
			return this.getArticleElement(id); 
	
		if (title.length > 35)
			title = title.substr(0, 35) + '...';
		
		var self = this;
		
		var div = new Element('div', {'class': this.parent.CLASSES.SPAN}).setText(title);
		new Element('a', {href: 'javascript:void(0);',
			events: {
				'click': function() {
					self.removeArticleElement(id);
					if (self.onArticleRemove)
						self.onArticleRemove(id);
				}
			}
		}).setHTML(this.parent.STRINGS.REMOVE).inject(div);
		var wrp = new Element('div');
		$$('.params_' + id + '[type=hidden]').clone().setProperties({'type':'text', 'name':'toParams[]'}).injectInside(wrp);
		wrp.injectInside(div);
		
		new Element('input', {
			type: 'hidden', 
			value: id,
			'class': this.parent.CLASSES.A
		}).inject(div);
		
		this.addedRecords['article' + id] = div;
		this.titles['article' + id] = title;
		this.count ++;
		
		this.container.appendChild(div);
		
		if (this.onArticleAdd)
			this.onArticleAdd(div);
		
		return div;
	},
	
	removeArticleElement: function(id) {
		var el = this.getArticleElement(id);
		if (el) {
			el.remove();
			delete this.addedRecords['article' + id];
			delete this.titles['article' + id];
			this.count--;
		}
	},
	
	getArticleElement: function(id) {
		return this.addedRecords['article' + id];
	},
	
	getArticleIds: function() {
		var result = [];
		
		for (var i in this.addedRecords) {
			if (typeof i != 'string') 
				continue;
			
			if (i.indexOf('article') >= 0)
				result.push(parseInt(i.substr(7)));
		}
		
		return result;
	},
	
	getArticleTitles: function() {
		return this.titles;
	},
	getArticleParams: function() {
		var params = this.params;
		$$('.article_selector_span').each(function(ix){
			if(ix.getElement('input[type=text]'))
			params['article' + ix.getElement('input[type=hidden]').value] = ix.getElement('input[type=text]').value;
		});
		return params;
	},
	
	clear: function() {
		for (var i in this.addedRecords) {
			if (typeof i != 'string') 
				continue;
			
			this.addedRecords[ i ].remove();
			delete this.addedRecords[ i ];
			this.count--;
		}
	}
};
