<?php
/**
 * @fileID: $Id: commenter.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgJoomsuite_content_fieldsCommenter extends JPlugin
{

	function plgJoomsuite_content_fieldsCommenter(&$subject, $params)
	{
		parent::__construct($subject, $params);
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'commenter') return;
		$user = JFactory::getUser();
		///left allow choose in legacy compatability for previos version settings, basically this option is depreciated from XML and replaced to access level
		$allow_choose = $params->get('allow_choose', 23);
		$access = $params->get('access', 0);
		if(! JRequest::getInt('article')) $value = 1;
		else $value = $obj->field_value;
		if($user->aid >= $access || $user->gid >= $allow_choose)
		{
			echo JHTML::_('select.booleanlist', "fields[$obj->id]", '', $value);
		}
		else
			echo '<input type="hidden" name="fields[' . $obj->id . ']" value="' . $value . '">';
	
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'commenter') return;
		if(! $value) return;
		$db = &JFactory::getDBO();
		$value = $db->getEscaped(trim($value));
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if(! $field->field_value) return;
		if($field->type != 'commenter') return;
		

		$params = new JParameter($field->params);
		$iparams = ResHelper::initArticleParams($record->type_id);
		$user = $record->user_id;
		$type = $field->type;
		

		$article = $this->jsGetArticleByFieldValueID($field->id);
		$lastComment = $this->getLastComment($article, $comment_params);
		$default_value = $params->get('default_value');
		if(! $lastComment)
		{
			$out = $default_value == 'none' ? null : $default_value;
			return;
		}
		if($params->get('user_name_linkage') == 'none') $params->set('user_name_linkage', 0);
		
		if($lastComment->user_id && $params->get('user_name') != 'none')
		{
			$author = JFactory::getUser($lastComment->user_id);
			
			$name = $params->get('user_name') == 'name' ? $author->name : $author->username;
			
			if($params->get('user_name_linkage'))
			{
				require_once JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'library' . DS . 'php' . DS . 'community' . DS . RES_COMMUNITY;
				$classname = 'MRCommunity' . ucfirst(substr(RES_COMMUNITY, 0, - 4));
				$class = new $classname();
				
				if(MECommunityHelper::isEnabled() && $params->get('user_name_linkage'))
				{
					MECommunityHelper::loadApi();
					if($iparams->get('item_avatar')) $uparams['avatar'] = true;
					else $uparams['avatar'] = false;
					If($iparams->get('item_author') == 1) $uparams['name'] = $iparams->get('item_author_mode', 'username');
					$out = JSCommunityApi::getUserSlideMenu($author->get('id'), $name, array(), $uparams);
				}
				elseif(JComponentHelper::isEnabled(substr(RES_COMMUNITY, 0, - 4)) && $params->get('user_name_linkage'))
				{
					If(method_exists($class, 'userName') && $iparams->get('item_author_link') == 1 && $author->get('id'))
					{
						$out = $class->userName($author->get('id'), $name);
					}
				}
				else
				{
					$link = MERoute::_(MEUrl::link_list($category, array('user_id' => $author->get('id'), 'view_what' => 'created')));
					$out = JHTML::link($link, $name);
				}
			}
		}
		else if($params->get('user_name') != 'none')
		{
			$out = '<div class="commenter-name">' . htmlspecialchars($lastComment->name, ENT_QUOTES, 'UTF-8') . '</div>';
		}
		else
		{
			$out = null;
		}
		$last_data = new JDate($lastComment->ctime);
		if($params->get('show_date', 1)) $out .= '<span class="small">' . ' ' . JText::_('On') . '</span> <span class="createdate">' . $last_data->toFormat($comment_params->get('comment_time_format')) . '</span>';
		if($params->get('show_length', 0) > 0)
		{
			$comfreetag = strip_tags($lastComment->comment);
			$comstr = substr($comfreetag, 0, $params->get('show_length', 0));
			if(strlen($comfreetag) > strlen($comstr))
			{
				$check_det = $params->get('check_det', 0);
				if($check_det == 1)
				{
					$catid = JRequest::getInt('category_id');
					if($catid) $catid = '&amp;category_id=' . $catid;
					else $catid = null;
					$href = JRoute::_("index.php?option=com_resource&amp;controller=article&amp;article=" . $field->record_id . $catid);
					$comstr .= "<a alt='Check details' href='$href'>" . JText::_("Check details") . "</a>";
				}
				$comstr .= '...';
			}
			$out .= '<div class="small">' . $comstr . '</div>';
		}
	}

	function getLastComment($article, &$params)
	{
		$db = JFactory::getDBO();
		$user = & JFactory::getUser();
		$lang = & JFactory::getLanguage();
		
		//$params = ResHelper::initListParams( JRequest::getInt( 'category_id' ) );
		$params = ResHelper::initArticleParams($article->type_id, $article->params);
		//$params->merge($iparams);
		


		$where = '';
		if($user->get('usertype') != 'Super Administrator') $where .= ' AND published = 1 AND hide = 0';
		if($params->get('comments_lang_mode')) $where .= " AND lang = '" . $lang->getTag() . "' ";
		
		$where .= " AND `access` <= " . (int)$user->get('aid');
		
		$db->setQuery("SELECT * FROM #__js_res_comments WHERE record_id = $article->id $where ORDER BY ctime DESC LIMIT 0, 1");
		$comment = $db->loadObject();
		
		return $comment;
	}

	function jsGetArticleByFieldValueID($field_value_id)
	{
		$db = & JFactory::getDBO();
		
		$sql = "    SELECT r.*" . "\n      FROM #__js_res_record_values AS fv" . "\n LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id" . "\n     WHERE fv.id = " . $field_value_id;
		
		$db->setQuery($sql);
		return $db->loadObject();
	}

}