<?php
/**
 * @fileID: $Id: files.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );


jimport('joomla.plugin.plugin');

class plgJoomsuite_content_fieldsFiles extends JPlugin
{

    /**
     * The prefix added to filenames, when files are saved
     * @var string
     */
    var $prefix = 'files_';

    /**
     *
     * @var JS_Res_FancyUploaderHelper
     */
    var $helper = null;

    function plgJoomsuite_content_fieldsFiles( &$subject, $params )
    {
        parent::__construct( $subject, $params );

        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'uploader.php';
        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'jsfilemanager.php';
        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'file_helper.php';
        $this->helper = & JS_Res_FancyUploaderHelper::getInstance();
    }

    function onRenderField(&$obj, &$params, $type)
    {
        if($type != 'files') return;
        $session = & JFactory::getSession();
        $user = & JFactory::getUser();

        $recordId 	= JHTMLJsmedia_new::getRealRecordId($obj, $type);
        $url 		= JHTMLJsmedia_new::getUploadUrl($obj, $type, $recordId);

        $exts = $params->get('allowed_formats');
        $optExts = explode(', ', $exts);
        if (is_array($optExts))
            $optExts = array_unique($optExts);

        $data = @unserialize($obj->field_value);
        if (!isset($data['files']))
            $data['files'] = array();

        // Show old values on page, if the article was not submitted
        $default = JRequest::getVar('fields');
        if ($default && isset($default[$obj->id]))
        {
            $default = $default[$obj->id];
            $data = $default;
        }

        $uid 		= uniqid('media_');
        $debug 		= false; // debug javascript

        // The file list.
        $files = $data['files'];
        settype($files, 'array');


        $sort = $params->get('sort');
        switch ($sort)
        {
            case 1:
                sort($files);
                break;
            case 2:
                rsort($files);
                break;
        }

        $fileLimit = $params->get('files_limit', 0);
        if (!$fileLimit)
            $fileLimit = 909999;



        // Show the uploader
        if ($params->get('add_type') == 0)
        {
            $options = array(
                    'uploader' => $params->get('uploader', 'flash'),
                    'files' => $files,
                    'title' => 'Upload your files',
                    'url' => $url,
                    'limitSize' => $params->get('max') ? ((int)$params->get('max')) * 1024 : 'false',
                    'maxFiles' => $params->get('files_limit', 0),
                    'debug' => $debug, // optional
                    'backgroundColor' => '#FFFFFF',
                    'filters' => $optExts,
                    'uid' => $uid,
                    'fieldId' => $obj->id,
                    'recordId' => $recordId,
                    'processResponse' => false,
                    'limitFiles' => $params->get('number_of_files_in_uploader', 5), // the number of files in uploader
                    'pluginName' => 'files',
                    'pluginGroup' => 'joomsuite_content_fields'
            );

            echo '<br>' . JText::_ ( 'Allowed formats are' ) . ": $exts</span>";
            echo JHTMLJsmedia_new::getUploaderWithFilesTable($obj, $options);
        }
        // Show file directory list
        else if ($params->get('add_type') == 2)
        {
            $dir = JPath::clean(JPATH_ROOT.DS.$params->get('file_directory'));
            $directoryFiles = JFolder::files($dir, null, true, true);

            $dir = JPath::clean($dir.DS);

            $options = array ();
            $options[] = JHTML::_('select.option', '', '- '.JText::_('Select file').' -');
            foreach ($directoryFiles as $aFile)
            {
                $badFilter = true;
                foreach ($optExts as $filter)
                {
                    if (JString::strrpos($aFile, $filter) == JString::strlen($aFile) - JString::strlen($filter))
                    {
                        $badFilter = false;
                        break;
                    }
                }

                if ($badFilter)
                    continue;

                $aFile = str_replace($dir, '', $aFile);
                if (JString::strpos($aFile, DS) === 0)
                    $aFile = JString::substr($aFile, 1);

                $options[] = JHTML::_('select.option', $aFile, $aFile);
            }

            $controlId = 'select'.$uid;

            JHTML::_('behavior.mootools');

            // Get the widget manager :)
            $this->_echoWidgetManagerJavascript($files, $uid, $fileLimit, $controlId, $obj->id);

            echo '<div id="files_', $uid, '">';
            $i = 0;
            foreach ($files as $file)
            {
                echo '<div>';
                echo JHTML::_('select.genericlist',  $options, 'fields['.$obj->id.'][files][]', 'class="inputbox"', 'value', 'text', $file, $controlId.$i);
                echo '<a href="javascript:void(0)" onclick="wm', $uid, '.createSelect.bind(wm', $uid, ')($(\'files_', $uid, '\'), wm', $uid,');" alt="', JText::_('Add new'),'">', '[ + ]', '</a> ';

                if ( $i )
                    echo ' <a href="javascript:void(0)" onclick="wm', $uid, '.removeParentContainer.bind(wm', $uid,')(this);" alt="', JText::_('Remove'),'">', '[ – ]', '</a> ';
                echo '</div>';
                $i++;
            }

            // If there are no files
            if ( !$i )
            {
                echo JHTML::_('select.genericlist',  $options, 'fields['.$obj->id.'][files][]', 'class="inputbox"', 'value', 'text', null, $controlId.$i), ' ';
                echo '<a href="javascript:void(0)" onclick="wm', $uid, '.createSelect.bind(wm', $uid, ')($(\'files_', $uid, '\'), wm', $uid,');" alt="', JText::_('Add new'),'">', '[ + ]', '</a> ';
                '<br />';
                $i++;
            }
            echo '</div>';
            echo '<input type="hidden" name="fields[field_vid][', $obj->id, ']" value="', $obj->vid, '" />';
            echo '<input type="hidden" name="fields[field_id][', $obj->id, ']" value="', $obj->id, '" />';
        }

        else if ($params->get('add_type') == 3)
        {
            JHTML::_('behavior.mootools');

            $controlId = 'url'.$uid;

            // Get the widget manager :)
            $this->_echoWidgetManagerJavascript($files, $uid, $fileLimit, $controlId, $obj->id);

            $desc = array();

            if (isset($data['desc']))
            {
                $desc = $data['desc'];
                settype($desc, 'array');
            }

            reset($desc);

            echo '<div id="files_', $uid, '">';
            $i = 0;
            foreach ($files as $file)
            {

                $title = current($desc);
                if ($title === false)
                    $title = '';

                echo '<div>';
                echo JText::_('URL'), ': ';
                echo '<input type="text" size="40" name="fields[', $obj->id, '][files][]" class="inputbox" value="', htmlspecialchars($file, ENT_QUOTES, 'UTF-8'), '" id="', $controlId.$i, '" /> ';
                echo JText::_('Title').': ';
                echo '<input type="text" size="40" name="fields[', $obj->id, '][desc][]" class="inputbox" value="', htmlspecialchars($title, ENT_QUOTES, 'UTF-8'), '" id="', $controlId.$i, '" />';
                echo '<a href="javascript:void(0)" onclick="wm', $uid, '.createURLBox.bind(wm', $uid, ')($(\'files_', $uid, '\'), wm', $uid,');" alt="', JText::_('Add new'),'">', '[ + ]', '</a> ';
                if ( $i )
                    echo ' <a href="javascript:void(0)" onclick="wm', $uid, '.removeParentContainer.bind(wm', $uid,')(this);" alt="', JText::_('Remove'),'">', '[ – ]', '</a> ';
                echo '</div>';
                $i++;

                if ($title)
                    next($desc);
            }

            // If there are no files
            if ( !$i )
            {
                echo '<div>';
                echo JText::_('URL'), ': ';
                echo '<input type="text" size="40" name="fields[', $obj->id, '][files][]" class="inputbox" value="http://" id="', $controlId.$i, '" /> ';
                echo JText::_('Title').': ';
                echo '<input type="text" size="40" name="fields[', $obj->id, '][desc][]" class="inputbox" value="" id="', $controlId.$i, '" />';
                echo '<a href="javascript:void(0)" onclick="wm', $uid, '.createURLBox.bind(wm', $uid, ')($(\'files_', $uid, '\'), wm', $uid,');" alt="', JText::_('Add new'),'">', '[ + ]', '</a> ';
                '</div>';
                $i++;
            }
            echo '</div>';
        }


        // Extra field to track author change.
        echo '<input type="hidden" name="fields[author][', $obj->id, ']" value="', $this->helper->getAuthorIdByArticleId($obj->record_id), '" />';
    }

    function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
    {
        if($type != 'files') return;

        jimport ( 'joomla.filesystem.file' );
        jimport ( 'joomla.filesystem.folder' );

        require_once (JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_resource' . DS . 'controllers' . DS . 'config.php');
        ResControllerConfig::initialyze ();

        $fileManager = & JSFileManager::getInstance();

        $db = &JFactory::getDBO ();
        $sess = & JFactory::getSession();

        if (!isset($value['files']))
            $value['files'] = array();

        // If we have URL's here, just save them.
        if ($params->get('add_type') == 3)
        {
            $toSave = array();
            $toSave['files'] = array();

            for ($i = 0, $count = count($value['files']); $i < $count; $i++)
            {
                $url = JString::trim($value['files'][ $i ]);

                /// Do not save the default values in URL.
                if ($url == 'http://' || !$url)
                    continue;

                if (JString::strpos($url, 'http://') === false)
                    $url = 'http://'.$url;

                if (JString::strlen($url))
                {
                    $toSave['files'][] = $url;
                    $toSave['desc'][] = isset($value['desc'][ $i ]) ? $value['desc'][ $i ] : $url;
                }

            }

            $value = serialize($toSave);
            return;
        }

        // track author change
        $author = (isset($_REQUEST['fields']['author'][ $id ]) ? (int)$_REQUEST['fields']['author'][ $id ] : -1);

        $exts = explode(', ', $params->get('allowed_formats'));

        // If we have Directory listing, treat the files accordingly
        if ($params->get('add_type') == 2)
        {
            $field_id 	= isset($_REQUEST['fields']['field_id'][$id]) ? (int)$_REQUEST['fields']['field_id'][$id] : 0;
            $field_vid 	= isset($_REQUEST['fields']['field_vid'][$id]) ? (int)$_REQUEST['fields']['field_vid'][$id] : 0;

            // Track author change
            if ($author >= 0 &&  $author != $row->user_id)
            {
                // Update references
                $db->setQuery(
                        'UPDATE #__js_res_field_extra SET user_id = '.$row->user_id.' WHERE record_id = '.$row->id.' AND user_id = '.$author.
                        ' AND ref_id = "file" AND field_id = '.$field_id.' AND field_value_id = '.$field_vid
                );
                $db->query();
            }

            if (is_array($value['files']))
            {
                $value['files'] = array_unique($value['files']);
                $db->setQuery('DELETE FROM #__js_res_field_extra WHERE record_id = '.$row->id.' AND user_id = '.$row->user_id.' AND ref_id = "file"');
                $db->query(
                        'DELETE FROM #__js_res_field_extra WHERE record_id = '.$row->id.' AND user_id = '.$row->user_id.
                        ' AND ref_id = "file" AND field_id = '.$field_id.' AND field_value_id = '.$field_vid
                );
                $toSave = array();

                $basePath = JPath::clean(JPATH_ROOT.DS.$params->get('file_directory'));

                $fileIds = array();
                $count = 0;
                foreach ($value['files'] as $file)
                {
                    if (!$file)
                        continue;

                    if (!in_array(JFile::getExt($file), $exts))
                    {
                        JError::raiseWarning('FE_01', JText::_('Extension not allowed'). ' : '.JFile::getExt($file));
                        $error = true;
                        return;
                    }

                    $filename = JPath::clean($basePath.DS.$file);
                    JPath::check($filename);

                    if (JFile::exists($filename))
                    {
                        $toSave [] = $file;
                    }

                    $q = 'INSERT INTO #__js_res_field_extra (user_id, ref_id, ctime, ip, value, field_id, field_value_id, record_id) '.
                            'VALUES ('.$row->user_id.', "file", NOW(), '.$db->Quote($_SERVER['REMOTE_ADDR']).', '.$db->Quote($filename).', '.$field_id.', '.$field_vid.', '.$row->id.')';
                    $db->setQuery( $q );
                    $db->query();
                    $fileIds [] = $db->insertid();
                }

                unset($value['files']);
                if (count($toSave))
                    $value['files'] = $toSave;

                unset($value['file_ids']);
                if (count($fileIds))
                    $value['file_ids'] = $fileIds;

            }
            $value = serialize($value);
            return;
        }


        $error = false;
        $files = array();

        // Check, if the article was newly created
        $shamaned_prefix = $sess->get('new_article_prefix', $row->id, $type);
        $newlyCreated = ($shamaned_prefix != $row->id);


        if ($author >= 0 && $author != $row->user_id)
        {
            $fileManager->reassignFiles($value['files'], $row->id, $author, $row->user_id);
        }

        /**
         * The folders are created when uploading the files via flash uploader, so no need to create
         * them here.
         */

//		echo '<pre>';
//		var_dump($value['files'],$shamaned_prefix, $row->id, $row->user_id);
//		die;

        if (is_array($value['files']))
        {
            $toSave = array();
            // fix the names
            foreach ($value['files'] as $f)
            {
            	
                $f = basename( $f );
                $ext = JString::strtolower(JFile::getExt( $f ));
                if ($ext == 'jpeg')
                    $ext = 'jpg';

                if (!in_array($ext, $exts))
                {
                    $error = true;
                    JError::raiseWarning('EXT02', JText::_('Extension not allowed').' : '.$ext);
                    return;
                }


                $f = JFile::makeSafe(JFile::stripExt( $f ).'.'.$ext);

//                $res = $fileManager->storeFile($shamaned_prefix.'_'.$f, $row->id.'_'.$f, $row->user_id, '', true);
// Start $fileManager->storeFile replacement							
								if ($newlyCreated)
								{
										$destFolder = RES_GENERAL_UPLOAD.DS;
										if($params->get('sub_directory'))
											{
													$sub = $params->get('sub_directory');
													$sub - preg_replace('/\/$/iU', '', $sub);
													$sub - preg_replace('/^\//iU', '', $sub);
													$destFolder .= $sub.DS;
											}
										$destFolder .= $row->user_id.DS.$ext;
										if (JFile::exists($destFolder.DS.$shamaned_prefix.'_'.$f))
							          JFile::move($shamaned_prefix.'_'.$f, $row->id.'_'.$f, $destFolder);
								}
// End $fileManager->storeFile replacement							

                if ($res)
                    $toSave [] = JString::substr(basename($res), strlen($row->id.'_'));
                else
                {
                    $toSave[] = $f;
                }
            }

            unset($value['files']);
            // Prevent duplicate files
            if (count($toSave))
            {
                $value['files'] = array_unique($toSave);
            }
        }

//		$sess->clear('new_article_prefix', $type);

        $value = serialize( $value );
    }

    function onRenderFieldValue(&$out, &$field, &$record, $category)
    {
        if($field->type != 'files') return;
        if(!$field->field_value) return;

        $type = $field->type;


        $params = new JParameter($field->params);
        $user = $record->user_id;
        $data = unserialize($field->field_value);

        jimport ( 'joomla.filesystem.file' );
        jimport ( 'joomla.filesystem.folder' );

        require_once (JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_resource' . DS . 'controllers' . DS . 'config.php');
        ResControllerConfig::initialyze ();


        if (!isset($data['files']))
            return;
        ob_start();

        if($params->get('show_hits', 1))
            $hits = $this->jsGetHits($field->id, $field->record_id, $field->fid);

        $filesExist = false;

        switch ($params->get('sort'))
        {
            case 1:
                sort($data['files']);
                break;
            case 2:
                rsort($data['files']);
                break;
        }

        // Print the list of urls.
        if ($params->get('add_type') == 3)
        {
            if (count($data['files']))
            {
                echo '<table>';

                for ($i = 0, $count = count($data['files']); $i < $count; $i++)
                {
                    if ($data['files'][ $i ])
                        echo '<tr><td>', JHTML::link($data['files'][ $i ], isset($data['desc'][ $i ]) ? $data['desc'][ $i ] : JText::_('File')), '</td></tr>';
                }

                echo '</table>';

                $filesExist = true;
            }
        }
        else
        {
            echo '<table>';
            $count = 0;
            $error = false;

            // Fetch and configure file manager
            $fileManager = & JSFileManager::getInstance();

            foreach ($data['files'] as $file)
            {
                $ext = JFile::getExt($file);

                // For uploader
                if ($params->get('add_type') == 0)
                {

                    $fullPath = RES_GENERAL_UPLOAD.DS.$user.DS.JString::strtolower($ext).DS.$field->record_id.'_'.$file;
                    $download = $fileManager->getDownloadUrl($field->id, array('hash'=>md5($file)));
                }
                // For directory mode.
                else if ($params->get('add_type') == 2)
                {
                    $fullPath = JPath::clean(JPATH_ROOT.DS.$params->get('file_directory').DS.$file);

                    if (empty($data['file_ids'][$count]))
                    {
                        if (!$error)
                            JError::raiseWarning('', JText::_('Misconfiguration. Please resave the article'));
                        $error = true;
                    }
                    $fileId = (int)$data['file_ids'][$count++];

                    // In fact, here the $file param does not matter, since we use 'file_id' in our URL.
                    $download = JURI::root().$params->get('file_directory').DS.$file;
                }

                if(file_exists($fullPath))
                {
                    $filesExist = true;

                    if($params->get('show_name'))
                    {
                        $label = basename($file);
                    }
                    else
                    {
                        $label = JText::_('File');
                    }

                    echo '<tr><td>', JHTML::link($download, $label), '</td>';

                    $addition = array();

                    if($params->get('show_size'))
                    {
                        $addition[] = JText::_('Size').': '.$this->jsFormatSize(filesize($fullPath));
                    }
                    if($params->get('show_hits', 1))
                    {
                        $addition[] = JText::_('Hits').': '.(isset($hits[$file]) && isset($hits[$file]['hits']) ? $hits[$file]['hits'] : 0);
                    }
                    if($params->get('show_ctime'))
                    {
                        $date = & JFactory::getDate(filectime($fullPath));

                        $addition[] = JText::_('Created').': '.$date->toFormat('%d %b %Y');
                    }
                    if(count($addition) > 0) echo '<td><span class="small js_small">('.implode(" | ", $addition).')</span></td>';
                    echo '</tr>';
                }
            }
            echo '</table>';

        }

        $out = ob_get_contents();
        ob_end_clean();

        if (!$filesExist)
            $out = '';
    }

    function onXajaxDeleteFile(&$response, $filename, $recordId, $callback = false, $field_id = NULL)
    {
        jimport ('joomla.filesystem.file');

        $user 		= & JFactory::getUser();
        $session 	= & JFactory::getSession();
        $fileHelper     = & JSFileManager::getInstance();

        $userId	= null;
        // --  Check the record id --
        if (!is_numeric($recordId))
        {
            $shamaned_prefix = JFile::makeSafe($session->get('new_article_prefix', null, 'files'));
            if (!$shamaned_prefix || $shamaned_prefix != $recordId)
            {
                return false;
            }

            // the owner is current user
            $userId = $user->get('id');
        }
        else
        {
            $record = & JTable::getInstance('Record', 'Res');
            if (!$record->load($recordId))
            {
                return false;
            }

            $userId = $record->user_id;
        }


        // Check user rights to delete

        if ($userId != $user->get('id'))
        {
            if ($user->get('aid') < 2)
            {
                // don't have enough rights to delete
                return false;
            }
        }


        // Now delete the files:
        // Here, we delete all the files, and thumbnails, if they exist :)
        $filename 	= JFile::makeSafe($filename);
        $ext 		= JFile::getExt($filename);
        
		$base = RES_GENERAL_UPLOAD.DS;
        
		if($field_id)
		{
    		$field = & JTable::getInstance('Field', 'Table');
    		$field->set('id', $field_id);
            $field->load();
    		$params = new JParameter($field->params);
    		
            if($params->get('sub_directory'))
    		{
    		    $sub = $params->get('sub_directory');
    		    $sub = preg_replace('/\/$/iU', '', $sub);
    		    $sub = preg_replace('/^\//iU', '', $sub);
    		    $base .= $sub.DS;
    		}
		}
        $base .= $userId.DS.$ext;
        $base = JPath::clean($base);
        
        // Here we deal with newly uploaded file, that has no thumbnails generated,
        // so I can simply delete it ;)
        $file = JPath::clean($base.DS.$recordId.'_'.$filename);

        if (!JFile::delete($file))
        {
            // Failed deleting file: exit
            if ($callback)
                $response->script($callback.'(false)');

            return false;
        }
        // Update only existing record with file list ... 
        if (is_numeric($recordId))
        {
 					$db = & JFactory::getDBO();
	  			$q = "SELECT field_value FROM #__js_res_record_values ".
	 	 			     "WHERE field_id = $field_id AND record_id = $recordId"; 
				  $db->setQuery( $q );
 					$value = unserialize($db->loadResult());
 					$array2['files'][] = $filename;
 		 			$value['files'] = array_diff($value['files'], $array2['files']);
 					$q = "UPDATE #__js_res_record_values SET field_value = '".serialize($value).
				 			 "' WHERE field_id = $field_id AND record_id = $recordId";
  				$db->setQuery( $q );
 					$db->query();
  			}
 
 

        if ($callback)
            $response->script($callback.'(true)');

        return true;
    }

    /**
     * Track the author article change to move files
     * @param $records
     * @param $newAuthor
     * @return unknown_type
     */
    function onArticleAuthorChange(&$records, $newAuthor)
    {

        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'file_helper.php';

        $fileHelper = JS_File_Helper::getInstance();

        $fileHelper->reassignFilesNew($records, $newAuthor, 'files');
    }

    /**
     * Cleanup the thumbs, etc.
     * @param $recordIds
     * @return void
     */
    function onDeleteRecords($recordIds)
    {
        jimport ('joomla.filesystem.file');

        require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
        ResControllerConfig::initialyze();

        $db = & JFactory::getDBO();

        $q = 'SELECT r.id AS record_id, f.params, rv.field_value, r.user_id FROM '.
                '#__js_res_record r '.
                'LEFT OUTER JOIN #__js_res_record_values rv ON r.id = rv.record_id '.
                'LEFT OUTER JOIN #__js_res_fields f ON rv.field_id = f.id '.
                'WHERE '.
                'r.id IN ('.implode(' , ', $recordIds).') AND f.type = "files"';

        $db->setQuery( $q );
        $fields = $db->loadObjectList();

        foreach ($fields as $field)
        {
            if (empty($field->user_id) || empty($field->record_id))
                continue;

            $params = new JParameter($field->params);
            /*
			  	0 = Upload
				2 = Directory
				3 URL
            */
            $type = $params->get('add_type');

            // We delete files uploaded by the Uploader only
            if ($type != 0)
                continue;

            $fValue = @unserialize($field->field_value);
            $files = isset($fValue['files']) ? $fValue['files'] : array();


            $baseDir = JPath::clean(RES_GENERAL_UPLOAD.DS.$field->user_id);

            /// Delete the files
            foreach ($files as $file)
            {
                if (empty($file))
                    continue;

                $file = JFile::makeSafe($file);
                $ext = JFile::getExt($file);

                $file = $baseDir.DS.$ext.DS.$field->record_id.'_'.$file;
                if (JFile::exists($file))
                {
                    JFile::delete($file);
                }
            }
        }
    }

    function _echoWidgetManagerJavascript(&$files, $uid, $fileLimit, $controlId, $id)
    {

        $document = & JFactory::getDocument();
        $document->addScript(JURI::root().'plugins/joomsuite_content_fields/html/widgetmanager.js');
        ob_start();
        ?>
		var wm<?php echo $uid; ?> = null;

		Window.onDomReady(function() {
			wm<?php echo $uid; ?> = new WidgetManager();

			wm<?php echo $uid; ?>.maxItems = <?php echo $fileLimit; ?>;
			wm<?php echo $uid; ?>.curNumItems = <?php echo count($files); ?>;

			var select = $('<?php echo $controlId; ?>0');
			if (select)
				wm<?php echo $uid; ?>.options = select.options;
			wm<?php echo $uid; ?>.name = 'fields[<?php echo $id; ?>][files][]';
			wm<?php echo $uid; ?>.desc = 'fields[<?php echo $id; ?>][desc][]';

			wm<?php echo $uid; ?>.texts = {
				addNew: '<?php echo addslashes(JText::_('Add new')); ?>',
				URL: '<?php echo addslashes(JText::_('URL')); ?>',
				title: '<?php echo addslashes(JText::_('Title')); ?>'
			};
		});
        <?php
        $document->addScriptDeclaration(ob_get_clean());
    }

    /**
     *
     * @param $ids The
     * @param $recordId
     * @param $fieldId
     * @return array
     */
    function jsGetHits($fieldValueId, $recordId, $fieldId)
    {
        $recordId = (int)$recordId;
        $fieldId = (int)$fieldId;
        $fieldValueId = (int)$fieldValueId;

        $db = &JFactory::getDBO();

        $sql = "SELECT ref_id, COUNT(*) AS hits FROM #__js_res_field_extra WHERE record_id = $recordId AND field_id = $fieldId AND field_value_id = $fieldValueId GROUP BY ref_id";

        $db->setQuery($sql);
        //var_dump($db->getQuery());exit;
        return $db->loadAssocList('ref_id');
    }

    function jsFormatSize($size)
    {
        $kb = 1024;
        $mgb = $kb * 1024;
        $gb  = $mgb * 1024;
        $trb = $gb * 1024;

        if($size > $trb)
        {
            return number_format($size / $trb, 2, ',', ' ')." Tb";
        }
        elseif($size > $gb)
        {
            return number_format($size / $gb, 1, ',', ' ')." Gb";
        }
        elseif($size > $mgb)
        {
            return number_format($size / $mgb, 0, ',', ' ')." Mb";
        }
        elseif($size > $kb)
        {
            return number_format($size / $kb, 0, ',', ' ')." Kb";
        }
        else
        {
            return $size." B";
        }
    }

    function onDownloadFile($field, $recordValue)
    {
        if($field->type != 'files')
        {
            return;
        }
        $user = &JFactory::getUser();
        $pathData = new stdClass();
        $fileHelper = &JS_File_Helper::getInstance();
        $fileManager = &JSFileManager::getInstance();
        $params = new JParameter($field->params);

        $files = @unserialize($recordValue->field_value);
        $file = '';
        foreach($files['files'] as $f)
        {

            if(md5($f) == JRequest::getVar('hash'))
            {
                $file = $f;
                break;
            }
        }

        $ext = JFile::getExt($file);
        if($fileHelper->checkSubscription($field->params))
        {
            if ($params->get('add_type') == 0)
            {
                $destFolder = RES_GENERAL_UPLOAD.DS;
    			if($params->get('sub_directory'))
    			{
    			    $sub = $params->get('sub_directory');
    			    $sub = preg_replace('/\/$/iU', '', $sub);
    			    $sub = preg_replace('/^\//iU', '', $sub);
    			    $destFolder .= $sub.DS;
    			}
    			$destFolder .= $field->user_id.DS.JString::strtolower($ext);
			    //$dir = RES_GENERAL_UPLOAD.DS.$field->user_id.DS.JString::strtolower($ext);
                $pathData->path = $destFolder.DS.$field->record_id.'_'.$file;
            }
            if($params->get('add_type') == 2)
            {
                $dir = JPath::clean(JPATH_ROOT.DS.$params->get('file_directory'));
                $pathData->path = $dir.DS.$file;
            }
			$pathData->filename = $file;
            $fileHelper->modifyUsersCarma($field->params, $field->user_id, $user->get('id'));
        }
        else 
        {
        	$pathData->error =JText::_("The file is under subscription");
        	$pathData->path = null;
        }
        

        return $pathData;

    }
}
