<?php
/**
 * @fileID: $Id: gallery2.php 7590 2011-12-05 10:20:35Z kostya $
 * @changedDate: $LastChangedDate: 2011-12-05 17:20:35 +0700 (Пн, 05 дек 2011) $
 * @changedBy: $LastChangedBy: kostya $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );


jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsGallery2 extends JPlugin
{
    var $video;
    var $pics;

    var $helper = null;

    function plgJoomsuite_content_fieldsGallery2( &$subject, $params )
    {
        parent::__construct( $subject, $params );

        $this->video = array('avi', 'mp4', 'flv', 'mov', 'mpg3');
        $this->pics = array('jpeg', 'jpg', 'png', 'gif', 'bmp');

        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'uploader.php';
        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'jsfilemanager.php';
        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'file_helper.php';
        $this->helper = & JS_Res_FancyUploaderHelper::getInstance();
    }

    function onRenderField(&$obj, &$params, $type)
    {
        if($type != 'gallery2')
            return;

        $session = & JFactory::getSession();
        $user = & JFactory::getUser();

        $recordId 	= JHTMLJsmedia_new::getRealRecordId($obj, $type);
        $url 		= JHTMLJsmedia_new::getUploadUrl($obj, $type, $recordId);

        $exts = '';
        if ($params->get('allow_pics', 1))
        {
            $exts .= implode(', ', $this->pics);
        }
        if ($params->get('allow_video', 1))
        {
            if (strlen($exts))
                $exts .= ', ';
            $exts .= implode(', ', $this->video);
        }

        $optExts = explode(', ', $exts);
        $optExts = array_unique($optExts);
        sort($optExts);

        $data = @unserialize($obj->field_value);
        if (!isset($data['files']))
            @$data['files'] = array();

        // Show old values on page, if the article was not submitted
        $default = JRequest::getVar('fields');
        if ($default && isset($default[$obj->id]))
        {
            $default = $default[$obj->id];
            $data = $default;
        }

        $uid 		= uniqid('media_');
        $debug 		= false; // debug javascript

        if (!isset($data['files']) || !is_array($data['files']))
            @$data['files'] = array();

        if(count($data['files']) && !isset($data['files']['name'])){
        	$tmp = $data['files'];
        	$data['files'] = array('name' => $tmp);
        }
        // The file list.
        $files = $data['files'];

        $options = array(
                'uploader' => $params->get('uploader', ''),
                'title' => 'Upload your files',
                'files' => $files,
                'url' => $url,
                'limitSize' => $params->get('max') ? ((int)$params->get('max')) * 1024 : 'false',
                'maxFiles' => $params->get('piclimit', 0),
                'debug' => $debug, // optional
                'backgroundColor' => '#FFFFFF',
                'filters' => $optExts,
                'uid' => $uid,
                'fieldId' => $obj->id,
                'recordId' => $recordId,
                'processResponse' => false,
                'limitFiles' => $params->get('number_of_files_in_uploader', 5),
                'pluginName' => 'gallery2',
                'pluginGroup' => 'joomsuite_content_fields'
        );

        echo '<br>' . JText::_ ( 'Allowed formats are' ) . ": $exts</span>";
        echo JHTMLJsmedia_new::getUploaderWithFilesAndTitleTable($obj, $options);

        // Extra field to track author change.
        echo '<input type="hidden" name="fields[author][', $obj->id, ']" value="', $this->helper->getAuthorIdByArticleId($obj->record_id), '" />';
    }

    function onBeforeSave(&$value, &$params, $type, $field_id, $row, &$error)
    {
        if($type != 'gallery2') return;
        $sess = &JFactory::getSession();
        //print_r($_POST['fields']['author'][$field_id]); exit;
        $db     = &JFactory::getDBO();

        $exts 	= array('gif', 'png', 'jpg', 'jpeg', 'bmp');

        jimport('joomla.filesystem.file');
        jimport('joomla.filesystem.folder');
//        $this->moveFilesFromOldToNew();


        $fileManager = & JSFileManager::getInstance();


        $files = isset($value['files']) ? $value['files'] : array();

        // Check, if the article was newly created
        $shamaned_prefix = JFile::makeSafe($sess->get('new_article_prefix', $row->id, $type));
        $newlyCreated = ($shamaned_prefix != $row->id);

        $shamaned_prefix .= '_';

        // track author change
        $auth = $_POST['fields']['author'][$field_id];
        $author = isset($auth) ? $auth : -1;
        if ($author >= 0 && $author != $row->user_id)
        {
            $this->_cleanUpThumbs($files['name'], $row->id, $author);
            $fileManager->reassignFiles($files['name'], $row->id, $author, $row->user_id);
        }

        //--------------------------------------------------------------------------
        $toSave = array();

        $exts = array();
        if ($params->get('allow_pics', 1))
            $exts = $this->pics;
        if ($params->get('allow_video', 1))
        {
            $exts = array_merge($exts, $this->video);
        }

        if (is_array($files['name']))
        {
            foreach($files['name'] as $key => $f)
            {
                $f = basename( $f );
                $ext = JString::strtolower(JFile::getExt( $f ));
                if ($ext == 'jpeg')
                    $ext = 'jpg';

                if (!in_array($ext, $exts))
                {
                    $error = true;
                    JError::raiseWarning(300, JText::_('Extension not allowed').' : '.$ext);
                    return;
                }

                $f = JFile::makeSafe(JFile::stripExt( $f ).'.'.$ext);

                $res = $fileManager->storeFile($shamaned_prefix.$f, $row->id.'_'.$f, $row->user_id);

                if ($res)
                    $toSave['name'][] = JString::substr(basename($res), strlen($row->id.'_'));
                else
                {
                    $toSave['name'][] = $f;
                }
                $toSave['title'][] = htmlspecialchars($files['title'][$key]);
            }
            $this->prepareThumbs($toSave, $row->id, $params, $row->user_id);
        }

        $value['files'] = $toSave;
        $value = serialize($value);
    }

    function onXajaxDeleteFile(&$response, $filename, $recordId, $callback = false, $field_id = NULL)
    {
//        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'file_helper.php';
        jimport ('joomla.filesystem.file');

        $user 		= & JFactory::getUser();
        $session 	= & JFactory::getSession();
        $fileHelper     = & JSFileManager::getInstance();

        $userId	= null;
        // --  Check the record id --
        if (!is_numeric($recordId))
        {
            $shamaned_prefix = JFile::makeSafe($session->get('new_article_prefix', null, 'gallery2'));
            if (!$shamaned_prefix || $shamaned_prefix != $recordId)
            {
                return false;
            }

            // the owner is current user
            $userId = $user->get('id');
        }
        else
        {
            $record = & JTable::getInstance('Record', 'Res');
            if (!$record->load($recordId))
            {
                return false;
            }

            $userId = $record->user_id;
        }


        // Check user rights to delete

        if ($userId != $user->get('id'))
        {
            if ($user->get('aid') < 2)
            {
                // don't have enough rights to delete
                return false;
            }
        }

        // Now delete the files:
        // Here, we delete all the files, and thumbnails, if they exist :)
        $filename 	= JFile::makeSafe($filename);
        $ext 		= JFile::getExt($filename);
        $base 		= JPath::clean(RES_GENERAL_UPLOAD.DS.$userId.DS.$ext);

        if (is_numeric($recordId))
        {
            // If the record id is numeric, it means we need to delete the thumbnails too
            $patterns = array(
                    $base.DS.$recordId.'_*'.$filename,
                    $base.DS.'gallery'.DS.'thumbnail_big'.DS.$recordId.'_*'.$filename,
                    $base.DS.'gallery'.DS.'thumbnail_small'.DS.$recordId.'_*'.$filename
            );

            foreach ($patterns as $globPattern)
            {
                foreach (glob($globPattern) as $file)
                {
                    if (!JFile::delete($file))
                    {
                        // Failed deleting file: exit
                        if ($callback)
                            $response->script($callback.'(false)');

                        return false;
                    }
                }
            }
        }
        else
        {
            // Here we deal with newly uploaded file, that has no thumbnails generated,
            // so I can simply delete it ;)
            $file = JPath::clean($base.DS.$recordId.'_'.$filename);
            if (!JFile::delete($file))
            {
                // Failed deleting file: exit
                if ($callback)
                    $response->script($callback.'(false)');

                return false;
            }
        }


        if ($callback)
            $response->script($callback.'(true)');

        return true;
    }



    function onArticleAuthorChange(&$records, $newAuthor)
    {

//        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'file_helper.php';

        $fileHelper = & JS_File_Helper::getInstance();
        $fileHelper->reassignFilesNew($records, $newAuthor, 'gallery2');
    }

    function onRenderFieldValue(&$out, &$field, &$record, $category)
    {
    	global $Itemid;
    	
        if ($field->type != 'gallery2')
            return;
        if (!$field->field_value)
            return;

        $aparams = ResHelper::initArticleParams($record->type_id);
        $item_id = $aparams->get('item_itemid', $Itemid);
        
        $params = new JParameter($field->params);
        $user = $record->user_id;
        $type = $field->type;



        $folder = RES_GENERAL_UPLOAD;
        $folder = str_replace(array(JPATH_ROOT.DS, str_replace('\\', '/',JPATH_ROOT.DS)),'', $folder);
        $folder = str_replace('\\','/', $folder);

        // The files.
        $data = unserialize($field->field_value);
        if (!isset($data['files']) || !count($data['files']))
            return;

        $skin = $params->get('skin', array('yui'));
        $skin = $skin[ 0 ];

        if (!is_array($data['files']))
            $data['files'] = array($data['files']);
            
	    if(!isset($data['files']['name'])){
			$data['files']['name'] = $data['files']; 
		}

        // Take care about thumbs:
        $this->prepareThumbs($data['files'], $field->record_id, $params, $user);

        $fileManager = & JSFileManager::getInstance();

        if ($useShadowbox = $params->get('use_shadowbox', 1))
        {
            $document = & JFactory::getDocument();
            $document->addScript(JURI::root().'media/mightyextensions/js/shadowbox/build/adapter/shadowbox-base.js');
            $document->addScript(JURI::root().'media/mightyextensions/js/shadowbox/build/shadowbox.js');
            $document->addStyleDeclaration('#shadowbox_title {border: 0px solid;}#shadowbox_info {border: 0px solid;}');
        }

        // ----- Blog Thumbnail -----
        if ( !JRequest::getInt('article') && $params->get('bresize') )
        {

            $images = array();
            foreach ($data['files']['name'] as $key => $file)
            {
                $ext = explode('.', $file);
                $iext = $ext[count($ext)-1];
                if (in_array($iext, $this->pics))
                    $images[] = $file;
            }
            $thmb_mode = $params->get('thmb_mode', 'first');
            if ($thmb_mode == 'first')
                $ipicture = @$images[0];
            else if ($thmb_mode == 'rand')
                $ipicture = @$images[array_rand($images)];
            
            $thumb =$this->_getBlogThumbUrl(
                    $ipicture,
                    $user, $field->record_id, $field->id,
                    $params->get('bwidth', 		120),
                    $params->get('bheight', 	120),
                    $params->get('bquality', 	100),
                    $params->get('border'),
			$params->get('crop_type', 'keep')
            );
            if (!empty($data['files']['name'][ 0 ]) && $fileManager->getFileType($data['files']['name'][ 0 ]) == 'image')
            {
                $out = JHTML::image($thumb, $ipicture);
                switch ($params->get('thumb_behavior', '0'))
                {
                    case 'link':
                        $catid = JRequest::getInt('category_id');
                        if ($catid) 
                        	$catid = '&amp;category_id='.$catid;
                        else 
                        	$catid = null;
                        
                        $linkbegin = '<a title="'.JText::_('View More').'" href="'.MERoute::_('index.php?option=com_resource&controller=article&article='.$field->record_id.$catid.'&Itemid='.$item_id).'">';
                        $out = $linkbegin.$out.'</a>';
                        break;
                }
            }
            return;
        }

        // Load the article.
        JModel::addIncludePath(JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'models');
        $articleModel = & JModel::getInstance('Article', 'ResModel');
        $articleModel->setId($field->record_id);

        $article = $articleModel->getRecord();

        // Start buffering.
        ob_start();

        if (JFile::exists(JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'gallery2'.DS.$skin.'.php'))
            include JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'gallery2'.DS.$skin.'.php';
        else
            JError::raiseError('G1', JText::_('Cannot find skin: '.$skin));

        $out = ob_get_contents();
        ob_end_clean();
    }

    /**
     * Cleanup the thumbs, etc.
     * @param $recordIds
     * @return unknown_type
     */
    function onDeleteRecords($recordIds)
    {
        jimport ('joomla.filesystem.file');

        require_once (JPATH_ROOT.DS.'administrator'.DS.'components'.DS.'com_resource'.DS.'controllers'.DS.'config.php');
        ResControllerConfig::initialyze();

        $db = & JFactory::getDBO();

        $q = 'SELECT r.id AS record_id, rv.field_value, r.user_id FROM '.
                '#__js_res_record r '.
                'LEFT OUTER JOIN #__js_res_record_values rv ON r.id = rv.record_id '.
                'LEFT OUTER JOIN #__js_res_fields f ON rv.field_id = f.id '.
                'WHERE '.
                'r.id IN ('.implode(' , ',$recordIds).') AND f.type = "gallery2"';

        $db->setQuery( $q );
        $gals = $db->loadObjectList();

        foreach ($gals as $gal)
        {
            if (empty($gal->user_id) || empty($gal->record_id))
                continue;

            $fValue = @unserialize($gal->field_value);
            $files = isset($fValue['files']) ? $fValue['files'] : array();


            $baseDir = JPath::clean(RES_GENERAL_UPLOAD.DS.$gal->user_id);

            /// Delete the pictures.
            foreach ($files as $file)
            {
                if (empty($file))
                    continue;

                $ext = JFile::getExt($file);

                $file = $baseDir.DS.$ext.DS.$gal->record_id.'_'.$file;
                if (JFile::exists($file))
                {
                    JFile::delete($file);
                }
            }

            foreach ($recordIds as $recordId)
            {
                $this->_cleanUpThumbs($files, $recordId, $gal->user_id);
            }
        }
    }

    function imageResize($infile, $outfile, $max_width, $max_height, $quality, $watermark = false, $crop_type = "keep")
    {
        global $mainframe;
        jimport('joomla.filesystem.file');
        jimport('joomla.filesystem.folder');
        
        $infile 	= JPath::clean($infile);
        $outfile 	= JPath::clean($outfile);

        // The extension of the resized image file.
        $extension = JString::strtolower(JFile::getExt($infile));

        // output folder
        $outFolder = dirname($outfile);

        if (!JFolder::exists($outFolder))
        {
            if (!JFolder::create($outFolder, 0755))
            {
                JError::raiseWarning(403, JText::_("Cannot Create Folder resizing picture, Please, check upload
    				directory is correct and accessible"));
                return false;
            }
        }

        if(!JFile::exists($infile))
        {
            JError::raiseWarning('N12343', JText::_("Resize error: File does not exist").' '.basename($infile));
            return false;
        }

        $size = getimagesize($infile);

        switch($extension)
        {
            case "gif":
                $img = imagecreatefromgif($infile);
                break;
            case "png":
                $img = imagecreatefrompng($infile);
                break;
            case "pjpeg":
            case "bmp":
            case "jpeg":
            case "jpg":
                $img = imagecreatefromjpeg($infile);
                break;
        }
        if(!$img)
        {
            JError::raiseWarning(240, JText::_('Cannot create image: '.basename($infile)));
            return ;
        }

        if (@$watermark[0])
        {
            $watermarkFile = JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'images'.DS.'watermarks'.DS.$watermark[0];

            if (JFile::exists($watermarkFile))
            {
                require_once JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'lib'.DS.'watermark.php';


                $watermarker = new JS_Watermark($watermarkFile, $watermark[2], $watermark[1]);

                $temp = $watermarker->createWatermarkForResource($img);
                if (!$temp)
                {
                    JError::raiseWarning(432, JText::_('Cannot create watermark'));
                }
                else
                    $img = $temp;
            }
        }

		if ($crop_type == "crop")
		{
			$rwidth = (int) (($size[0] * $max_height)/$size[1] );
			$rheight = (int) (($size[1]  * $max_width)/$size[0] );
			$xofs = 0;
			$yofs = 0;
			if($rwidth > $max_width)
			{
				$rheight = $max_height;
				$xofs = round($max_width - $rwidth);
			}
			elseif ($rheight > $max_height)
			{
				$rwidth = $max_width;
				$yofs = round($max_height - $rheight);
			}
			elseif ($rheight < $max_height && $rwidth == $max_width)
			{
				$rwidth_b = ($max_height * $rwidth)/$rheight;
				$xofs = round($rwidth - $rwidth_b);
				$rwidth = (int) $rwidth_b;
				$rheight = $max_height;
			}
			elseif ($rheight == $max_height && $rwidth < $max_width)
			{
				$rheight_b = ($max_width * $rheight)/$rwidth;
				$yofs = round($rheight - $rheight_b);
				$rheight = (int) $rheight_b;
				$rwidth = $max_width;
			}
			elseif($rheight == $max_height && $rwidth == $max_width)
			{
				//bingo!!!
				$rheight = $max_height;
				$rwidth = $max_width;          
			}
			$xofs == -1? null:$xofs = $xofs/2;
			$yofs == -1? null:$yofs = $yofs/2;

			$mini  = imagecreatetruecolor($max_width, $max_height);
			$white = imagecolorallocate  ($mini,255,255,255);

			imagefilledrectangle($mini,			0,0,	$rwidth,$rheight,		$white);
			imagecopyresampled ($mini,$img,	$xofs,$yofs,	0,0, 				$rwidth, $rheight, 	$size[0],$size[1]);
		}
		else
		{
			if(($size[0] > $max_width) && ($size[0] > $size[1]))
			{
				$width  = $max_width;
				$k = $size[0] / $max_width;
				$height = ($size[1] / $k);
			}
			else
			{
				$width  = $size[0];
				$height = $size[1];
			} 
			
			if($height > $max_height)
			{
				$k = $height / $max_height;
				$height = $max_height;
				$width = ($width / $k);
			}

			
			$width  = round($width);
			$height = round($height);
			
			$mini  = imagecreatetruecolor($width, $height);
			$white = imagecolorallocate  ($mini,255,255,255);

			imagefilledrectangle($mini,			0,0,	$width,$height,		$white);
			imagecopyresampled	($mini,$img,	0,0,	0,0,				$width,$height,		$size[0],$size[1]);
		}

        // Huh, we have a border here ;)
        if ($watermark && !is_array($watermark))
        {
            $border = JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'borders'.DS.$watermark;

            if (JFile::exists($border))
            {
                $borderGD =  @imagecreatefrompng($border);
                if ($borderGD)
                {
			if ($crop_type == "crop") { $width = $rwidth; $height = $rheight; }
                    @imagecopyresampled ( $mini, $borderGD, 0,0,0,0, $width, $height, imagesx($borderGD), imagesy($borderGD));
                }
            }
        }

        $tmpFile = JPATH_CACHE.DS.uniqid('resize');
        @imagejpeg($mini, $tmpFile, $quality);
        JFile::copy($tmpFile, $outfile);
        JFile::delete($tmpFile);

        @chmod($outfile, 0644);

        imagedestroy($mini);
        imagedestroy($img);
    }

    function getFiles($files, $url, $record_id, $params, $userId, $fieldValueId = 0)
    {

        $fileManager = JSFileManager::getInstance();
        $ret = array();
        if(!isset($files['name'])){
        	$files['name'] = $files;
        }
        
        foreach ($files['name'] as $key => $f)
        {
            if (empty ($f))
            {
                continue;
            }

            $ext = JString::strtolower(JFile::getExt( $f ));
            if ($ext == 'jpeg')
                $ext = 'jpg';

            $f = JFile::makeSafe(JFile::stripExt( $f ).'.'.$ext);

            $video = false;
            $player = 'img';


            if (in_array($ext, $this->video))
            {
                $video = 'plugins/joomsuite_content_fields/images/gallery/video.png';

                // the player
                $player = 'flv';
                if (in_array($ext, array("dv", "mov", "moov", "movie", "mp4")))
                    $player = 'qt';

                if (in_array($ext, array("swf")))
                    $player = 'swf';

                if (in_array($ext, array("avi", "mpg", "mpeg")))
                    $player = 'wmp';

                if (in_array($ext, array("asf", "wm", "wmv")))
                    $player = 'wmp';

                if ($ext == 'mp4' || $ext == 'flv' || $ext == 'mp3')
                    $player = 'flv';

            }

            $item = new stdClass;
            $item->name = $f;
            if(isset($files['title']))
            	$item->title = $files['title'][$key];
            else
            	$item->title = JText::_('Untitled');

            // The watermarked image prefix
            $prefixThumb = '';
            $prefixImage = '';
            $prefixOriginal = '';
            $watermarkParams = $params->get('watermark');

            $putWatermark = @$watermarkParams[0] && @$watermarkParams[0] != -1;

            if ($putWatermark)
            {
                if ($params->get('watermark_thumb'))
                    $prefixThumb = 'w_'.$watermarkParams[1].'_'.$watermarkParams[2];

                if ($params->get('watermark_image'))
                    $prefixImage = 'w_'.$watermarkParams[1].'_'.$watermarkParams[2];

                if ($params->get('watermark_original'))
                    $prefixOriginal = 'w_'.$watermarkParams[1].'_'.$watermarkParams[2];
            }

            if ($video)
            {
                $item->thumb 		= $video;
                $item->bigthumb 	= $video;
                // Set URL generation vars for video
                $item->d_original 	= JURI::root().$fileManager->getDownloadUrl($fieldValueId, array('hash'=>md5($f)), false);
                

                $item->original 	= JURI::root().$fileManager->getDownloadUrl($fieldValueId, array('hash'=>md5($f)), false);
                $item->player 		= $player;

                // set prev. values

            }
            else
            {
                $thumbMeta =@getimagesize($fileManager->getPath($record_id.'_'.$prefixThumb.$params->get('thumb_width', 120).'_'.$params->get('thumb_height', 120).'_'.$f, $userId, 'gallery'.DS.'thumbnail_small'));
                $thumbBigMeta = @getimagesize($fileManager->getPath($record_id.'_'.$prefixImage.$params->get('max_width', 400).'_'.$params->get('max_height', 400).'_'.$f, $userId,'gallery'.DS.'thumbnail_big'));
                $item->thumb 		= JURI::root().$fileManager->getDownloadUrl( $fieldValueId, array('hash'=>md5($f), 'type'=>'thumbnail_small'), false);
                $item->bigthumb 	= JURI::root().$fileManager->getDownloadUrl($fieldValueId, array('hash'=>md5($f), 'type'=>'thumbnail_big'), false);
                if ($putWatermark && $params->get('watermark_original'))
                    $item->original 	= JURI::root().$fileManager->getDownloadUrl($fieldValueId, array('type'=>'watermark', 'hash'=>md5($f)),false );//'gallery/'.$record_id.'_'.$prefixOriginal.$f
                else
                    $item->original 	= JURI::root().$fileManager->getDownloadUrl($fieldValueId, array('hash'=>md5($f)), false);

                $item->player 		= $player;
                $item->thumbSize = $thumbMeta;
                $item->thumbBigSize = $thumbBigMeta;
            }

            $ret[] = $item;
        }

        return $ret;
    }

    /**
     *
     * @param $files
     * @param $url
     * @param $record_id
     * @param $params
     * @param $ownerId
     * @return string javascript representation of given playlist
     */
    function playlist_to_object($files, $url, $record_id, &$params, $ownerId, $fieldValueId)
    {
        $files = $this->getFiles($files, $url, $record_id, $params, $ownerId, $fieldValueId);

        foreach ($files as $f)
        {
            if (empty ($f))
                continue;

            $ext = JString::strtolower(JFile::getExt( $f->name ));
            if ($ext == 'jpeg')
                $ext = 'jpg';

            $video = false;
            $player = 'img';
            if ($f->player == 'video')
            {
                $video = JURI::root().'plugins/joomsuite_content_fields/images/gallery/video.png';
            }

            if ($video)
            {
                $ret[] = '{thumb: "'.$video.'", '.
                        'bigthumb: "'.$video.'", '.
                        'original: "'.rawurlencode($r->original).'", '.
                        'player: "'.$f->player.'", '.
                		'title: "'.$f->title.'", '.
                        'options:{'.
                        'flashVars: {type: "video"}'.
                        '} '.
                        '}';
            }
            else
            {
                $ret[] = '{thumb: "'.$f->thumb.'", '.
                        'bigthumb: "'.$f->bigthumb.'", '.
                        'original: "'.$f->original.'", '.
                        'player: "'.$f->player.'", '.
                		'title: "'.$f->title.'", '.
                        'options: {}}';
            }
        }

        return '['.implode(',', $ret).']';
    }

    function prepareThumbs($files, $recordId, &$params, $userId)
    {
        $recordId 	= (int)$recordId;
        $userId 	= (int)$userId;
        settype($files, 'array');

        $debug = false;

       	if(!isset($files['name'])){
       		$files['name'] = $files;
       	}

        // Check, whether the thumbnail sizes were altered..
        foreach ($files['name'] as $f)
        {
            $ext = JString::strtolower(JFile::getExt( $f ));
            if ($ext == 'jpeg')
                $ext = 'jpg';

            $f = JFile::makeSafe(JFile::stripExt( $f ).'.'.$ext);
            $originalImage = JPath::clean(RES_GENERAL_UPLOAD.'/'.$userId.'/'.$ext.'/'. $recordId.'_'.$f);

            // Resize pics only
            if (in_array($ext, $this->pics))
            {
                // Take care of watermarking
                $canWatermark = false;
                $watermark = $params->get('watermark');
                if (@$watermark[0] && @$watermark[0] != -1)
                    $canWatermark = true;

                // well, need to refactor the code, but now have no time :(
                $prefix = '';
                if ($canWatermark && $params->get('watermark_thumb'))
                {
                    $prefix = 'w_'.$watermark[1].'_'.$watermark[2];
                    $watermarkParams = $watermark;
                }
                else
                {
                    $prefix = '';
                    $watermarkParams = false;
                }


                $smallThumb = RES_GENERAL_UPLOAD.'/'.$userId.'/'.$ext.'/gallery/thumbnail_small/'. $recordId.'_'.$prefix.
                        $params->get('thumb_width', 120).'_'.$params->get('thumb_height', 120).'_'.$f;


                // Huh, the user has changed settings %)
                if (!is_file($smallThumb))
                {
                    $this->imageResize(
                            $originalImage,
                            $smallThumb,
                            $params->get('thumb_width', 120),
                            $params->get('thumb_height', 120),
                            $params->get('thumbquality', 100),
                            $watermarkParams,
				$params->get('crop_type', 'keep')
                    );
                }

                $prefix = '';
                if ($canWatermark && $params->get('watermark_image'))
                {
                    $prefix = 'w_'.$watermark[1].'_'.$watermark[2];
                    $watermarkParams = $watermark;
                }
                else
                {
                    $prefix = '';
                    $watermarkParams = false;
                }

                $bigThumb = RES_GENERAL_UPLOAD.'/'.$userId.'/'.$ext.'/gallery/thumbnail_big/'. $recordId.'_'.$prefix.
                        $params->get('max_width', 400).'_'.$params->get('max_height', 400).'_'.$f;

                // Huh, the user has changed settings %)
                if (!is_file($bigThumb))
                {
                    $this->imageResize(
                            $originalImage,
                            $bigThumb,
                            $params->get('max_width', 400),
                            $params->get('max_height', 400),
                            $params->get('bigquality', 100),
                            $watermarkParams,
				$params->get('crop_type', 'keep')
                    );
                }

                if ($canWatermark && $params->get('watermark_original'))
                {
                    $watermarkedOriginal = JPath::clean(RES_GENERAL_UPLOAD.'/'.$userId.'/'.$ext.'/gallery/'. $recordId.'_w_'.$watermark[1].'_'.$watermark[2].$f);
                    if (!is_file($watermarkedOriginal))
                    {
                        $this->imageResize(
                                $originalImage,
                                $watermarkedOriginal,
                                99999 + 1, // big numbers here to avoid resizing
                                99999 + 7,
                                100,
                                $watermark,
				$params->get('crop_type', 'keep')
                        );
                    }
                }

            }
        }
    }

    function i(&$array, $idx, $default = 0)
    {
        if (isset($array[ $idx ]) && $array[ $idx ])
        {
            return $array[ $idx ];
        }
        return $default;
    }

    function _getBlogThumbUrl($filename, $user_id, $record_id, $fieldvalueId, $width, $height, $quality, $border, $crop_type = 'keep')
    {
        
    	
    	$fileManager = & JSFileManager::getInstance();
    	
        if ($fileManager->getFileType($filename) != 'image')
            return '';

        $folder = RES_GENERAL_UPLOAD;
        $folder = str_replace(array(JPATH_ROOT.DS, str_replace('\\', '/',JPATH_ROOT.DS)),'', $folder);
        $folder = str_replace('\\','/', $folder);
        $filename 	= JPath::clean($filename);
        $ext = JString::strtolower(JFile::getExt( $filename ));
        if ($ext == 'jpeg')
        {
            $ext = 'jpg';
        }

        $filename = JFile::makeSafe(JFile::stripExt( $filename ).'.'.$ext);

        $path 		= RES_GENERAL_UPLOAD.DS.$user_id.DS.JFile::getExt($filename).DS.'gallery'.DS.'thumbnail_big'.DS.$record_id. '_'. $width.'_'.$height.'_'.$border.'_'. $filename;
        $infile 	= RES_GENERAL_UPLOAD.DS.$user_id.DS.JFile::getExt($filename).DS.$record_id. '_'. $filename;
        $newName = $record_id. '_'. $width.'_'.$height.'_'.$border.'_'. $filename;
       
        if (!JFile::exists($path))
        {
            $this->imageResize($infile, $path, $width, $height, $quality, $border, $crop_type);
        }

        //$filename = JFile::makeSafe($record_id. '_'. $width.'_'.$height.'_'.$border.'_'. $filename);
     
        
        return JURI::root().$fileManager->getDownloadUrl($fieldvalueId, array('hash'=>md5($filename), 'type'=>'blog_view'), false);
    }

    function _cleanUpThumbs($files, $recordId, $userId)
    {
        $baseDir = JPath::clean(RES_GENERAL_UPLOAD.DS.(int)$userId);

        /// Delete the pictures.
        foreach ($files as $file)
        {
            $ext = JFile::getExt($file);
            $exts[ $ext ] = 1;
        }

        foreach ($exts as $ext => $dummy)
        {
            foreach (glob($baseDir.DS.$ext.DS.'gallery'.DS.$recordId."_*") as $thumb)
            {
                JFile::delete($thumb);
            }

            foreach (glob($baseDir.DS.$ext.DS.'gallery'.DS.'thumbnail_big'.DS.$recordId."_*") as $thumb)
            {
                JFile::delete($thumb);
            }

            foreach (glob($baseDir.DS.$ext.DS.'gallery'.DS.'thumbnail_small'.DS.$recordId."_*") as $thumb)
            {
                JFile::delete($thumb);
            }
        }
    }

    function onDownloadFile($field, $recordValue)
    {
        if($field->type != 'gallery2')
        {
            return;
        }
        $user = &JFactory::getUser();
        $params = new JParameter($field->params);
        $files = @unserialize($recordValue->field_value);
        $file = '';
        if(!isset($files['files']['name'])){
        	$files['files']['name'] = $files['files'];
        }
        foreach($files['files']['name'] as $f)
        {

            if(md5($f) == JRequest::getVar('hash'))
            {
                $file = $f;
                break;
            }
        }

        $prefixThumb = '';
        $prefixImage = '';
        $prefixOriginal = '';
        $watermarkParams = $params->get('watermark');

        $putWatermark = @$watermarkParams[0] && @$watermarkParams[0] != -1;
        if ($putWatermark)
        {
            if ($params->get('watermark_thumb'))
                $prefixThumb = 'w_'.$watermarkParams[1].'_'.$watermarkParams[2];

            if ($params->get('watermark_image'))
                $prefixImage = 'w_'.$watermarkParams[1].'_'.$watermarkParams[2];

            if ($params->get('watermark_original'))
                $prefixOriginal = 'w_'.$watermarkParams[1].'_'.$watermarkParams[2];
        }

        $width = '';
        $height = '';
        $type = JRequest::getWord('type');
        $pathData = new stdClass();
        $fileHelper = &JS_File_Helper::getInstance();
        $dir = RES_GENERAL_UPLOAD.DS.$field->user_id;
		$subscr = true;
        $carma = true;
        
        $pathData->error = null;
        switch ($type) {
            case 'thumbnail_small':
                $carma = false;
                $subscr = false;
                $width = $params->get('thumb_width', 120);
                $height = $params->get('thumb_height', 120);
                $file = 'gallery' . DS . $type . DS . $field->record_id . '_' . $prefixThumb . $width . '_' . $height . '_' . $file;
                break;
            case 'thumbnail_big':
                $carma = false;
                $subscr = false;
                $width = $params->get('max_width', 400);
                $height = $params->get('max_height', 400);
                $file = 'gallery' . DS . $type . DS . $field->record_id . '_' . $prefixImage . $width . '_' . $height . '_' . $file;
                break;
            case 'blog_view':
                $carma = false;
                $subscr = false;
                $width = $params->get('bwidth', 120);
                $height = $params->get('bheight', 120);
                $border = $params->get('border');
                $file = 'gallery' . DS . 'thumbnail_big' . DS . $field->record_id . '_' . $width . '_' . $height . '_' . $border . '_' . $file;
                break;
            case 'watermark':
                $file = 'gallery' . DS . $field->record_id . '_' . $prefixOriginal . $file;
                break;
            default:
                $file = $field->record_id . '_' . $file;
                break;
        }

        if($fileHelper->checkSubscription($field->params))
        {
            $ext = strtolower(JFile::getExt($file));
            $pathData->path = $dir.DS.$ext.DS.$file;
            if( $carma )
                $fileHelper->modifyUsersCarma($field->params, $field->user_id, $user->get('id'));
        }
        else 
        {
        	if($subscr)
        	{
        		$pathData->error =JText::_("The file is under subscription");
        		$pathData->path = null;
        	}	
        }
       
        
        return $pathData;

    }

    // this will be removed in some time in a month today 16.06.2010
 /*   function moveFilesFromOldToNew()
    {
        $folder = RES_GENERAL_UPLOAD;
        $db = &JFactory::getDBO();
        $sql = "SELECT a.*, r.user_id  FROM #__js_res_record_values AS a
                INNER JOIN #__js_res_record AS r ON r.id = a.record_id
                INNER JOIN #__js_res_fields AS f ON f.id = a.field_id
                WHERE f.type = 'gallery2'";
        $db->setQuery($sql);
        $records = $db->loadObjectList();
        foreach($records as $rec)
        {


            $files = @unserialize($rec->field_value);
            $files = $files['files']['name'];
            foreach($files as $f)
            {
                $f = basename( $f );
                $ext = JString::strtolower(JFile::getExt( $f ));
                if ($ext == 'jpeg')
                    $ext = 'jpg';

                $f = JFile::makeSafe(JFile::stripExt( $f ).'.'.$ext);

                $srcFile = JPath::clean($folder.DS.$rec->user_id.DS.$ext.DS.'gallery'.DS.$rec->record_id.'_'.$f);
                $destFile = JPath::clean($folder.DS.$rec->user_id.DS.$ext.DS.$rec->record_id.'_'.$f);


                if (JFile::exists($destFile))
                {
                    if (JFile::exists($srcFile))
                    {
                        JFile::delete($srcFile);
                    }
                }
                else
                {
                    if (JFile::exists($srcFile))
                    {
                        JFile::move($srcFile, $destFile);
                    }
                }
            }

        }


    }*/
}
