<?php
/**
 * @fileID: $Id: getrss.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsGetRSS extends JPlugin
{
	function plgJoomsuite_content_fieldsGetRSS( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'getrss') return;
		if($obj->field_value)
		    $rssurl = unserialize($obj->field_value);
	    else
	        $rssurl[0] = '';
		$doc = &JFactory::getDocument();
		$css = "
		.rss-urls span{
			font-size: 25px;
			color: blue;
			cursor: pointer;
		}
		.rss-urls input{
			width: 90%;
		}
		";
		$doc->addStyleDeclaration($css);
		$script = "
		function add_rss".$obj->id."(parent)
		{
			total = 0;
			$$('.rss-urls').each(
				function (item){
					reg = /rss\d{1}".$obj->id."/m;
					if(reg.exec(item.id))
					{
						total++;
					}
				}
			);
			newrss = new Element('div', {id:'rss'+total+".$obj->id.", 'class':'rss-urls'});
			newinput = new Element('input', {type:'text', 'class':'inputbox', name:'fields[".$obj->id."][]', id:'fields".$obj->id."'+total});
			remove = new Element('span', {'onclick':'rem_rss".$obj->id."(this.parentNode);'});
			remove.innerHTML = '&nbsp;-&nbsp;';
			newrss.appendChild(newinput);
			newrss.appendChild(remove);
			newrss.injectAfter(parent);
			return false;
		}
		function rem_rss".$obj->id."(me)
		{
			$(me).remove();
		}
		";
		$doc->addScriptDeclaration($script);
		$html = '<div id="rss0'.$obj->id.'" class="rss-urls">';
		$html .= '<input type="text" class="inputbox" name="fields['.$obj->id.'][]" id="fields'.$obj->id.'0" value="'.$rssurl[0].'"/>';
		$html .='<span onclick="add_rss'.$obj->id.'(this);"> + </span>';
		$html .= '</div>';
		if(count($rssurl) > 1){
			for ($i=1; $i<count($rssurl); $i++){
				$html .= '<div id="rss'.$i.$obj->id.'" class="rss-urls">';
				$html .= '<input type="text" class="inputbox" name="fields['.$obj->id.'][]" id="fields'.$obj->id.$i.'" value="'.$rssurl[$i].'"/>';
				$html .='<span onclick="rem_rss'.$obj->id.'(\'rss'.$i.$obj->id.'\');">&nbsp;-&nbsp;</span>';
				$html .= '</div>';
			}			
		}
		echo $html;
		
	}
	
	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'getrss') return;
		if(!$value) return;
		$db = JFactory::getDBO();
		foreach ($value as $val) {
			$val = trim($val);
			if( !$val ) continue;
			$out[] = $db->getEscaped($val);
		}
		$value = serialize($out);		
	}
	
	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if($field->type != 'getrss') return;
		if(!$field->field_value) return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		
		$rssurls = unserialize($field->field_value);
		if(empty($rssurls))
		    return;
		    
		if(isset($rssurls[0]) && empty($rssurls[0]))
		    return;
		    
		$doc = &JFactory::getDocument();
		$css = "
		.rss-item{border-bottom: 1px solid gray;margin: 10px 5px;}
		.item-title{font-size: 14px;}
		";
		$doc->addStyleDeclaration($css);
		
		$heads = array();
		$items = array();
		$nitems = array();
		
		foreach ($rssurls as $i => $rssurl) {
			$rss = $this->getrss($params, $rssurl, $i);
			if (!empty($rss->head))
			{
				$heads = array_merge($rss->head, $heads);
			}
			if( isset($rss->items) )
			    $items = array_merge($rss->items, $items);
		}
// 		$items = array_reverse($items);
		$m = 1;
		$html = array();
		foreach ($items as $item) {
		    
		    if ($m > $params->get('rssitemstotal', 3))
			{
				break;
			}
			
			$date = new JDate($item->ctime);
			$row = '<div class="item-title">'.$item->title.'</div>';
			$t = $item->t;
			
			if($params->get('rssimage', 0) && isset($heads["image$t"]))
			{
				$row .= '<div class="rss-image">'.$heads["image$t"].'</div>';
			}
			if($params->get('rsstitle', 0) && isset($heads["title$t"]) )
			{
				if ($params->get('rsslink', 0) && isset($heads["link$t"]) )
				{
					$rsstitle = '<a href="'.$heads["link$t"].'">'.$heads["title$t"].'</a>';
				}else{
				    $rsstitle = $heads["title$t"];
				}
				$row .= '<div class="rss-title">'.$rsstitle.'</div>';
			}
			if($params->get('rssdesc', 0))
			{
				$row .=  '<div class="rss-title">'.$heads["description$t"].'</div>';
			}
			if($params->get('rssitemdate', 1))
			{
				$row .= '<span class="createdate">'.$date->toFormat('%Y-%m-%d').'</span>';
			}
			if($params->get('rssitemdesc', 1))
			{
				$row .= '<div class="rss-body">'.$item->body.'</div>';
			}
			$html[] = $row;
			
			$m++;
		}
		if(empty($html))
		    $out = '';
	    else
	        $out = '<div class="rss-item">'.implode('</div><div class="rss-item">',$html).'</div>';
	}

	function getrss($params, $rssurl, $i)
	{
		//params
		$rssitems			= $params->get('rssitems', 5);
		$rssdesc			= $params->get('rssdesc', 1);
		$rssimage			= $params->get('rssimage', 1);
		$rssitemdesc		= $params->get('rssitemdesc', 1);
		$words				= $params->def('word_count', 0);
		$rsstitle			= $params->get('rsstitle', 1);
		$rssrtl				= $params->get('rssrtl', 0);
		$rssrtl ? $rssrtl = 'right': $rssrtl = 'left';

		$rssout = new stdClass();
		//  get RSS parsed object
		$options = array();
		$options['rssUrl'] 		= $rssurl;
		if ($params->get('cache')) {
			$options['cache_time']  = $params->get('cache_time', 15) ;
			$options['cache_time']	*= 60;
		} else {
			$options['cache_time'] = null;
		}
		$rssDoc =& JFactory::getXMLparser('RSS', $options);
		if ($rssDoc != false)
		{
			// channel header and link
			$channel["title"] = $rssDoc->get_title();
			$channel["link"] = $rssDoc->get_link();
			$channel["description"] = $rssDoc->get_description();

			// channel image if exists
			$image["url"] = $rssDoc->get_image_url();
			$image["title"] = $rssDoc->get_image_title();

			//image handling
			$iUrl 	= isset($image["url"]) ? $image["url"] : null;
			$iTitle = isset($image["title"]) ? $image["title"] : null;
			// items
			$items = $rssDoc->get_items();
			// feed elements
			$items = array_slice($items, 0, $rssitems);
			
			$head = array();
			// feed title
			if (!is_null( $channel["title"] ) && $rsstitle) 
			{
				$head["link$i"] = str_replace( "&", "&amp;", $channel["link"]);
				$head["title$i"] = $channel["title"];
			}
			// feed description
			if ($rssdesc) {
				$head["description$i"] = $channel["description"];
			}
			
			// feed image
			if ($rssimage && $iUrl) {
				$head["image$i"] = '<img src="'.$iUrl.'" alt="'.@$iTitle.'"/>';
			}
			$rssout->head = $head;
			
            foreach ($items as $currItem) {
				$item = new stdClass();
				// item title
				if ( !is_null( $currItem->get_link() ) ) {
					$item->title = '<a href="'.$currItem->get_link().'" target="_child">'.$currItem->get_title().'</a>';
				}

				// item description
				if ($rssitemdesc)
				{
					// item description
					$text = $currItem->get_description();
					$text = str_replace('&apos;', "'", $text);

					// word limit check
					if ($words) {
						require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'html'.DS.'html_stripper.php';
						$text = JSHTMLStripper::substr($text, $words, '...');
					}
					$item->body = '<div style="text-align: '.$rssrtl.' ! important">'.$text.'</div>';
				}
				$item->ctime =$currItem->get_date('U');
				$item->t = $i;
				
				$set[] = $item;
			}
			$rssout->items = $set;
		}
		return $rssout;
	}
}
?>