<?php
/**
 * @fileID: $Id: watermark.php 7800 2012-02-13 07:01:36Z kostya $
 * @changedDate: $LastChangedDate: 2012-02-13 14:01:36 +0700 (Пн, 13 фев 2012) $
 * @changedBy: $LastChangedBy: kostya $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license http://www.gnu.org/licenseses/gpl-2.0.html GNU/GPL
*/
defined('_JEXEC') or die('Restricted Access');

class JS_Watermark extends JObject
{
	var $_watermark;
	
	/**
	 * LEFT | CENTER | RIGHT
	 * @var string
	 */
	var $_hAlign;
	
	/**
	 * TOP | CENTER | BOTTOM
	 * @var string
	 */
	var $_vAlign;
	
	function __construct($watermarkFile, $_hAlign, $_vAlign) {
		parent::__construct();
		
		$this->_hAlign = $_hAlign;
		$this->_vAlign = $_vAlign;
		
		jimport ('joomla.filesystem.file');
		$this->_watermark = $watermarkFile;
	}
	
	function createWatermarksForFiles($infiles) {
		require_once JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'lib'.DS.'Thumbnail.class.php';
		settype($infiles, 'array');
		
		$waterRes = $this->_readWatermark();
		if (!$waterRes)
			return false;
		
		$watermarker = new JS_Image_Thumbnail();
		
		foreach ($infiles as $file) {
			if (JFile::exists($file) && $watermarker->loadImage($file)) {
				$ext = strtoupper(JFile::getExt($file));
				if ($ext == 'JPG')
					$ext = 'JPEG';
				
				$outfile = JPath::clean($outdir.DS.$prefix.basename($file));
				
				$watermarker->output_format = $ext;
				$watermarker->quality = 90;
				$watermarker->img_watermark_Valing = $this->_vAlign;
				$watermarker->img_watermark_Haling = $this->_hAlign;
				
				$watermarker->setWatermark($waterRes);
				 
				$watermarker->process();
				$watermarker->save($file);
			}
		}
	}
	
	function createWatermarkForResource($img) {
		require_once JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'lib'.DS.'Thumbnail.class.php';
		settype($infiles, 'array');
		
		$waterRes = $this->_readWatermark();
		if (!$waterRes)
			return false;
		
		$watermarker = new JS_Image_Thumbnail();
		
		$watermarker->quality = 90;
		$watermarker->img_watermark_Valing = $this->_vAlign;
		$watermarker->img_watermark_Haling = $this->_hAlign;
		
		$watermarker->loadImage($img);
		$watermarker->setWatermark($waterRes);
		$watermarker->process();

		return $watermarker->img["des"];
	}
	
	/**
	 * Reads the watermark file or GD resource.
	 * @param $watermark mixed. Has to be a png file.
	 * @return resource
	 */
	function _readWatermark($watermark = null) {
		$watermark = $watermark ? $watermark : $this->_watermark;
		
		if (is_resource($watermark)) {
			$this->_watermark = $watermark;
			return $this->_watermark;
		}
		
		if (JFile::exists($watermark)) {
			$img_info =  getimagesize( $watermark );
			
			//detect image format
	        switch( $img_info[2] ){
	        	case IMAGETYPE_GIF:
	        		$this->_watermark = ImageCreateFromGIF ($watermark);
	    			break;
	    		case IMAGETYPE_JPEG:
	    			$this->_watermark = ImageCreateFromJPEG ($watermark);
        		break;
	    		case IMAGETYPE_PNG:
	    			$this->_watermark = ImageCreateFromPNG ($watermark);
  	    		break;
	    		default:
	                $this->setError(JText::_("Watermark: Not Supported File"). ' '.basename($watermark));
	 				return false;
		    }
		    
		    return $this->_watermark;
		}
		
		$this->setError(JText::_('Cannot load the watermark'));
		return false;
	}
}
