<?php
/**
 * @fileID: $Id: media.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die ('Restricted access');

jimport('joomla.plugin.plugin');

class plgJoomsuite_content_fieldsMedia extends JPlugin
{
    var $data;
    var $PLG_MEDIA_RSS_PLAYLIST_DIR = 'playlist';
    var $exts = 'flv, mp4, mp3, aac, jpeg, jpg, png, gif, mpg3';

    function plgJoomsuite_content_fieldsMedia(&$subject, $params)
    {
        parent::__construct($subject, $params);

        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'uploader.php';
        require_once JPATH_ROOT . DS . 'components' . DS . 'com_resource' . DS . 'library' . DS . 'php' . DS . 'jsfilemanager.php';
        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'file_helper.php';
        $this->helper = & JS_Res_FancyUploaderHelper::getInstance();
    }

    function onRenderField(&$obj, &$params, $type)
    {
        if ($type != 'media')
            return;

        $session = & JFactory::getSession();
        $user = & JFactory::getUser();

        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'uploader.php';

        $recordId = JHTMLJsmedia_new::getRealRecordId($obj, $type);
        $url = JHTMLJsmedia_new::getUploadUrl($obj, $type, $recordId);

        $optExts = explode(', ', $this->exts);

        $data = @unserialize($obj->field_value);
        if (!isset($data['files']))
            $data['files'] = array();

        // Show old values on page, if the article was not submitted
        $default = JRequest::getVar('fields');
        if ($default && isset($default[$obj->id]))
        {
            $default = $default[$obj->id];
            $data = $default;
        }

        if (!$params->get('license_stuff', 0))
        {
            JError::raiseNotice('403', JText::_('Please accept license for media field (look at field configuration)'));
        }

        $uid = uniqid('media_');
        $debug = false;

        // The file list.
        $files = $data['files'];

        if (is_array($files))
        {
            $sort = $params->get('sort');
            switch ($sort)
            {
                case 1:
                    sort($files);
                    break;
                case 2:
                    rsort($files);
                    break;
            }
        }

        $options = array(
            'uploader' => $params->get('uploader', 'flash'),
            'title' => 'Upload your files',
            'url' => $url,
            'files' => $files,
            'limitSize' => $params->get('max') ? ((int) $params->get('max')) * 1024 : 'false',
            'maxFiles' => $params->get('files_limit', 0),
            'debug' => $debug, // optional
            'backgroundColor' => '#FFFFFF',
            'filters' => $optExts,
            'uid' => $uid,
            'fieldId' => $obj->id,
            'recordId' => $recordId,
            'processResponse' => false,
            'limitFiles' => $params->get('number_of_files_in_uploader', 5),
            'pluginGroup' => 'joomsuite_content_fields',
            'pluginName' => 'media'
        );


        echo '<br><span>' . JText::_('Allowed formats are') . ": $this->exts</span>";
        echo JHTMLJsmedia_new::getUploaderWithFilesTable($obj, $options);

        // Extra field to track author change.
        echo '<input type="hidden" name="fields[author][', $obj->id, ']" value="', $this->helper->getAuthorIdByArticleId($obj->record_id), '" />';
        echo '<input type="hidden" name="fields[field_vid][', $obj->id, ']" value="', $obj->vid, '" />';
        echo '<input type="hidden" name="fields[field_id][', $obj->id, ']" value="', $obj->id, '" />';
    }

    function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
    {
        if ($type != 'media')
            return;

        $db = &JFactory::getDBO();
        $sess = & JFactory::getSession();
        $fileManager = & JSFileManager::getInstance();

        if (!isset($value['files']))
            $value['files'] = array();

        $error = false;

        if (!$params->get('license_stuff', 0))
        {
            JError::raiseNotice('403', JText::_('Please accept license for media field (look at field configuration)'));
            $error = true;
            return;
        }

        $sitePath = str_replace('\\', '/', JPATH_SITE . '/');
        $mediaDir = str_replace($sitePath, '', RES_GENERAL_UPLOAD);
        $mediaDir = chop($mediaDir, '/');

        // Check, if the article was newly created
        $shamaned_prefix = $sess->get('new_article_prefix', $row->id, $type);
        $newlyCreated = ($shamaned_prefix != $row->id);

        // track author change
        /*$author = (isset($_REQUEST['fields']['author'][ $id ]) ? (int)$_REQUEST['fields']['author'][ $id ] : -1);
        if ($author >= 0 && $author != $row->user_id)
            $fileManager->reassignFiles($value['files'], $row->id, $author, $row->user_id);*/

        $allowedExts = explode(', ', $this->exts);

        $toSave = array();
        $realFiles = array();

        if (is_array($value['files']))
        {
            // fix the names
            foreach ($value['files'] as $file)
            {
                $ext = strtolower(JFile::getExt($file));
                if ($ext == 'jpeg')
                    $ext = 'jpg';

                if (!in_array($ext, $allowedExts))
                {
                    $error = true;
                    JError::raiseWarning('M_EXT_01', JText::_('Extension is not allowed') . ' : ' . $ext);
                }

                $filename = JFile::makeSafe(JFile::stripExt(basename($file)) . '.' . $ext);
                $toSave[] = $filename;
                $realFiles [] = $row->id . '_' . $filename;

                $fileManager->storeFile($shamaned_prefix . '_' . $filename, $row->id . '_' . $filename, $row->user_id, '', true);
            }
        }

        unset($value['files']);
        if (count($toSave))
            $value['files'] = $toSave;

        if (is_array($toSave))
        {
            $sort = $params->get('sort');
            switch ($toSave)
            {
                case 1:
                    sort($toSave);
                    break;
                case 2:
                    rsort($toSave);
                    break;
            }
        }


        $value = serialize($value);
        return;
    }


    function onRenderFieldValue(&$out, &$field, &$record, $category)
    {
        if ($field->type != 'media')
            return;

        if (!$field->field_value)
            return;

        $params = new JParameter($field->params);
        $user = $record->user_id;
        $type = $field->type;


        $fileManager = &JSFileManager::getInstance();

        global $mainframe;

        $data = @unserialize($field->field_value);
        if (!isset($data['files']))
            $data['files'] = array();

        if (!count($data['files']))
            return;


        /*****************************/
        foreach ($data['files'] as $file)
        {
            $ext = JFile::getExt($file);
            $filename = JFile::makeSafe(JFile::stripExt(basename($file)) . '.' . $ext);
            $toSave[] = $filename;
            $realFiles [] = $record->id . '_' . $filename;
        }


        // Generate the playlist:
        $playlist = JSJWPlaylistGenerator::generateRSS(
            $realFiles, JURI::root(),
            $field->id,
            array(
                'title' => JURI::root(),
                'link' => JURI::root(),
                'userId' => $record->user_id
            )
        );
        
        
        $rssDir = JPath::clean(RES_GENERAL_UPLOAD . DS . $record->user_id . DS . $this->PLG_MEDIA_RSS_PLAYLIST_DIR);
        $rssPlaylistFile = JPath::clean($rssDir . DS . $record->id . '-' . $field->fid . 'playlist.xml');

        if (!JFolder::exists($rssDir))
        {
            JFolder::create($rssDir, 0755);
        }

        // Write the playlist to file.
        if (!JFile::write($rssPlaylistFile, $playlist))
        {
            JError::raiseWarning('MW_01', JText::_('Cannot write the playlist'));
            $error = true;
        }


      


        /*****************************/


        require_once (JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_resource' . DS . 'controllers' . DS . 'config.php');
        ResControllerConfig::initialyze();

        if (!$params->get('license_stuff', 0))
        {
            JError::raiseNotice('403', JText::_('Please accept license for media field (look at field configuration)'));
        }


        JTable::addIncludePath(JPATH_ADMINISTRATOR . DS . 'components' . DS . 'com_resource' . DS . 'tables' . DS);
        $record = & JTable::getInstance('Record', 'Res');
        $record->id = $field->record_id;
        $record->load();
        $userId = $record->user_id;

        JHTML::_('behavior.mootools');
        // Get the playlist URL.
        $basePath = str_replace('\\', '/', RES_GENERAL_UPLOAD);
        $mediaDir = str_replace(
            str_replace('\\', '/', JPATH_SITE . '/'), '',
            $basePath
        );
        $mediaDir = chop($mediaDir, '/');

        $playlistURL = JURI::root() . $mediaDir . '/' . $user . '/' . $this->PLG_MEDIA_RSS_PLAYLIST_DIR . '/' . $field->record_id . '-' . $field->fid . 'playlist.xml?a=' . uniqid('1');

        $uid = uniqid('media_player');

        $document = &JFactory::getDocument();
        $document->addScript(JURI::root() . 'plugins/joomsuite_content_fields/media.js');

        $out [] = '<p id="pl_' . $uid . '"><a href="http://www.macromedia.com/go/getflashplayer">Get the Flash Player</a> to see this player.</p>';


        $out [] = '<script>';
        $out [] = sprintf(
            'var s%s = new SWFObject("' . JURI::root() . 'plugins/joomsuite_content_fields/media.swf", "line", "%d", "%d", "7" );',
            $uid,
            $params->get('width'),
            $params->get('height')
        );
        $out [] = sprintf('s%s.addVariable("file","%s");', $uid, rawurlencode($playlistURL));
        if ($params->get('backcolor'))
            $out [] = sprintf('s%s.addVariable("backcolor","%s");', $uid, $params->get('backcolor'));
        if ($params->get('frontcolor'))
            $out [] = sprintf('s%s.addVariable("frontcolor","%s");', $uid, $params->get('frontcolor'));
        if ($params->get('lightcolor'))
            $out [] = sprintf('s%s.addVariable("lightcolor","%s");', $uid, $params->get('lightcolor'));
        if ($params->get('skin'))
            $out [] = sprintf('s%s.addVariable("skin","' . JURI::root() . 'plugins/joomsuite_content_fields/media_skins/%s");', $uid, $params->get('skin'));
        if ($params->get('playlist_size'))
            $out [] = sprintf('s%s.addVariable("playlistsize",%d);', $uid, $params->get('playlist_size'));
        if ($params->get('controlbarPosition'))
            $out[] = sprintf('s%s.addVariable("controlbar","%s")', $uid, $params->get('controlbarPosition'));

        $playlistPosition = (int) $params->get('playlistPosition');
        switch ($playlistPosition)
        {
            case 0:
                $playlistPosition = 'none';
                break;
            case 1:
                $playlistPosition = 'bottom';
                break;
            case 2:
                $playlistPosition = 'over';
                break;
            case 3:
                $playlistPosition = 'right';
                break;
            default:
                $playlistPosition = 'right';
        }

        $out [] = sprintf('s%s.addVariable("autostart","false")', $uid);
        $out [] = sprintf('s%s.addVariable("controlbarsize","20");', $uid);
        $out [] = sprintf('s%s.addVariable("playlist","%s");', $uid, $playlistPosition);
        $out [] = sprintf('s%s.addParam("allowfullscreen","true");', $uid);
        $out [] = sprintf('s%s.addParam("allowscriptaccess","always");', $uid);
        $out [] = sprintf('s%s.addParam("wmode","opaque");', $uid);
        $out [] = sprintf('s%s.addVariable("repeat","true");', $uid);
        $out [] = sprintf('s%s.addVariable("showdigits","true");', $uid);
        $out [] = sprintf('s%s.addVariable("showdownload","true");', $uid);
        $out [] = sprintf('s%s.addVariable("width","%d");', $uid, $params->get('width'));
        $out [] = sprintf('s%s.addVariable("height","%d");', $uid, $params->get('height'));
        $out [] = 'Window.onDomReady(function(){
			(function() { ' .
                sprintf('s%s.write("%s");', $uid, 'pl_' . $uid)
                . '}).delay(500);  ' .
                '});';

        $out [] = 'Window.addEvent("load", function(){ ' .
                'if ($E("#pl_' . $uid . ' a"))' .
                sprintf('s%s.write("%s");', $uid, 'pl_' . $uid) .
                '});';

        $out [] = '</script>';


        //$document->addScriptDeclaration(implode("\n", $script));


        $thiFiles = $data['files'];
        if (!is_array($thiFiles))
            $thiFiles = array($thiFiles);

        //$dowloadUrl = JURI::root().'index2.php?option=com_resource&task=download2&no_html=1&id='.$field->id;

        ob_start();
        ?>
        <?php if ($params->get('allow_download', 0) == 1) : ?>
        <a href="javascript:void(0)" id="<?php echo $uid; ?>toggle"
           title="<?php echo JText::_('Click here to expand'); ?>"><b><?php echo JText::_('Download'), ':'; ?></b></a>
        <div id="<?php echo $uid; ?>media_download_outer" style="overflow:hidden;">
            <div id="<?php echo $uid; ?>media_download" style="float:left">
                <table cellpadding="0" cellspacing="0">
                <?php
                
                
                foreach ($thiFiles as $thiFile)
                {
                    $dowloadUrl = JURI::root().$fileManager->getDownloadUrl($field->id, array('hash' => md5($field->record_id.'_'.$thiFile)));
                    if (JFile::exists(RES_GENERAL_UPLOAD . DS . $userId . DS . JFile::getExt($thiFile) . DS . $field->record_id . '_' . $thiFile))
                        echo '<tr><td><a href="'. $dowloadUrl.'">',
                        htmlspecialchars($thiFile, ENT_QUOTES, 'UTF-8'). '</a></td></tr>';
                }
                ?>
                </table>
            </div>
        </div>
        <script>
            Window.onDomReady(function()
            {
                var mySlider = new Fx.Slide('<?php echo $uid; ?>media_download_outer', {duration: 500});
                $('<?php echo $uid; ?>toggle').addEvent('click', function()
                {
                    mySlider.toggle();
                });
                mySlider.toggle();
            });
        </script>
        <?php endif; ?>
        <?php
        $out[] = ob_get_clean();

        $out = implode("\n", $out);


    }


    /**
     * Track the author article change to move files
     * @param $records
     * @param $newAuthor
     * @return unknown_type
     */
    function onArticleAuthorChange(&$records, $newAuthor)
    {

        require_once JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'library'.DS.'php'.DS.'file_helper.php';

        $fileHelper = JS_File_Helper::getInstance();

        $fileHelper->reassignFilesNew($records, $newAuthor, 'media');
    }

    /**
     * Cleanup the thumbs, etc.
     * @param $recordIds
     * @return unknown_type
     */
    function onDeleteRecords($recordIds)
    {
        jimport('joomla.filesystem.file');

        require_once (JPATH_ROOT . DS . 'administrator' . DS . 'components' . DS . 'com_resource' . DS . 'controllers' . DS . 'config.php');
        ResControllerConfig::initialyze();

        $db = & JFactory::getDBO();

        $q = 'SELECT r.id AS record_id, rv.field_value, f.id AS field_id, r.user_id FROM ' .
                '#__js_res_record r ' .
                'LEFT OUTER JOIN #__js_res_record_values rv ON r.id = rv.record_id ' .
                'LEFT OUTER JOIN #__js_res_fields f ON rv.field_id = f.id ' .
                'WHERE ' .
                'r.id IN (' . implode(' , ', $recordIds) . ') AND f.type = "media"';

        $db->setQuery($q);
        $recs = $db->loadObjectList();

        foreach ($recs as $rec)
        {
            if (empty($rec->user_id) || empty($rec->field_value) || empty($rec->record_id))
                continue;

            $fValue = @unserialize($rec->field_value);
            $files = isset($fValue['files']) ? $fValue['files'] : array();

            $baseDir = JPath::clean(RES_GENERAL_UPLOAD . DS . $rec->user_id);

            $rssPlaylistFile = JPath::clean(RES_GENERAL_UPLOAD . DS . $rec->user_id . DS . $this->PLG_MEDIA_RSS_PLAYLIST_DIR . DS . $rec->record_id . '-' . $rec->field_id . 'playlist.xml');
            if (JFile::exists($rssPlaylistFile))
                JFile::delete($rssPlaylistFile);

            foreach ($files as $file)
            {
                if (empty($file))
                    continue;

                $ext = JFile::getExt($file);

                $file = $baseDir . DS . $ext . DS . $rec->record_id . '_' . $file;
                $fileHelper = JS_File_Helper::getInstance();
                $fileHelper->removeFiles($file);
            }
        }
    }

    function onXajaxDeleteFile(&$response, $filename, $recordId, $callback = false, $field_id = NULL)
    {
        jimport('joomla.filesystem.file');

        $user = & JFactory::getUser();
        $session = & JFactory::getSession();
        $fileHelper = & JSFileManager::getInstance();


        $userId = null;
        // --  Check the record id --
        if (!is_numeric($recordId))
        {
            $shamaned_prefix = JFile::makeSafe($session->get('new_article_prefix', null, 'media'));
            if (!$shamaned_prefix || $shamaned_prefix != $recordId)
            {
                return false;
            }

            // the owner is current user
            $userId = $user->get('id');
        }
        else
        {
            $record = & JTable::getInstance('Record', 'Res');
            if (!$record->load($recordId))
            {
                return false;
            }

            $userId = $record->user_id;
        }


        // Check user rights to delete

        if ($userId != $user->get('id'))
        {
            if ($user->get('aid') < 2)
            {
                // don't have enough rights to delete
                return false;
            }
        }


        // Now delete the files:
        // Here, we delete all the files, and thumbnails, if they exist :)
        $filename = JFile::makeSafe($filename);
        $ext = JFile::getExt($filename);
        $base = JPath::clean(RES_GENERAL_UPLOAD . DS . $userId . DS . $ext);


        // Here we deal with newly uploaded file, that has no thumbnails generated,
        // so I can simply delete it ;)
        $file = JPath::clean($base . DS . $recordId . '_' . $filename);
        if (!JFile::delete($file))
        {
            // Failed deleting file: exit
            if ($callback)
                $response->script($callback . '(false)');

            return false;
        }


        if ($callback)
            $response->script($callback . '(true)');

        return true;
    }


    function jsFormatSize($size)
    {

        $kb = 1024;
        $mgb = $kb * 1024;
        $gb = $mgb * 1024;
        $trb = $gb * 1024;

        if ($size > $trb)
        {
            return number_format($size / $trb, 2, ',', ' ') . " Tb";
        }
        elseif ($size > $gb)
        {
            return number_format($size / $gb, 1, ',', ' ') . " Gb";
        }
        elseif ($size > $mgb)
        {
            return number_format($size / $mgb, 0, ',', ' ') . " Mb";
        }
        elseif ($size > $kb)
        {
            return number_format($size / $kb, 0, ',', ' ') . " Kb";
        }
        else
        {
            return $size . " B";
        }
    }

    function onDownloadFile($field, $recordValue)
    {
        if ($field->type != 'media')
        {
            return;
        }
        
        $user = &JFactory::getUser();
        $pathData = new stdClass();
        $fileHelper = &JS_File_Helper::getInstance();
        $params = new JParameter($field->params);
        $files = @unserialize($recordValue->field_value);
        $file = '';
        foreach ($files['files'] as $f)
        {
        	$f = $field->record_id.'_'.$f;

            if (md5($f) == JRequest::getVar('hash'))
            {
                $file = $f;
                break;
            }
        }


        $ext = strtolower(JFile::getExt($file));

        if ($fileHelper->checkSubscription($field->params))
        {
            $pathData->path = RES_GENERAL_UPLOAD . DS . $field->user_id . DS . $ext . DS . $file;
            $fileHelper->modifyUsersCarma($field->params, $field->user_id, $user->get('id'));
        }

        $pathData->error = null;
        return $pathData;

    }
}

?>