<?php
/**
 * @fileID: $Id: multi_rating.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted Access');
/* IMPORTANT NOTE: function onRenderFieldValue() decorates the uri,
 * 		so it won't contain nasty 'user_id' variable,
 * 		cuz it redirects you away, and the ranking is not saved.
 * 		The decoration is done with javascript in 'front/com_resource/helpers/script.js'
 * 		So, be careful.
 */

jimport( 'joomla.plugin.plugin' );

define ('PLG_MCR_ORDER_NONE', 1);
define ('PLG_MCR_ORDER_ASC', 2);
define ('PLG_MCR_ORDER_DESC', 3);

define ('PLG_MCR_CMD_SAVE', 'mcr_save');
define ('PLG_MCR_CMD_SAVE_VALUE', '1');

define ('PLG_MCR_DUMMY_FIELD', '__dummy_exsistence_field');
define ('PLG_MCR_DUMMY_FIELD_VALUE', '1');

define ('PLG_MCR_SEPARATOR', ':::');
define ('PLG_MCR_USABLE_SEPARATOR', '__PLG_SEP_');
define ('PLG_MCR_SPACE_SEPARATOR', '__SPC_SEP_');


define ('PLG_MCR_MAX_VOTE', 100);
define ('PLG_MCR_MIN_VOTE', 0);

class plgJoomsuite_content_fieldsMulti_rating extends JPlugin
{
	var $_data;
	
	function plgJoomsuite_content_fieldsMulti_rating( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	
	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'multi_rating')
			return;
		// Setting default values for fields
		$default = array();
		$def = JRequest::getVar('fields', array(), 'default', 'array');
		if(key_exists($obj->id, $def)) 
			$default = $def[$obj->id];
		if($obj->field_value && !count($default))
			$default = unserialize($obj->field_value);

		if (!isset($default['canrate'])) {
			$default['canrate'] = 1;
		}
		if (!isset($default['whocanrate']))
			$default['whocanrate'] = 0;

		if (!$params->get('multicriteriarating_tmpl'))
			$params->def('multicriteriarating_tmpl', 'default');

//		$user 		= &JFactory::getUser();
		?>
		<?php //if ($user->get('aid') > 1): ?>
			<label><input type="radio" name="fields[<?php echo $obj->id; ?>][canrate]" value="1" <?php echo $default['canrate']=='1' ? 'checked' : ''; ?> /> <?php echo JText::_('Allow rating');?></label><br />
			<label><input type="radio" name="fields[<?php echo $obj->id; ?>][canrate]" value="0" <?php echo $default['canrate']=='0' ? 'checked' : ''; ?> /> <?php echo JText::_('Disallow rating');?></label><br />
			<label><input type="radio" name="fields[<?php echo $obj->id; ?>][canrate]" value="2" <?php echo $default['canrate']=='2' ? 'checked' : ''; ?> /> <?php echo JText::_('Hide');?></label>
		<?php //else: ?>
			<?php //echo JText::_('MultiRating'); ?>
		<?php //endif; ?>
		<input type="hidden" name="fields[<?php echo $obj->id; ?>][<?php echo PLG_MCR_DUMMY_FIELD; ?>]" value="<?php echo PLG_MCR_DUMMY_FIELD_VALUE; ?>" />
		<?php
	}

	/*
	 * Serializes the value of field before saving
	 */
	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'multi_rating')
			return;
		if(!$value)
			return;
		$value = serialize($value);
	}
	
	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if($field->type != 'multi_rating')
			return;

		if(!$field->field_value)
			return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		
	
	// Workaround to avoid inserting records to database twice
		static $savedId = 0;

		
		$data = array();
		$data = unserialize($field->field_value);
		
		$db 		= &JFactory::getDBO();
		$session 	= &JFactory::getSession();
		$curUser 	= &JFactory::getUser();
		$canRate 	= @$data['canrate'];
		
		if ($canRate == 2)
			return;
		
		
		$whoCanRate = array();
		if ($params->get('access_public', 0))
			$whoCanRate[] = 0;
		if ($params->get('access_registered', 0))
			$whoCanRate[] = 1;
		if ($params->get('access_special', 0))
			$whoCanRate[] = 2;

	    $curURI = & JURI::getInstance();
		$uri = $curURI->toString();		
		
		// Names of 'Multicriteria rating field'
		$fieldNames = explode("\n", JString::trim($params->get('values'), "\r\n"));
		$ordering 	= $params->get('sort');

		// Handle ordering
		switch ($ordering) {
		case PLG_MCR_ORDER_ASC:
			asort($fieldNames);
			break;
		case PLG_MCR_ORDER_DESC:
			arsort($fieldNames);
			break;
		}

		// Handle saving routine:
		$saveCmd = JRequest::getString(PLG_MCR_CMD_SAVE.$field->id, '');
		
		if ($saveCmd == PLG_MCR_CMD_SAVE_VALUE && $savedId != $field->id) {
			$votes = array();
			$reqData = JRequest::getVar('fields');
			if ( is_array($reqData) && isset($reqData[$field->id]) && is_array($reqData[$field->id])) {
				$reqData = $reqData[$field->id];
				$fError = false;
				foreach ($fieldNames as $fieldName) {
					// The variable names can't start with numbers, decode encoded values:
					$fieldName = str_replace(PLG_MCR_SEPARATOR, PLG_MCR_USABLE_SEPARATOR, $fieldName);
					$fieldName = str_replace(' ', PLG_MCR_SPACE_SEPARATOR, $fieldName);
					$fieldName = addslashes($fieldName);
					if (!isset($reqData['__'.$fieldName])) {
						$fError = true; // flag an error
						break;
					}
					// Prepare array for saving, by decoding values:
					$key = $fieldName;
					$key = str_replace(PLG_MCR_USABLE_SEPARATOR, PLG_MCR_SEPARATOR, $key);
					$key = str_replace(PLG_MCR_SPACE_SEPARATOR, ' ', $key);
					$votes[$key] = $reqData['__'.$fieldName];
				}
				
				if ($fError) {
					JError::raiseWarning(12345, JText::_('Wrong MCR fields'));
				}
				else {
					$row = & JTable::getInstance('FieldExtra', 'Res');
					$row->set('user_id', $curUser->get('id', 0));
					$row->set('ip', $_SERVER['REMOTE_ADDR']);
					$row->set('field_id', $field->id);
					$row->set('record_id', $field->record_id);
					
					foreach ($votes as $p => $vote)
					{
						if ($vote > PLG_MCR_MAX_VOTE)
							$vote = PLG_MCR_MAX_VOTE;
						if ($vote < PLG_MCR_MIN_VOTE)
							$vote = PLG_MCR_MIN_VOTE;
						
						if (!is_string( $p ))
							$p = strval($p);
							
						$row->set('id', null);
						$row->set('ref_id', stripslashes(JString::strtolower( $p )));
						$row->set('value', (int)$vote);
						$row->store();
					}
					
					$savedId 	= $field->id;

					$session->set('user_mcr_rate_'.$field->id, 1);
					setcookie('user_mcr_rate_'.$field->id, 1, 86400 * 365);
					global $mainframe;
					$mainframe->redirect($uri, JText::_('Thank you for voting!'));
				}
			}
		}
		$q = 'SELECT b.ref_id AS ratingEntry, AVG(b.value) AS average FROM 
			`#__js_res_field_extra` b WHERE b.field_id = '.(int)$field->id.' GROUP BY ref_id';
		$db->setQuery( $q );
		$prevRatings = $db->loadObjectList();
		
		$voted		= $session->get('user_mcr_rate_'.$field->id, 0);
		
		$canRate = !in_array($curUser->get('aid'), $whoCanRate) ? 0 : $canRate;
		$canRate = $savedId == $field->id ? 0 : $canRate;
		$canRate = $voted ? 0 : $canRate;
		// Now, ready to go, let's render it.
		ob_start();
		if (!$params->get('multicriteriarating_tmpl'))
			$params->def('multicriteriarating_tmpl', 'default');

		$uniqueId = 'mcr'.uniqid (true);
		$formName = 'mcrform_'.$field->id;
		?>
		<script>
		mcr_rating['<?php echo $uniqueId; ?>'] = {
			id: <?php echo $field->id; ?>,
			url: '<?php echo addslashes($uri); ?>',
			headInserted: false,
			separator: '<?php echo PLG_MCR_USABLE_SEPARATOR;?>',
			headText: '<?php echo JText::_('You ranked'); ?>',
			saveText: '<?php echo JText::_('Save'); ?>',
			formName: '<?php echo $formName, $uniqueId; ?>',
			formCreated: false,
			spaceSeparator: '<?php echo PLG_MCR_SPACE_SEPARATOR; ?>',
			saveCmd: {
				name: '<?php echo PLG_MCR_CMD_SAVE, $field->id; ?>',
				value: <?php echo PLG_MCR_CMD_SAVE_VALUE; ?>
			},
			fields: []
		};
		
		</script>
		<table cellpadding="3" cellspacing="0" border="0" width="100%">
			<?php
			$hack = new _EnMCRHack();
			
			$generalSum = 0;
			$ratingEntriesCount = 0;
			foreach ($fieldNames as $fieldName) {
				$avg = '';
				if (!is_string($fieldName))
					$fieldName = strval($fieldName);
				$fName = JString::strtolower($fieldName);
				
				if (isset($prevRatings[ 0 ])){
					foreach ($prevRatings as $prevRating) {
						if ($prevRating->ratingEntry == $fName) {
							$avg = $prevRating->average;
							break;
						}
					}
				}
				$generalSum += (int)$avg;
				$ratingEntriesCount++;
				
				$ratingTemplate = $params->get('multicriteriarating_tmpl');
				$ratingName = $fieldName;
				// Decorate the names, to make them work properly.
				$fieldDisplayName = '__'.$fieldName;
				if (strpos($fieldName, PLG_MCR_SEPARATOR)) {
					$t = explode (PLG_MCR_SEPARATOR, $fieldName);
					$ratingTemplate = $t[ 1 ];
					$ratingName 	= $t[ 0 ];
				}
				if (!strncmp('__', $ratingName, 2))
					$ratingName = substr($ratingName, 2);
				if (false !== strpos($fieldDisplayName, PLG_MCR_SEPARATOR)){
					$fieldDisplayName = str_replace(PLG_MCR_SEPARATOR, PLG_MCR_USABLE_SEPARATOR, $fieldDisplayName);
				}
				// JFilterOutput::objectHTMLSafe($fieldDisplayName, ENT_QUOTES);
				// $fieldDisplayName = htmlspecialchars($fieldDisplayName, ENT_QUOTES, 'UTF-8');
				$fieldDisplayName = addslashes($fieldDisplayName);
				?>
				<tr>
					<td nowrap="nowrap" width="1%">
					    <?php echo htmlentities($ratingName, ENT_QUOTES, 'UTF-8'); ?>
					    <?php if($params->get('show_rating_each', 0))
					        echo '<br /><small>',JText::_('Avg'), ': ', (int)$avg, '%','</small>'; ?>
				    </td>
					<td><?php echo $hack->loadRatingTemplates($field, str_replace(' ', PLG_MCR_SPACE_SEPARATOR, $fieldDisplayName), $params, $avg, $canRate, $ratingTemplate, $uniqueId); ?></td>
					<script>
					mcr_rating['<?php echo $uniqueId; ?>'].fields.push({
						name: '<?php echo str_replace(' ', PLG_MCR_SPACE_SEPARATOR, $fieldDisplayName); ?>',
						viewName: '<?php echo $fieldDisplayName; ?>',
						vote: <?php echo (int)$avg; ?>
					});
					</script>
				</tr>
				
				<?php
			}
			// avoid division by zero
			$generalSum == 0 ? 1 : $generalSum;
			
			?>
			<?php if($params->get('show_total_rating', 0)):?>
			<tr>
				<td colspan="2"><?php echo JText::_('Total average rating'), ': ', (int)($generalSum / $ratingEntriesCount), '%'; ?></td>
			</tr>
			<tr>
				<td colspan="2">
					<table>
						<thead id="mcr_user_ratings_head<?php echo $field->id, $uniqueId; ?>">
						</thead>
						<tbody id="mcr_user_ratings<?php echo $field->id, $uniqueId; ?>">
						</tbody>
					</table>
				</td>
			</tr>
			<?php endif;?>
		</table>
		<p>
			<input type="button" id="<?php echo 'mcr_save_button_', $field->id, $uniqueId; ?>" onclick="mcrsubmit('<?php echo $uniqueId; ?>');" style="display: none;" class="button" value="<?php echo JText::_('Save'); ?>"/>
		</p>
		<?php
		$out = ob_get_contents();
		ob_end_clean();
		// $out = implode("\n", $out);
		
		// Now, handle the orphan rating items, the items that have been renamed or
		// deleted from rating list.
		if (isset($prevRatings[ 0 ])){
			$orphans = array();
			foreach ($prevRatings as $prevRating) {
				$isOrphan = true;
				
				foreach ($fieldNames as $fieldName) {
					if ($prevRating->ratingEntry == JString::strtolower($fieldName)) {
						$isOrphan = false;
						break;
					}
				}
				if ($isOrphan)
					$orphans[] = $db->Quote($prevRating->ratingEntry);
			}
			
			if (count($orphans)) {
				$q = 'DELETE FROM #__js_res_field_extra WHERE field_id = '.(int)$field->id
					.' AND record_id = '.(int)$field->record_id.' AND ref_id IN ('.implode(',', $orphans).')';
				$db->setQuery( $q );
				$db->query();
			}
		}
	}
}

/*
 * This class is used only to avoid problems with $this pointer
 * which is used in some static methods of helper class subTemplate
 *
 */
class _EnMCRHack {
	function loadRatingTemplates(&$item, $fieldName, &$params, $rating, $canRate, $template, $uniqueId) {
		return subTemplate::loadRatingTemplateMCR(
			$template,
			$rating,
			'r'.uniqid($item->id),
			$item->id.'_EN_SEP_'.$fieldName.'_EN_SEP_'.$uniqueId, // Here, _EN_SEP_ is justa separator ;)
			'MCRRatingCallBack',
			$canRate
		);
	}
}
