<?php
/**
 * @fileID: $Id: poll.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted Access');

jimport( 'joomla.plugin.plugin' );
jimport('joomla.utilities.date');
class plgJoomsuite_content_fieldsPoll extends JPlugin
{
	function plgJoomsuite_content_fieldsPoll( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		JTable::addIncludePath(JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'poll'.DS.'tables');
		$document = &JFactory::getDocument();
		$document->addStyleSheet(JURI::root().'components/com_poll/assets/poll_bars.css');
		$db = &JFactory::getDBO();
		$sql = 'CREATE TABLE  IF NOT EXISTS `#__js_res_apoll` (
                `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
                `title` varchar(255) NOT NULL,
                `user_id` int(10) unsigned NOT NULL,
                `record_id` int(10) unsigned NOT NULL,
                `ctime` datetime NOT NULL,
                `extime` datetime NOT NULL,
                `params` text NOT NULL,
                `total_votes` int(10) unsigned NOT NULL,
                `exnotesent` tinyint(3) unsigned NOT NULL,
                PRIMARY KEY (`id`),
                KEY `user_id` (`user_id`))';
		$db->setQuery($sql);
		$db->Query();

		$sql = 'CREATE TABLE IF NOT EXISTS `#__js_res_apoll_options` (
                `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
                `poll_id` int(10) unsigned NOT NULL,
                `votes` int(10) unsigned NOT NULL,
                `text` text NOT NULL,
                PRIMARY KEY (`id`),
                KEY `poll_id` (`poll_id`))';
		$db->setQuery($sql);
		$db->Query();

		$sql = 'CREATE TABLE IF NOT EXISTS `#__js_res_apoll_votes` (
                `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
                `user_id` int(10) unsigned NOT NULL,
                `option_id` int(10) unsigned NOT NULL,
                `poll_id` int(10) unsigned NOT NULL,
                `ctime` datetime NOT NULL,
                `ip` varchar(45) NOT NULL,
                PRIMARY KEY (`id`),
                KEY `option_id` (`option_id`),
                KEY `poll_id` (`poll_id`))';
		$db->setQuery($sql);
		$db->Query();

	}


	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'poll') return;
		$value = $obj->field_value;
		$pTable = JTable::getInstance('Poll', 'APoll');
		$loaded = false;
		if($value)
		{
			$loaded = $pTable->load($value);
		}

		$pollparams = new JParameter($pTable->get('params', ''));
		$maxId = 0;

		require(JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'poll'.DS.'editpolls.php');
			
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type!='poll'){return;}
		$post = $value;
		$poll_id = intval($post['id']);


		$pollParams = new JParameter('');
		$pollParams->set('multiple', $post['multiple']);
		$pollParams->set('access', $post['access']);

		$pTable = JTable::getInstance('Poll', 'APoll');
		if($poll_id)
		{
			$pTable->load($poll_id);
		}

		$currentOptions = $pTable->get('options');

		$post['params'] = $pollParams->toString();
		$post['user_id'] = $row->user_id;
		$post['record_id'] = $id;

		$options = $post['options'];

		$pTable->bind($post);
		$pTable->store();

		$poll_id = $pTable->get('id');


			
		$options = $this->syncronizePollOptions($poll_id,$currentOptions, $options);

		$oTable = JTable::getInstance('Option', 'APoll');

		foreach($options['result'] as $opt)
		{
			$oTable = JTable::getInstance('Option', 'APoll');
			$oTable->load($opt->id);
			$oTable->set('text',$opt->text);
			$oTable->set('votes', $opt->votes);
			$oTable->set('poll_id', $opt->poll_id);
			$oTable->store();
		}
		foreach($options['remove'] as $opt)
		{
			$oTable = JTable::getInstance('Option', 'APoll');
			$oTable->delete($opt->id);
		}
		$value = $poll_id;

	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if(!$field->field_value) return;
		if($field->type != 'poll') return;
		$isList = false;
		$params = new JParameter($field->params);
		$user = &JFactory::getUser();
		$user_ip = $_SERVER['REMOTE_ADDR'];

		$pTable = &JTable::getInstance('Poll', 'APoll');
		$vTable = &JTable::getInstance('Vote', 'APoll');

		$pTable->load($field->field_value);
		if(!count($pTable->get('options', array())))
		{
			return;
		}
		$pollParams = new JParameter($pTable->get('params'));
		$canVote  = false;
		if($user->get('id'))
		{
			$canVote = !$vTable->loadByUser($user->get('id'), $pTable->get('id'));
		}
		else if($pollParams->get('access') == 0 && !$pollParams->get('access'))
		{
			$canVote = !$vTable->loadByIp($user_ip, $pTable->get('id'));
		}

		if($params->get('allow_set_expire_date') && $params->get('allow_recieve_expire_notice')
		&& $pTable->get('extime') != '0000-00-00 00:00:00')
		{
			$db = &JFactory::getDBO();
			$extime = $db->Quote($pTable->get('extime'));
			$sql = 'SELECT NOW() > '.$extime;
			$db->setQuery($sql);
			if($db->loadResult())
			{
				$canVote = false;
			}
		}
		ob_start();
		if(!$canVote)
		{
			$pollResults = $this->getPollResults($pTable);
			require(JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'poll'.DS.'showresults.php');
		}

		if($canVote)
		{
			$uid = uniqid('poll');
			$doc = &JFactory::getDocument();
			$doc->addScriptDeclaration("
			function getSelectedOptions".$uid."(conteiner_id){
				var sel = new Array();
				$(conteiner_id).getElements('input[type=".($pollParams->get('multiple')? 'checkbox':'radio')."]').each(function(input){
				
				    if( /".($pollParams->get('multiple')? 'checkbox':'radio')."/.test(input.getAttribute('type')) && input.checked){
				        sel.push( input.getValue() );
				    }
				});
				return sel;
			}
			");
			if(JRequest::getWord('view') == 'list')
			{
				$isList = true;
			}
			require(JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'poll'.DS.'showoptions.php');

		}
		$out = ob_get_clean();

	}



	function onDeleteRecords($recordIds)
	{
		$db = & JFactory::getDBO();
		$sql = 'SELECT rv.field_value FROM '.
                '#__js_res_record r '.
                'LEFT OUTER JOIN #__js_res_record_values rv ON r.id = rv.record_id '.
                'LEFT OUTER JOIN #__js_res_fields f ON rv.field_id = f.id '.
                'WHERE '.
                'r.id IN ('.implode(" , ", $recordIds).') AND f.type = "poll"';
		$db->setQuery($sql);
		$fieldValueIds = $db->loadResultArray();
		if(!empty($fieldValueIds)){
			$sql = 'DELETE FROM #__js_res_apoll WHERE id IN('.implode(' , ', $fieldValueIds).')';
			$db->setQuery($sql);
			$db->query();
	
			$sql = 'DELETE FROM #__js_res_apoll_options WHERE poll_id IN('.implode(' , ', $fieldValueIds).')';
			$db->setQuery($sql);
			$db->query();
	
			$sql = 'DELETE FROM #__js_res_apoll_votes WHERE poll_id IN('.implode(' , ', $fieldValueIds).')';
			$db->setQuery($sql);
			$db->query();
		}
	}

	function onXajaxSubmitVote(&$response, $option=null, $pollId=null, $uid=null)
	{
	
		$user = &JFactory::getUser();
		$user_ip = $_SERVER['REMOTE_ADDR'];

		$pTable = &JTable::getInstance('Poll', 'APoll');
		$vTable = &JTable::getInstance('Vote', 'APoll');

		if(!$pollId || !$option)
		{
			$response->alert(JText::_("Please make your choise"));
			return true;
		}
		$pTable->load($pollId);

		$pollParams = new JParameter($pTable->get('params'));

		$canVote  = false;
		if($user->get('id'))
		{
			$canVote = !$vTable->loadByUser($user->get('id'), $pTable->get('id'));
		}
		else if($pollParams->get('access') == 0 && !$pollParams->get('access'))
		{
			$canVote = !$vTable->loadByIp($user_ip, $pTable->get('id'));
		}

		//storing the vote if everything is allright
		if($canVote)
		{
			$date = new JDate();
			if(is_array($option) && $pollParams->get('multiple'))
			{
				$options = $option;
			}
			else
			{
				$options = array($option);
			}
			
			foreach($options as $option)
			{
				$oTable = &JTable::getInstance('Option', 'APoll');
				$vTable = &JTable::getInstance('Vote', 'APoll');

				$oTable->load($option);
				$oTable->set('votes', $oTable->get('votes')+1);
				$oTable->store();

				$pTable->set('total_votes', $pTable->get('total_votes')+1);
				$pTable->store();

				$vTable->set('user_id', $user->get('id'));
				$vTable->set('option_id', $oTable->get('id'));
				$vTable->set('poll_id', $pTable->get('id'));
				$vTable->set('ctime', $date->toMySQL());
				$vTable->set('ip', $user_ip);
				$vTable->store();
			}

			if($pollParams->get('allow_recieve_vote_notice'))
			{
				$this->sendAlert($pTable, 'vote');
			}
			$this->sendAlert($pTable, 'expire');

		}
		else
		{
			$response->alert(JText::_("Sorry, but you are not allowed to vote"));
		}
		$response->script('xajax_jsCallPlugin("joomsuite_content_fields", "poll", "onXajaxShowPollResults", ['.$pTable->get('id').', "'.$uid.'"]);');

		return true;
	}


	function onXajaxShowPollResults(&$response,$pollId, $uid)
	{

		$pTable = &JTable::getInstance('Poll', 'APoll');
		$pTable->load($pollId);
		$pollResults = $this->getPollResults($pTable);
		$pollParams = new JParameter($pTable->get('params'));


		//getting the params of the plugin
		$db = &JFactory::getDBO();
		$sql = "SELECT f.params FROM #__js_res_record_values AS a"
		."\n INNER JOIN #__js_res_fields AS f ON a.field_id = f.id"
		."\nWHERE f.type = 'poll' AND a.field_value = ".$pTable->get('id');
		$db->setQuery($sql);
		$params = new JParameter($db->loadResult());
		if($params->get('result_type', 0))
		{
			$response->script('document.location.href=document.location.href');
			return true;
		}
		

		ob_start();
		require(JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'poll'.DS.'showresults.php');
		$contents = ob_get_clean();
		$response->assign($uid, 'innerHTML', $contents);
		return true;
	}


	/**
	 * This method syncronizes the new options and old options into one array
	 *
	 * @param int $poll_id
	 * @param array $existing the existing options
	 * @param array $new the array of new options
	 * @return array where result=>current options to be saved or updated
	 *                     remove=>items to be removed from the database
	 */
	function syncronizePollOptions($poll_id, $existing, $new)
	{

		$result = array();
		$toRemove = array();
		$count = count($existing);

		for($i = 0; $i < $count; $i++)
		{
			$row = &$existing[$i];
			$found = false;
			foreach($new as $key=>$opt)
			{
				if($opt['id'] == @$row->id)
				{
					$row->text = $opt['text'];
					$found = true;
					unset($new[$key]);
					break;
				}
			}
			if($found)
			{
				$result[] = $row;
			}
			else
			{
				$toRemove[] = $existing[$i];
			}

		}


		foreach($new as $key=> $n)
		{
			$found = false;
			foreach($result as $res)
			{
				if($res->text == $n['text'])
				{
					$found = true;
					break;
				}
			}
			if(!$found && trim($n['text']))
			{

				$obj = new stdClass();
				$obj->id = null;
				$obj->text = $n['text'];
				$obj->votes = 0;
				$obj->poll_id = $poll_id;
				$result[] = $obj;
			}

		}
		return array('result'=>$result, 'remove'=>$toRemove);
	}


	/**
	 * Send the alert to the poll creator
	 *
	 * @param APollPoll $pTable
	 * @param string $type
	 */
	function sendAlert($pTable, $type = 'vote')
	{
		$db= &JFactory::getDBO();
		$sql = "SELECT rv.record_id FROM #__js_res_record_values as rv"
		."\n INNER JOIN #__js_res_fields AS rf ON rf.id = rv.field_id AND rf.type = 'poll'"
		."\n WHERE rv.field_value = ".$pTable->get('id');
		$db->setQuery($sql);
		$article = $db->loadResult();
		//custom($article, $subject, $body, $params = null, $options = array())
		switch($type)
		{
			case 'vote':
				MEAlerts::custom($article, JText::sprintf("User voted for poll %s",$pTable->get('title') ), JText::_('One of the users has voted on your poll'));
				break;

			case 'expire':
				$sql = "SELECT f.params FROM #__js_res_record_values AS a"
				."\n INNER JOIN #__js_res_fields AS f ON a.field_id = f.id"
				."\nWHERE f.type = 'poll' AND a.field_value = ".$pTable->get('id');
				$db->setQuery($sql);
				$params = new JParameter($db->loadResult());


				if(!$pTable->get('exnotesent')
				&& $params->get('allow_set_expire_date')
				&& $params->get('allow_recieve_expire_notice')
				&& $pTable->get('extime') != '0000-00-00 00:00:00')
				{


					$extime = $db->Quote($pTable->get('extime'));
					$sql = 'SELECT NOW() > '.$extime;
					$db->setQuery($sql);
					if($db->loadResult())
					{
						MEAlerts::custom($article, JText::sprintf("The poll %s is finished", $pTable->get('title')), JText::sprintf('The poll %s is finished. The expire date is %s', $pTable->get('title'), $pTable->get('extime')));
						$pTable->set('exnotesent', 1);
						$pTable->store();
					}
				}
				break;
		}

	}

	/**
	 * Get the results for the poll
	 *
	 * @param APollPoll $pTable
	 * @return array of objects
	 */
	function getPollResults(&$pTable)
	{

		$pollResults = $pTable->getResultData();

		//displaying the results of the poll
		$maxval = 0;
		$graphwidth = 200;
		$barheight    = 4;
		$maxcolors    = 5;
		$barcolor     = 0;
		$tabcnt     = 0;
		$colorx     = 0;
		$sumval = $pTable->get('total_votes');
		for($i = 0; $i<count($pollResults); $i++)
		{
			$vote = &$pollResults[$i];
			if($vote->votes > $maxval)
			{
				$maxval = $vote->votes;
			}

		}
		for($i = 0; $i<count($pollResults); $i++)
		{
			$vote = &$pollResults[$i];

			if ($maxval > 0 && $sumval > 0)
			{
				$vote->width    = ceil( $vote->votes * $graphwidth / $maxval );
				$vote->percent = round( 100 * $vote->votes / $sumval, 1 );
			}
			else
			{
				$vote->width    = 0;
				$vote->percent  = 0;
			}

			$vote->class = '';
			if ($barcolor == 0)
			{
				if ($colorx < $maxcolors) {
					$colorx = ++$colorx;
				} else {
					$colorx = 1;
				}
				$vote->class = "polls_color_".$colorx;
			} else {
				$vote->class = "polls_color_".$barcolor;
			}

			$vote->barheight = $barheight;

		}

		return $pollResults;
	}


	function preparePollXML($pollResults, $pTable, $type='pie')
	{
		$result = array();

		$resultXml = '';

		$db = &JFactory::getDBO();
		
		$options = $pTable->get('options', array());
		switch($type)
		{
			case 'ampie':
				$resultXml.='<pie>';

				foreach($pollResults as $vote)
				{
					$resultXml.='<slice title="'.$vote->text.'">'.$vote->votes.'</slice>';
				}
				$resultXml.='</pie>';
                $label1 = '<label lid="0"><x>0</x><y>20</y><rotate>false</rotate><width></width><align>center</align><text_color></text_color><text_size>12</text_size><text><![CDATA[<b>'.$pTable->get('title').'</b>]]></text></label>';
                $label2 = '<label lid="2"><x>10</x><y>45</y><rotate>false</rotate><width></width><align>left</align><text_color></text_color><text_size>12</text_size><text><![CDATA[<small>'.JText::_('Total votes').': '.$pTable->get('total_votes').'</small>]]></text></label>';
                $settings = "<settings><labels>{$label1}{$label2}</labels></settings>";
				break;
			case 'amcolumn':
				$resultXml.='<chart><series>';
				$dataXml = '<graphs>';
				$additional = '<graphs>';
				foreach($pollResults as $key=>$opt)
				{
					$resultXml.='<value xid="'.$key.'">'.$db->getEscaped($opt->text).'</value>';
					
					$dataXml.='<graph gid="'.$key.'" title="'.$db->getEscaped($opt->text).'">';
					$dataXml.='<value xid="'.$key.'">'.$opt->votes.'</value>';
					$dataXml .= '</graph>';
					$additional.='<graph gid="'.$key.'"><balloon_text><![CDATA[{value} for {series}]]></balloon_text></graph>';
				}
                $resultXml.='</series>';
                $additional.="</graphs>";
                
                
                $dataXml .= '</graphs>';

				

				$resultXml.=$dataXml;
				$resultXml.="</chart>";
				
				
				
				$label1 = '<label lid="0"><x>0</x><y>20</y><rotate>false</rotate><width></width><align>center</align><text_color></text_color><text_size>12</text_size><text><![CDATA[<b>'.$pTable->get('title').'</b>]]></text></label>';
                $label2 = '<label lid="2"><x>10</x><y>35</y><rotate>false</rotate><width></width><align>left</align><text_color></text_color><text_size>12</text_size><text><![CDATA[<small>'.JText::_('Total votes').': '.$pTable->get('total_votes').'</small>]]></text></label>';
                
                $settings = '<settings>'.$additional.'<labels>'.$label1.$label2.'</labels></settings>';
                
				break;
			default:
				break;
		}

        $result['data'] = $resultXml;
        $result['settings'] = $settings; 
		return $result;


	}


}




?>
