<?php
/**
 * @fileID: $Id: records.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsRecords extends JPlugin
{
	function plgJoomsuite_content_fieldsRecords( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'records') return;

		global $mainframe;

		$user = & JFactory::getUser();

		if($mainframe->isAdmin() || $user->get('aid') > 1)
		{
			echo JHTML::_('select.booleanlist', "fields[{$obj->id}]", NULL, 1, 'Show', 'Hide' );
		}
		else
		{
			echo "<input type=\"hidden\" name=\"fields[{$obj->id}]\" value=\"1\" />";
		}
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'records') return;
	}

	function onArticleAuthorChange(&$records, $newAuthor) {

	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if(!$field->field_value) return;
		if($field->type != 'records') return;

		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;



		if(JRequest::getVar('option') == 'com_resource' && JRequest::getInt('article') && (JRequest::getVar('view') != 'list'))
		{
			require_once (JPATH_ROOT.DS.'components'.DS.'com_resource'.DS.'api.php');

			$visitor = & JFactory::getUser();

			$options['client'] = 'module';
			$options['limit'] = $params->get('r_limit');
			$options['category'] = $params->get('r_sec_id');
			$options['records_mode'] = 2;
			if($params->get('r_template')) $options['template'] = $params->get('r_template');
			if($params->get('r_orderby')) $options['order'] = $params->get('r_orderby');
			$where = array();
			$join = array();
			$link = 'index.php?option=com_resource';
			$add = ''; if($user) $add = ' AND user_id != '.$user;

			/*
			 * <option value="7">That one who comment this article also comments</option>
			 * <option value="8">That one who rates this article also rates</option>
			 * <option value="9">That one who view this article also visit</option>
			 * <option value="10">That one who favorite this article also favorits</option>
			 * <option value="11">That one who buys this product also buys</option>
			 * <option value="16">Tag Related Articles</option>
			 */
			$options['user_id'] = 0;
			$options['view_what'] = 0;
			switch($params->get('r_type'))
			{
				// Author things
				case 1:
					$options['user_id'] = 0;
					break;
				case 2:
					$options['user_id'] = $user;
					break;
				case 3:
					$options['user_id'] = $user;
					$options['view_what'] = 'favorites';
					break;
				case 4:
					$options['user_id'] = $user;
					$options['view_what'] = 'rated';
					break;
				case 5:
					$options['user_id'] = $user;
					$options['view_what'] = 'commented';
					break;
				case 6:
					$options['user_id'] = $user;
					$options['view_what'] = 'last-visited';
					break;

					// visitor things
				case 12:
					$options['user_id'] = $visitor->id;
					break;
				case 13:
					$options['user_id'] = $visitor->id;
					$options['view_what'] = 'favorites';
					break;
				case 14:
					$options['user_id'] = $visitor->id;
					$options['view_what'] = 'rated';
					break;
				case 15:
					$options['user_id'] = $visitor->id;
					$options['view_what'] = 'commented';
					break;
				case 16:
					$options['user_id'] = $visitor->id;
					$options['view_what'] = 'last-visited';
					break;

				case 7: // that one who comment
					$db = & JFactory::getDBO();
					$query = "SELECT user_id FROM #__js_res_comments WHERE user_id > 0 {$add} AND record_id = " . $field->record_id. " GROUP BY user_id";
					$db->setQuery($query);
					$ids = $db->loadResultArray();
					if(count($ids) > 0)
					{
						$ids =  implode(',', $ids);
						$where[] = "r.user_id IN ({$ids})";
					}
					else
					{
						$out = JText::_('No one yet commented this record');
						return;
					}
					break;
				case 8: // that one who rate
					$db = & JFactory::getDBO();
					$query = "SELECT user_id FROM #__js_res_vote WHERE user_id > 0 {$add} AND record_id = " . $field->record_id. " GROUP BY user_id";
					$db->setQuery($query);
					$ids = $db->loadResultArray();
					if(count($ids) > 0)
					{
						$ids =  implode(',', $ids);
						$where[] = "r.user_id IN ({$ids})";
					}
					else
					{
						$out = JText::_('This record have not beed voted to find related records');
						return;
					}
					break;
				case 9: // that one who view
					$db = & JFactory::getDBO();
					$query = "SELECT user_id FROM #__js_res_hits WHERE user_id > 0 {$add} AND record_id = " . $field->record_id. " GROUP BY user_id";
					$db->setQuery($query);
					$ids = $db->loadResultArray();
					if(count($ids) > 0)
					{
						$ids =  implode(',', $ids);
						$where[] = "r.user_id IN ({$ids})";
					}
					else
					{
						$out = JText::_('No one have viewed this record to find related records');
						return;
					}
					break;
				case 10: // that one who favorite
					$db = & JFactory::getDBO();
					$query = "SELECT user_id FROM #__js_res_favorite WHERE user_id > 0 {$add} AND record_id = " . $field->record_id. " GROUP BY user_id";
					$db->setQuery($query);
					$ids = $db->loadResultArray();
					if(count($ids) > 0)
					{
						$ids =  implode(',', $ids);
						$where[] = "r.user_id IN ({$ids})";
					}
					else
					{
						$out = JText::_('No one have added this record to favorites to find related records');
						return;
					}
					break;



				case 11: // that one who buy
					$out = JText::_('Not yet implemented');
					return;
					break;


				case 17: // tag relation
				case 20: // tag relation
					if($params->get('r_type') == 19 && $user) $options['user_id'] = $user;
					$db = & JFactory::getDBO();
					$query = "SELECT tag_id FROM #__js_res_tags_history WHERE record_id = " . $record->id;
					$db->setQuery($query);
					$ids = $db->loadResultArray();
					if($ids)
					{
						$ids =  implode(',', $ids);
						$join[] = "LEFT JOIN #__js_res_tags_history AS tgh ON tgh.record_id = r.id";
						$where[] = "tgh.tag_id IN ({$ids})";
					}
					else
					{
						$out = JText::_('This record have no tags to find related records');
						return;
					}
					break;
				
				case 18:
				case 21:
				case 19:
					if($params->get('r_field_id') && $params->get('r_field_id2'))
					{
						$id = $params->get('r_field_id');
						$db = & JFactory::getDBO();

						$dispatcher =& JDispatcher::getInstance();
						JPluginHelper::importPlugin( 'joomsuite_content_fields');

						$query = "SELECT v.id as fid, v.record_id, f.id, v.field_value, v.params as vparams, f.filter,
							f.params, f.title, f.type, f.ordering
						FROM #__js_res_record_values as v " .
						' LEFT JOIN #__js_res_fields AS f ON f.id = v.field_id' .
						' WHERE v.record_id = ' . $field->record_id .
						//' AND f.access <= '.$user->get( 'aid', 0 ) .
						//( $show_anywhere == 0 ? ($whole > 0 ? ' AND f.show_detail = 1 ' : ' AND f.show_intro = 1 ') : '').
						' AND f.id = ' . $id .
						' AND f.published = 1 ' .
						' ORDER BY f.ordering ASC'
						;
						//echo $sql;
						$db->setQuery($query);
						$rfield = $db->loadObject();

						if($rfield->field_value)
						{
							$options['user_id'] = 0;
							if($params->get('r_type') == 19 && $user) $options['user_id'] = $user;

							$join[] = "LEFT JOIN #__js_res_record_values AS v{$id} ON v{$id}.record_id = r.id AND v{$id}.field_id = ".$params->get('r_field_id2');

							$dispatcher->trigger( 'onFilterWhere', array (&$sql, $rfield, $rfield, $db->getEscaped($rfield->field_value)));
							if($sql)
							{
								$where[] = $sql;
							}
							else
							{
								$where[] = "v{$id}.field_value LIKE '%".$db->getEscaped($rfield->field_value)."%'";
							}
							$add_link = '&filter'.$id.'='.base64_encode($rfield->field_value);
						}
					}
					else
					{
						$out = JText::_('Field not selected in records field parameters to find related records');
						return;
					}
					break;
			}
			$where[] = 'r.id <> '.$field->record_id;

			if(in_array($params->get('r_type'), array(12,13,14,15,16)) && !$visitor->id)
			{
				if($params->get('r_no_login'))
				{
					$out = 	$params->get('r_no_login');
				}
				else
				{
					$out = false;
				}
				return;
			}

			$list = MightyResourcesApi::getRecordList($options, $where, $join, $tmp, $tmp);

			if(count($list[0]) <= 0 )
			{
				if($params->get('r_no_records'))
				{
					$out = 	$params->get('r_no_records');
				}
				else
				{
					$out = false;
				}
				return;
			}

			$out = $list[1];

			if($params->get('r_show_all'))
			{
				$link = MEUrl::link_list($params->get('r_sec_id'), array('user_id' => $options['user_id'], 'view_what' => $options['view_what'])).@$add_link;

				//if($params->get('r_show_all_iid')) $link = '&Itemid='.$params->get('r_show_all_iid');
				$link = MERoute::_($link);
				$out .= "<div class=\"readonbox\"><a class=readon href=\"{$link}\">".$params->get('r_show_all_text')."</a></div>";
			}
		}
	}
}