<?php
/**
 * @fileID: $Id: relate_child2.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted Access');

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsRelate_child2 extends JPlugin
{
	var $data;

	/**
	 * Dumb value for child articles, do not change cuz it is used in relate_parent.
	 *
	 * @var string
	 */
	var $DUMB_VALUE = '__PLG_RC_DUMB_';
	var $ADD_EXISTING_TRIGGER = 'anotherabracadabra';

	function plgJoomsuite_content_fieldsRelate_child( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		require_once JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'relate_helper.php';
	}


	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'relate_child2') return;

		if( !$params->get('parent_type') ) {
			echo JText::_( 'This field is not configured. Please set parent relate field in params of this field' );
			return;
		}

		$user 	= & JFactory::getUser();
		$db		= & JFactory::getDBO();
		require_once JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'relate_helper.php';
		$helper = & Relate_Fields_Helper_v1::getInstance();

		// If we are being added as a child:
		if( JRequest::getInt('child_field', 0) && JRequest::getInt('parent_article', 0) ) {
			$sql = " SELECT r.title"
			."\n   FROM #__js_res_record AS r"
			."\n  WHERE r.id = ".JRequest::getInt('parent_article', 0);
			$db->setQuery( $sql );
			$result = $db->loadResult();
			// If no such article, throw a warning
			if ($result === null)
			JError::raiseWarning('REL_001', JText::_('Parent article does not exist'));
			else {
				echo $result;
				echo "<input type='hidden' value='".JRequest::getInt('parent_article', 0)."' name='fields[".$obj->id."][add]'>";
			}
			return;
		}

		$orderby		= $params->get('parent_ordering', 'r.ctime ASC' );
		$parentType 	= $params->get('parent_type');
		$childFieldId 	= $obj->id;
		
		$strictToUser 	= $params->get('strict_to_user', array());
		settype($strictToUser, 'array');
		
		$strictToUser = in_array($user->get('gid'), $strictToUser);
//		// Public users don't have strict to user mode, to avoid errors.
//		if ($user->guest)
//			$strictToUser = false;
		// Superadmins don't have strict to user mode
		if ($user->get('gid') == 25)
			$strictToUser = false;
			
		// check, if field value is empty
		if (intval($obj->field_value))
			$flag = 'r.id IN ('.$obj->field_value.') AS flag ';
		else
			$flag = '0 AS flag ';
		
		$andWhere = array();
		
		// Filtering by expiration.
		$timeWhere = $helper->_getTimeWhereSQL($params);
		if ($timeWhere)
			$andWhere [] = $timeWhere;
		// Other filters..
		if (!in_array($user->get('gid'), array(23, 24, 25)))
			$andWhere [] = 'r.published = 1'; 
		if ($user->get('id') && $strictToUser)
			$andWhere [] = 'r.user_id = '.$user->get('id');
	
		// Category Client filters 	
		$catid 	= JRequest::getInt('category_id', 0);
		$section_id = ResHelper::getCategorySection($catid);
		
		$sec_params = ResHelper::getSectionParams($section_id);
		$cat_params = ResHelper::getSectionParams($catid);
		
		$sectionClients = $cat_params->get('list_clients', $sec_params->get('list_clients', 0));
		
		if ( ! $params->get('show_other_clients') || $sectionClients) {
			$client = JRequest::getString('client', 'resource');
			
			if ($client) {
				if ($client == 'resource')
					$andWhere [] = '(r.client = "resource" OR r.client = \'\')';
				else
					$andWhere [] = 'r.client = '.$db->Quote($client);
			}
		}
		
		
		if (count($andWhere))
			$andWhere = ' AND '.implode(' AND ', $andWhere);
		else
			$andWhere = '';
		
		$sql = "SELECT r.id, r.title, $flag "
		."\n    FROM    #__js_res_record      AS r "
		."\n  LEFT JOIN #__js_res_types       AS t ON t.id = r.type_id"
		."\n      WHERE t.published = 1 AND r.type_id = $parentType ".$andWhere
		.' GROUP BY r.id '
		." ORDER BY $orderby ";
		
		$db->setQuery( $sql );
		//echo $db->_sql;
		$result = $db->loadObjectList();

		if( !$result ) $result = array();
			$parentRequired = $params->get('required_relate', 'n') == 'y';

		$options[] = JHTML::_( 'select.option', '', "- ".JText::_("Select")." -", 'value', 'text', $parentRequired );

		$selected = array();
		foreach( $result as $record ) {
			$options[] = JHTML::_( 'select.option', $record->id, $record->title );
			if ($record->flag)
				$selected[] = $record->id;
		}

		$multiple = $params->get('multi_parented', 1) ? 'multiple' : '';
		echo $html[] = JHTML::_( 'select.genericlist', $options, "fields[".$obj->id."][]", $multiple, 'value', 'text', $selected );
		echo "<input type='hidden' value='".$this->DUMB_VALUE."' name='fields[".$obj->id."][]'>";
			
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'relate_child2')
			return;
		if(!$value)
			return;
		// Here is how the plugin uses `#__js_res_field_extra` table:
		//
		//		`user_id` int(10) unsigned NOT NULL default '0', // parent_type
		//  	`field_id` int(10) unsigned NOT NULL default '0', // child field id
		//  	`field_value_id` int(10) unsigned NOT NULL default '0', // child record id
		//  	`record_id` int(10) unsigned NOT NULL default '0', // Parent record id

		$db = & JFactory::getDBO();

		$add = false;
		// We gonna be ADDED to a parent article
		if (isset($value['add'])) {
			$value = $value['add'];
			$add = true;
		}

		if (!is_array($value))
			$value = array($value);
		$value = array_diff($value, array($this->DUMB_VALUE));

		if (!$add) {
			// Check "parent required" options
			if ($params->get('required_relate', 'n') == 'y' && !count($value)) {
				$error = true;
				JError::raiseWarning('R12', JText::_('Parent article is not selected'));
				return;
			}
				
			// Clear the previous relations
			$q = 'DELETE FROM #__js_res_field_extra WHERE user_id = '.(int)$params->get('parent_type') .
				' AND field_id = '.$id .' AND field_value_id = '.$row->id;
			$db->setQuery( $q );
			$db->query();
		}

		// Insert the new relations.
		if (count($value)) {
			$q = 'INSERT INTO #__js_res_field_extra (`user_id`, `ref_id`, `ctime`, `ip`, `value`, `field_id`, `field_value_id`, `record_id`) VALUES ';
			$vals = array();
			foreach ($value as $v) {
				$vals[] = '('.$params->get('parent_type').', "", NOW(), "'.$_SERVER['REMOTE_ADDR'].'", "", '.
				$id.', '.$row->id.', '.(int)$v.')';
			}
			$q .= implode(', ', $vals);
				
			$db->setQuery( $q );
			$db->query();
		}

		$value = implode(',', $value);
		
		if (empty($value))
			$value = $this->DUMB_VALUE;
		
		require_once JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'relate_helper.php';
		$helper = & Relate_Fields_Helper_v1::getInstance();
		$helper->emptyCache();
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		
	
		global $mainframe;
		
		if( !$field->field_value || $field->field_value == $this->DUMB_VALUE)
			return;
			
		if( $type != 'relate_child2' )
			return;
		
		$TTL = 1;
		// Check the nesting level (TTL)
		if (isset($field->ttl)) {
			// exit if TTL is zero or negative
			if ($field->ttl <= 0)
			return;

			$TTL = $field->ttl;
		}
		else {
			$TTL = $params->get('TTL', 0);
		}
		$TTL--;

		$db	= &JFactory::getDBO();
		$curUser = & JFactory::getUser();
		
		require_once JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'relate_helper.php';
		$helper = & Relate_Fields_Helper_v1::getInstance();

		$parent_limit       = $params->get('limit', 20 );

		if (!$parent_limit)
			$parent_limit = 99999;

		$orderby            = $params->get('parent_ordering', 'r.ctime ASC' );
		$bots               = explode( ",", $params->get( 'bots', '' ) );
		$item_id            = $params->get('link_itemid', JRequest::getInt( 'Itemid' ) );
		$url_add_new        = $params->get('url_add_new', '' );
		$invite_view_more   = $params->get('invite_view_more', "See more..." );
		$invite_add_more    = $params->get('invite_add_more', "Add new" );
		$jschildrelatefield = $params->get('show_relate_field', 0);
		$parent_type		= $params->get('parent_type', 0);
		$strict_to_user		= $params->get('strict_to_user', 0);
		$category_id		= $params->get('category_id', 0);
		$add_existing		= $params->get('add_existing', 0);

		// module parameter
		$categoryFilter		= $params->get('allowed_cat');
		
		$addNewAccess			= $params->get('add_more_access', 1);
		if ($addNewAccess == 'none')
			$addNewAccess = false;
		else {
			$addNewAccess = $curUser->get('aid') >= $addNewAccess;
			if ($curUser->get('id') == $user)
				$addNewAccess = true;
		}

		settype($strict_to_user, 'array');
		$strict_to_user = in_array($curUser->get('gid'), $strict_to_user);
		
		// Public users don't have strict to user mode, to avoid errors.
		if ($curUser->guest)
			$strict_to_user = false;
		// Superadmins don't have strict to user mode
		if ($curUser->get('gid') == 25)
			$strict_to_user = false;

		if ($categoryFilter) {
			$categoryFilter = explode(',', $categoryFilter);
			JArrayHelper::toInteger($categoryFilter);
			$categoryFilter = array_unique($categoryFilter);
		}

		if ($add_existing == 'none') {
			$add_existing = false;
		}
		else {
			$add_existing = $add_existing <= $curUser->get('aid');
			if ($curUser->get('id') == $user)
				$add_existing = true;
		}
		
		// Add a parent via 'add new'
		$lastId 	= JRequest::getInt('lastid');
		$childId 	= JRequest::getInt('child_id');
		
		if ($lastId && $childId && $field->fid == $childId) {
			$db = & JFactory::getDBO();
			$db->setQuery('SELECT type_id FROM #__js_res_record WHERE id = '.$lastId);
			$parentType = $db->loadResult();
			
			// Create the relation
			$this->createRelation($lastId, $field->record_id, $field->fid, $parentType, $field->field_value);
			
			$fieldValue = trim(str_replace($this->DUMB_VALUE, '', $field->field_value), ', ');
			$fieldValue = explode(',', $fieldValue);
			$fieldValue [] = $lastId;
			
			$field->field_value = implode(',', $fieldValue);
			
			$helper->emptyCache();
		}

		// ---------------  START: Add the new parents %)) ---
		$requestData = JRequest::getVar('fields', null, 'post');
		if (isset($requestData[$field->fid]))
		$requestData = $requestData[$field->fid];

		// Test if we gonna save the new relations.
		if (isset($requestData[$this->ADD_EXISTING_TRIGGER]) &&
			isset($requestData['child']) &&
			$requestData['child'] == $field->record_id &&
			isset($requestData['parents']) &&
			$requestData[$this->ADD_EXISTING_TRIGGER] == $this->ADD_EXISTING_TRIGGER)
		{
			// Save the new child now...
			JArrayHelper::toInteger($requestData['children']);
			$requestData['children'] = array_unique($requestData['children']);

			// If got any children to save:
			if (count($requestData['parents'])) {

				$db = & JFactory::getDBO();
				$db->setQuery('SELECT type_id FROM #__js_res_record WHERE id = '.$field->record_id);
				$type_id = $db->loadResult();

				// Create the relation
				$this->createRelation($requestData['parents'], $field->record_id, $field->fid, $parent_type, $field->field_value);

				// Unset the triggering flag.
				$_POST['fields'][$field->fid][$this->ADD_EXISTING_TRIGGER] = 'ihopeyouwillnoteverhavethisvariableinthepostarray'.uniqid('adfdf', true);

				JArrayHelper::toInteger($requestData['parents']);
				$field->field_value = trim(str_replace($this->DUMB_VALUE, '', $field->field_value), ', ');
				$field->field_value .= ','.implode(',', $requestData['parents']);

				// --- Increment the rating of current article:
				$addScore 		= $params->get('add_rating') && $params->get('num_votes', 1);
				if ($addScore && !$curUser->guest) {
					$howManyTimes 	= $params->get('num_votes', 1);
					$howMuch 		= $params->get('score');
						
					$helper->addRating($curUser->get('id'), $field->record_id, $howMuch, $howManyTimes);
				}
				
				$helper->emptyCache($type);
			}
		}
		// ---------------  END: Add the new children %)) ---

		$catid 	= JRequest::getInt('category_id', JRequest::getInt('section_id', 0));
		
		// Restore stuff from cache
		$info 			= null;
		$relatedRecords = null;
		$relatedFields 	= null;
		$ids			= null;
		
		if (empty($parent_type))
		{
			JError::raiseNotice('REL_CH1', ucfirst($type).': '.JText::_('Please select the parent type'));
		}
		
		$fromCache = $helper->getFieldCache($field, $params, $type, $user, $catid);
		
		if ($fromCache) {
			$fromCache = @unserialize($fromCache);
			
			if (isset($fromCache['relatedRecords']))
				$relatedRecords = $fromCache['relatedRecords'];
			if (isset($fromCache['relatedFields']))
				$relatedFields = $fromCache['relatedFields'];
		}
		
		
		foreach ($bots as $key => $bot)
			$bots[$key] = trim( $bot );
			
		// Got no parent type set? Then just halt.
		if (!$parent_type)
			return;
			
		// Make the client where clause
		$clientWhere = '';

		if ( ! $params->get('show_other_clients'))
		{
			if (!$helper->isShowAllCategoryClients($catid)) {
				// Get the record client
				$q = 'SELECT client FROM #__js_res_record WHERE id = '.$field->record_id;
				$db->setQuery( $q );
				$client = $db->loadResult();
				
				if ($client == 'resource' || $client == '')
					$clientWhere = ' AND (r.client = "resource" OR r.client = "") ';
				else
					$clientWhere = ' AND r.client = '.$db->Quote($client);
			}
		}
		
		$fieldValue = trim(str_replace($this->DUMB_VALUE, '', $field->field_value), ', ');
		
		$timeWhere = $helper->_getTimeWhereSQL($params);

		if (!empty($fieldValue)) {
			if (is_null($relatedRecords)) {
				// Select all parents.
				$sql = '/* RCH */ SELECT r.id, r.title, rc.catid AS category_id, r.user_id '.
					'FROM #__js_res_record AS r '.
						'LEFT JOIN #__users AS u '.
							'ON u.id = r.user_id '.
						'LEFT JOIN #__js_res_types AS t '.
							'ON t.id = r.type_id '.
						'LEFT JOIN #__js_res_fields AS f '.
							' ON f.type_id = t.id '.
						'LEFT JOIN #__js_res_record_values AS v '.
							'ON v.field_id = f.id AND v.record_id = r.id '.
						'LEFT JOIN #__js_res_record_category AS rc '.
							'ON rc.record_id = r.id '.
					'WHERE r.published = 1 AND t.published = 1 AND '.
		            	'f.published = 1 AND '.
		            	'r.type_id = '.	$parent_type. ' AND '.
						'r.id IN ('.$fieldValue.')'.
						(is_array($categoryFilter) ? ' AND rc.catid IN ('.implode(',', $categoryFilter).') ' : '').
						($timeWhere ? ' AND '.$timeWhere : '').
						$clientWhere.
					'GROUP BY '.
						'r.id '.
					'ORDER BY '.
				$orderby.
				// Here + 1 is a counting hack to avoid double querying db
				( in_array( $_SERVER['HTTP_USER_AGENT'] , $bots ) ? '' : ' LIMIT 0, '.($parent_limit + 1) );
	
				$db->setQuery( $sql );
					
				$relatedRecords = $db->loadObjectList();
			}
		}
		else
			$relatedRecords = array();
			
		$total_parents = count($relatedRecords);

		// Counting hack to avoid double querying db
		if ($total_parents > $parent_limit)
			array_pop($relatedRecords);

		// Halt if nothing to show.
		if (!$total_parents) {
			$out = JText::_('No items');
		}
		else
		{
			for ($i = 0, $count = count($relatedRecords); $i < $count; $i++) {
				$href = JRoute::_("index.php?option=com_resource&controller=article&article={$relatedRecords[ $i ]->id}&category_id=".$relatedRecords[ $i ]->category_id."&Itemid=".$item_id);
				$relatedRecords[ $i ]->link = $href;
				$relatedRecords[ $i ]->ntitle = JHTML::link($href, $relatedRecords[ $i ]->title);
			}	
			
			if (is_null($relatedFields)) {
				// Prepare the fields.
				$recordIds = array();
				foreach ( $relatedRecords as $r )
					$recordIds[] = $r->id;
				
				$relatedFields = & $helper->jsGetFieldValue($jschildrelatefield, $recordIds, $params->get('relate_field_order', array()), $TTL, $categoryFilter);
			}

			// Render via template
			$template = $params->get('template', 'default');
				
			$listThreshold = $params->get('list_threshold');
				
			if ($listThreshold && $listThreshold <= count($relatedRecords)) {
				$template = 'compact';
			}
			
			// Set helper options for generating controls
			$helper->set('isParent', 		false);
			$helper->set('childFieldId', 	$field->fid);
			$helper->set('childRecordId', 	$field->record_id); 
			$helper->set('parentType', 		$parent_type);
			$helper->set('owner',			$user);
			// There are lots of parents in list :)
			$helper->set('parentRecordId',		false);
				
			$out .= $helper->loadTemplate($template, $relatedFields, $relatedRecords, $params, $field);
		}

		// Set the cache
		if (!$fromCache) {
			$toCache = array(
				'relatedRecords' => $relatedRecords,
				'relatedFields' => 	$relatedFields
			);
			
			$helper->setFieldCache($field, $params, $type, $user, $catid, serialize($toCache));
		} 

		// If the user didn't provide category id, extract it.
		if (!$category_id) {
			if( $relatedRecords ) {
				$category_id = ResHelper::getArticleSection($relatedRecords[0]->id);
			} else {
				$category_id = JRequest::getInt( 'category_id' );
			}
		}

		// The additional buttons like "see more", "add new", etc.
		$controls = array();

		if ( $invite_view_more && ($total_parents > count($relatedRecords))
			|| (count($relatedRecords) && $params->get('always_show_view_more')) 
		) 
		{
			$controls [] = ' <a class="readon" href="'.
				JRoute::_(  "index.php?option=com_resource"
					."&view=list"
					."&category_id=".$category_id
					."&child_field=".$field->fid
					."&child_record=".$field->record_id
					.'&view_what=related'
					."&Itemid=".$item_id
				).
			    '">'.$invite_view_more.'</a> ';
		}

		//		$out .= '</td><td nowrap="nowrap">';

		if ($addNewAccess && $url_add_new) {
			$uri = & JURI::getInstance();
			
			$oldFid = $uri->setVar('child_id', $field->fid);
			$lastid = $uri->getVar('lastid');
			$uri->delVar('lastid');
			
			(strstr($url_add_new, '?')) ?
			$href = $url_add_new.'&redirect='.base64_encode($uri->toString()):
			$href = $url_add_new.'?redirect='.base64_encode($uri->toString());
			//$href = $url_add_new.'&child_field='.$field->fid.'&child_article='.$field->record_id :
			//$href = $url_add_new.'?child_field='.$field->fid.'&child_article='.$field->record_id ;
			//$uri = & JURI::getInstance();
			//$href .= '&redirect='.urlencode(base64_encode($uri->toString()));
			if (JRequest::getString('view') == 'list') 
				$href .= '#flag'.$field->record_id;
			
			$uri->setVar('child_field', $oldFid);
			if ($lastid)
				$uri->setVar('lastid', $lastid);
			
			$controls[] = ' <a class="readon" href="'.JRoute::_($href).'">'.$invite_add_more.'</a> ';
		}

		if ($params->get('multi_parented', 1) && $add_existing)
		{
			$uid = uniqid('relation');
				
			ob_start();
			?>
			<script>
			// The "add existing" popup. 
			var popupChik<?php echo $uid; ?> = null;
			var parent<?php echo $uid; ?> = null;
			// The popup state [0, 1] = [hidden, visible]
			var popupChikState<?php echo $uid; ?> = 0;
			
			function popup<?php echo $uid; ?>(who) {
				if (!popupChik<?php echo $uid; ?>) {
					// Create the popup if not exists 
					var d = document.createElement('div');
					d.id = 'add_existing_popup_<?php echo $uid; ?>';
					// Set the HTML popupData 
					d.innerHTML = '<img src="<?php echo JURI::root(); ?>plugins/joomsuite_content_fields/images/relate_fields/loading.gif" />';
					
					rel_par_arrangeExistingPopup(who, d);
					
					popupChik<?php echo $uid; ?> = d;
					parent<?php echo $uid; ?> = who;

					// Load the Related records that can be added.
					xajax_jsCallPlugin(
							'joomsuite_content_fields', 
							'relate_child2', 
							'onXajaxGetExistingRecords', 
							[
								'<?php $uri = & JURI::getInstance(); echo addslashes($uri->toString()); ?>', <?php echo $field->id?>, 
								d.id, 'popup<?php echo $uid; ?>(null);', 'rel_par_xajaxCallback<?php echo $uid; ?>();'
							]
					);
				}
				
				// Toggle the PoPuP:1  	   	  com_community 
				if (popupChikState<?php echo $uid; ?> == 1)
					popupChik<?php echo $uid; ?>.style.display = 'none';
				else 
					popupChik<?php echo $uid; ?>.style.display = 'block';

				popupChikState<?php echo $uid; ?> = 1 - popupChikState<?php echo $uid; ?>;
			}

			function rel_par_xajaxCallback<?php echo $uid; ?>() {
				rel_par_arrangeExistingPopup(parent<?php echo $uid; ?>, popupChik<?php echo $uid; ?>);
			}
			
			function rel_par_arrangeExistingPopup(parent, target) {
				// p = The element being clicked.
				var p = parent;
				var top = 0, left = 0;
				for ( ; p; p = p.offsetParent ){
			        top  += p.offsetTop;
			        left += p.offsetLeft;
				}
				
				top -= parent.offsetHeight + 5;
									
				document.body.appendChild( target );
				target.style.zIndex = '99999';
				target.style.position = 'absolute';
				target.style.background = '';
				
				top -= target.offsetHeight;
				left += parent.offsetWidth;
				left -= target.offsetWidth;
				
				target.style.top = top + 'px';
				target.style.left = left + 'px';
			}
			
			</script>
<a class="readon" href="javascript:void(0);"
	onclick="popup<?php echo $uid; ?>(this);"><?php echo JText::_($params->get('add_existing_label', 'Add existing...')); ?></a>
			<?php
			$controls[] = ob_get_contents();
			ob_end_clean();
		}

		if (count($controls)) {
			$out .= '<table align="right"><tr><td nowrap="nowrap">';
			$out .= implode('</td><td nowrap="nowrap">', $controls);
			$out .= '</td></tr></table>';
		}
	}
	
	function onXajaxGetExistingRecords(&$objResponse, $url, $recordValueId, $targetElementId, $onClick, $callBack) {
			$db 		= & JFactory::getDBO();
			$curUser 	= & JFactory::getUser();
			require_once JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'relate_helper.php';
			$helper 	= & Relate_Fields_Helper_v1::getInstance();
		
			// Load the field
			$query = "SELECT ".
				" v.id, v.field_value, v.record_id, f.id as fid, f.params, f.type
				FROM 			#__js_res_record_values as v " .
				' LEFT JOIN 	#__js_res_fields AS f 			ON f.id = v.field_id' .
				' WHERE v.id = ' . $recordValueId;
			
			$db->setQuery($query);
			$field = $db->loadObject();
			$field->field_value = trim(str_replace('__PLG_RC_DUMB_', '', $field->field_value), ', ');
			 
			// Init field params
			$params 		= new JParameter($field->params);
			$parent_type	= $params->get('parent_type', 0);
			$url_add_new        = $params->get('url_add_new', '' );
			$jschildrelatefield = $params->get('show_relate_field', 0);
			
			$strict_to_user	= $params->get('strict_to_user', 0);
			settype($strict_to_user, 'array');
			
			$strict_to_user = in_array($curUser->get('gid'), $strict_to_user);
			// Public users don't have strict to user mode, to avoid errors.
			if ($curUser->guest)
				$strict_to_user = false;
			// Superadmins don't have strict to user mode
			if ($curUser->get('gid') == 25)
				$strict_to_user = false;
			
			// Make the client where clause
			$clientWhere = '';
			$catid 	= 0;
			
			$q = 'SELECT catid FROM #__js_res_record_category WHERE record_id = '.$field->record_id.' LIMIT 1';
			$db->setQuery( $q );
			$catid = $db->loadResult();
			
			if ( ! $params->get('show_other_clients')) {
				if ($catid && !$helper->isShowAllCategoryClients($catid)) {
					// Get the record client
					$q = 'SELECT client FROM #__js_res_record WHERE id = '.$field->record_id;
					$db->setQuery( $q );
					$client = $db->loadResult();
					
					if ($client == 'resource' || $client == '')
						$clientWhere = ' AND (r.client = "resource" OR r.client = "") ';
					else
						$clientWhere = ' AND r.client = '.$db->Quote($client);
				}
			}
						        
            // Filter articles by expiration/creation dates 
			$timeWhere = $helper->_getTimeWhereSQL($params);
            
            $sql = "/* RCH */ SELECT r.id, r.title"
			."\n       FROM #__js_res_record          AS r"
			."\n  LEFT JOIN #__js_res_types           AS t    ON t.id = r.type_id"
			."\n  LEFT JOIN #__js_res_record_category AS rc   ON rc.record_id = r.id"
			."\n WHERE r.published = 1 AND t.published = 1 AND ".
	          	'r.type_id = '.$parent_type .
			($strict_to_user ? ' AND r.user_id = '.$curUser->get('id') : '').
			(!empty($field->field_value) ? ' AND r.id NOT IN ('.$field->field_value.') ' : ' ').
			($timeWhere ? ' AND '.$timeWhere : '').
			$clientWhere.
			"\n  GROUP BY r.id".
			' ORDER BY r.title';

			$db->setQuery( $sql );
			$result = $db->loadObjectList();
				
			// Let's add some javascript magic here..
			ob_start();
			?>
			<form action="<?php echo $url; ?>" method="post">
			<p><?php echo JText::_('Select'), ':'; ?></p>
			<div style="clear: both"></div>
				<?php if (count($result)) : ?> 
					<select	size="<?php echo min($params->get('add_existing_select_size', 10), count($result)); ?>"
					name="fields[<?php echo $field->fid; ?>][parents][]" multiple>
					<?php
					foreach ($result as $r) {
						echo '<option value="', $r->id, '">', $r->title,'</option>';
					}
					// Enable "Add" button
					$disableAdd = false;
					?>
				</select> 
				<?php else: ?>
					 <b><?php echo JText::_('No items to add'); ?></b>
				<?php 
					// Disable "Add" button
					$disableAdd = true;		
				endif; ?>
			 <br />
			<br />
			<input type="hidden" name="fields[<?php echo $field->fid; ?>][<?php echo $this->ADD_EXISTING_TRIGGER; ?>]" value="<?php echo $this->ADD_EXISTING_TRIGGER; ?>" /> 
			<input type="hidden" name="fields[<?php echo $field->fid; ?>][child]" value="<?php echo $field->record_id; ?>" /> 
			<input type="hidden" name="fields[<?php echo $field->fid; ?>][parent_type]"	value="<?php echo $parent_type; ?>" />
			<div>
			<div style="float: left"><input
			<?php if ($disableAdd) echo ' disabled="disabled" '; ?> type="submit"
				class="button" value="<?php echo JText::_('Add'); ?>" /></div>
			<div style="float: right"><input type="button" class="button"
				value="<?php echo JText::_('Close'); ?>"
				onclick="<?php echo $onClick; ?>" /></div>
			</div>
			</form>
			<?php
			$popupData = ob_get_clean();
            
            $objResponse->assign($targetElementId, "innerHTML", $popupData);
            if ($callBack)
            	$objResponse->script($callBack);
	}
	
	/**
	 * Creates a relation between articles.
	 *
	 * @param mixed $parent_article
	 * @param int $child_article
	 * @param int $child_field
	 * @param int $type
	 * @return boolean
	 */
	function createRelation($parent_article, $child_article, $child_field, $type, $child_field_value) {
		$db = & JFactory::getDBO();

		$debug = false;

		if ($debug) {
			$log = fopen('relation.txt', 'a');
			fwrite($log, '---- LOG START ----'."\n");
			ob_start();
			echo '$parent_article, $child_article, $child_field, $type, $child_field_value', "\n";
			var_dump($parent_article, $child_article, $child_field, $type, $child_field_value);
			fwrite($log, ob_get_clean()."\n");
		}

		if ($child_field && $child_article && $parent_article && $type) {
				
			if (is_array($parent_article))
			$parent_article = array_unique($parent_article);
			else
			$parent_article = array($parent_article);

			JArrayHelper::toInteger($parent_article);
				
			$q = '/* RCH */ SELECT COUNT(*) '.
				'FROM #__js_res_record '.
				'WHERE id IN ('.implode(',', $parent_article).') '.
				'AND type_id = '.$type;
			$db->setQuery( $q );
			$count = $db->loadResult();
				
			$debug && fwrite($log, "For query: ".$db->getQuery()."\n");
			$debug && fwrite($log, "Count = $count\n");
				
			// If the child article(s) exist, create the relation.
			if ($count && $count == count($child_article)) {
				// Insert the new relation.
				$q = 'INSERT INTO #__js_res_field_extra '.
					'(`user_id`, `ref_id`, `ctime`, `ip`, `value`, `field_id`, `field_value_id`, `record_id`) VALUES ';

				$values = array();
				foreach ($parent_article as $a) {
					$values[] = '('.$type.', "", NOW(), "'.$_SERVER['REMOTE_ADDR'].'", "", '.
					$child_field.', '.$child_article.', '.$a.')';
				}

				$q .= implode(',', $values);

				$db->setQuery( $q );
				$debug && fwrite($log, "Query = ".$db->getQuery()."\n");

				$db->query();

				// Update the child field value, put the parent article id there.
				// Note: smart update here... __PLG_RC_DUMB_

				$child_field_value = explode(',', str_replace($this->DUMB_VALUE, '', $child_field_value));
				JArrayHelper::toInteger($child_field_value);

				$toInsert = array_unique(array_merge($child_field_value, $parent_article));
				$toInsert = (count($toInsert)) ? implode(',', $toInsert) : $this->DUMB_VALUE;

				$q = "UPDATE `#__js_res_record_values` b SET b.field_value = ".$db->Quote($toInsert).
					'WHERE b.field_id = '.$child_field.' AND b.record_id = '.$child_article;
				$db->setQuery( $q );
				$debug && fwrite($log, "Query = ".$db->getQuery()."\n");
				$db->query();

				// Everything is OK now..
				$debug && fclose($log);
				return true;
			}
		}
		$debug && fclose($log);
		return false;
	}
	
	function onXajaxDeleteArticleRelation(&$response, $childFieldId, $childRecordId, $parentType, $parentRecordId, $callback)  {
		require_once JPATH_PLUGINS.DS.'joomsuite_content_fields'.DS.'relate_helper.php';
			
		$helper = & Relate_Fields_Helper_v1::getInstance();
		
		$res = $helper->deleteArticleRelation($childFieldId, $childRecordId, $parentType, $parentRecordId);
		if ($res === true)
		{
			$response->script($callback);
		}
		else 
		{
			$response->alert(JText::_('Error. Cannot delete record'));
			
			$args = func_get_args();
			array_shift($args);
			$response->alert(implode(', ', $args));
			$response->alert($res);
		}
		
		
		$helper->emptyCache();
	}
	
	function _addRating($userId, $recordId, $howMuch, $howManyTimes) {
		$userId 		= (int)$userId;
		$recordId 		= (int)$recordId;
		$howMuch 		= min((int)$howMuch, 100);
		$howManyTimes 	= (int)$howManyTimes;

		$db = & JFactory::getDBO();

		$q = "INSERT INTO #__js_res_vote VALUES (NULL, '{$userId}', '$recordId', '$howMuch', NOW())";

		for ($i = 0; $i < $howManyTimes; $i++) {
			$db->setQuery( $q );
			echo $db->query();
			die;
			$db->query();
		}
	}
}