<?php
/**
 * @fileID: $Id: relate_helper.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined('_JEXEC') or die('Restricted Access');

/**
 * Related fields helper.
 * @author Nurlan
 *
 */
class Relate_Fields_Helper_v1 extends JObject
{
	/**
	 * Returns RelateFieldHelper instance.
	 * @return Relate_Fields_Helper_v1
	 */
	function & getInstance() {
		static $instance = 0;
		if (!$instance) {
			$instance = new Relate_Fields_Helper_v1();
		}
		return $instance;
	}
	
	var $_cache = array(); 
	
	/**
	 * Renders field, and returns it's value
	 *
	 * @param mixed $fieldIds Field ids
	 * @param mixed $recordIds  the article to display
	 * @param int $TTL the nesting level for related fields (a bad parameter don't touch if not sure %)) )
	 * @param mixed $categoryFilter The categories that are allowed to display for related fields (a bad parameter don't touch if not sure %)) )
	 * @return array Rendered fields, indexed by record_ids, and field_ids. 
	 */
	function & jsGetFieldValue( $fieldIds, $recordIds, $ordering, $TTL = 2, $categoryFilter = null )
	{
		$db			=& JFactory::getDBO();
		
		settype($recordIds, 'array');
		settype($fieldIds, 'array');
		settype($ordering, 'array');
		
		if ($categoryFilter) {
			settype($categoryFilter, 'array');
			JArrayHelper::toInteger($categoryFilter);
			$categoryFilter = array_unique($categoryFilter);
		}
		
		JArrayHelper::toInteger($recordIds);
		$recordIds = array_unique($recordIds);
		
		JArrayHelper::toInteger($fieldIds);
		$fieldIds = array_unique($fieldIds);
		
		$signature = implode('.', $fieldIds).'__'.implode('.', $recordIds).'_'.implode('.', $ordering).$TTL;
		if ($categoryFilter)
			$signature .= implode('.', $categoryFilter);
			
		$signature = md5($signature);
		
		if (!empty($this->_cache[$signature]))
			return $this->_cache[$signature];
			
		$order = array();
		for ($i = 0, $count = count($ordering); $i < $count; $i += 2) {
			list($id, $title) = explode('%_%%_%%_%', $ordering[ $i ]);
			$order[(int)$id] = (int)$ordering[$i + 1];
		}
		
		ksort($order);
		

		$sql  = "SELECT v.`id`,
			f.access,
			f.id AS fid,
			f.`type_id`,
			f.`type`,
			f.`params`,
			f.`title`,
			r.user_id AS author_id,
			v.`field_value`,
			r.id as record_id,
			rc.id AS category_id,
			v.`params` AS fparams" 
			."\n      FROM #__js_res_fields AS f "
			."\n LEFT JOIN #__js_res_record_values AS v ON v.field_id = f.id"
			."\n LEFT JOIN #__js_res_record        AS r ON r.id = v.record_id "
			."\n LEFT JOIN #__js_res_record_category AS rc ON r.id = rc.record_id "
			."\n     WHERE f.id IN ( ".implode(',', $fieldIds)." ) AND f.published > 0 AND v.record_id IN (".implode(',', $recordIds).") "
			.($categoryFilter ? ' AND rc.catid IN ('.implode(', ', $categoryFilter).') ' : '')
			."\n  ORDER BY r.id ASC ";

		$db->setQuery( $sql );

		$fields_for_show = $db->loadObjectList();
		
		if( !is_array($fields_for_show) || !count($fields_for_show) ) {
			///
			$temp = array();
			return $temp;
		}
		
		// Hydrate the returned array of fields, into easy-to-use array.
		$theFields = array();

		foreach ($fields_for_show as $field) {
			$rid = $field->record_id;
			if (empty($theFields[ $rid ]))
				$theFields[ $rid ] = array();
			
			if (in_array($field->type, array('relate_parent2', 'relate_child2'))) {
				if ($categoryFilter) {
					$p = new JParameter($field->params);
					
					$p->set('allowed_cat', implode(', ', $categoryFilter));
					$field->params = $p->toString();
				}
				// Set the TTL for related fields.
				$field->ttl = $TTL;
			}
			$theFields[ $rid ][ $field->fid ] = $field;
		}
			
		// Free some memory %))
		unset($fields_for_show);
		
		
		// Render the fields now.
		$result = array();
		
		foreach ($theFields as $rid => $fields) 
		{	
			$result[ $rid ] = array();
			
			foreach ($fields as $fid => $field_for_show) 
			{
				$get = '';
		
				$field_for_show_params = new JParameter( $field_for_show->params."\n".$field_for_show->fparams);
				$dispatcher =& JDispatcher::getInstance();
				JPluginHelper::importPlugin( 'joomsuite_content_fields', $field_for_show->type );
		
				$current_controller = JRequest::getWord('controller');
				$current_view       = JRequest::getWord('view');
		
				switch( $field_for_show->type ) {
					case 'picture':
						JRequest::setVar('controller', 'list' );
						JRequest::setVar('view',       'list' );
						$field_for_show_params->set( 'align', 'bottom' );
						break;
					case 'html':
						JRequest::setVar('view',       'list' );
						break;
				}
				
				// Remove the ugly buttons :)
				if (in_array($field_for_show->type, array('relate_child2', 'relate_parent2'))) 
				{
					$field_for_show_params->set( 'url_add_new', 0 );
					$field_for_show_params->set( 'add_existing', 0 );
					$field_for_show_params->set( 'invite_view_more', 0 );
					$field_for_show_params->set( 'invite_add_more', 0 );
				}
				
				$field_for_show_params->set('tabled', 0);
				$field_for_show_params->set('show_lable', 0);
				$field_for_show_params->set('show_icon', 0);
                
				$list = JModel::getInstance('Article', 'ResModel');
                $record = $list->getArticle($field_for_show->record_id);
				
				
			    $dispatcher->trigger( 'onRenderFieldValue', array (&$get, &$field_for_show, &$record, $field_for_show->category_id), $field_for_show->type);
				//$dispatcher->trigger( 'onRenderFieldValue', array (&$get, & $field_for_show, $field_for_show_params, $field_for_show->type, $field_for_show->author_id ) );
				
			    
				JRequest::setVar('controller', $current_controller );
				JRequest::setVar('view',       $current_view );
				
				//echo htmlspecialchars($get).'<br><br>';
				
				if (!empty($get)) {
					if (isset($order[$fid]))
						$result[$rid][$order[$fid]] = array('text' => $get, 'field' => $field_for_show);
					else
						$result[$rid][] = array('text' => $get, 'field' => $field_for_show);
				}
			}
			
			ksort($result[$rid]);
		}
		
		$this->_cache[$signature] = $result;
		
		return $this->_cache[$signature];
	}
	
	/**
	 * 
	 * @param $field
	 * @param $params
	 * @param $type
	 * @param $userId
	 * @param $stuff
	 * @return unknown_type
	 */
	function getFieldCache(&$field, &$params, $type, $userId, $stuff) {
		$curUser	= & JFactory::getUser();
		$lang 		= & JFactory::getLanguage();
		
		jimport ('joomla.cache.cache');
		
		$conf 		= & JFactory::getConfig();
		$caching 	= $params->get('caching', 2) == 2 ? $conf->getValue('config.caching') : $params->get('caching');
		$cachetime	= $params->get('caching', 2) == 2 ? $conf->getValue('config.cachetime') : $params->get('cachetime');
		
		if ($caching) {
			$cacheGroup = 'plg_'.$type;
			$signature 	= $this->_getSignature($field, $params, $type, $userId, $stuff);
			
			$options = array(
				'lifetime' => $cachetime * 60, // minutes to seconds
				'language' => $lang->getTag(),
				'storage' => 'file'
			);
			
			$cache 		= & JCache::getInstance('output', $options);
			$cache->setCaching($caching);
			
			return $cache->get($signature, $cacheGroup);
		}
		
		return false;
	}
	
	function setFieldCache(&$field, &$params, $type, $userId, $stuff, $cachedData) {
		$curUser	= & JFactory::getUser();
		$lang 		= & JFactory::getLanguage();
		
		jimport ('joomla.cache.cache');
		
		$conf 		= & JFactory::getConfig();
		$caching 	= $params->get('caching', 2) == 2 ? $conf->getValue('config.caching') : $params->get('caching');
		$cachetime	= $params->get('caching', 2) == 2 ? $conf->getValue('config.cachetime') : $params->get('cachetime');
		
		if ($caching) {
			$cacheGroup = 'plg_'.$type;
			$signature 	= $this->_getSignature($field, $params, $type, $userId, $stuff);
			
			$options = array(
				'lifetime' => $cachetime * 60, // minutes to seconds
				'language' => $lang->getTag(),
				'storage' => 'file'
			);
			
			$cache 		= & JCache::getInstance('output', $options);
			$cache->setCaching( 1 );
			return $cache->store($cachedData, $signature, $cacheGroup);
		}
		
		return false;
	}
	
	function emptyCache($type = false) {
		$lang = & JFactory::getLanguage();
		$options = array(
			'language' => $lang->getTag(),
			'storage' => 'file'
		);
		
		jimport ('joomla.cache.cache');
		
		$cacheGroup = 'plg_relate_parent2';
		$cache 		= & JCache::getInstance('output', $options);
		$cache->clean($cacheGroup);
		
		$cacheGroup = 'plg_relate_child2';
		$cache 		= & JCache::getInstance('output', $options);
		$cache->clean($cacheGroup);
	}
	
	function _getSignature(&$field, &$params, $type, $userId, $stuff) {
		$lang 		= & JFactory::getLanguage();
		
		$fSig = '';
		foreach ($field as $k => $v) {
			if (!is_object($v) && !is_resource($v)) {
				$fSig .= $v;
			}
		}
		
		$cacheGroup = 'plg_'.$type;
		$signature 	= 'related_'.$type.md5($params->toString().$fSig.$userId.serialize($stuff));
			
		return $signature;
	}
	
	/**
	 * Loads template for related fields
	 * @param $template string template name
	 * @param $relatedFields array of rendered fields
	 * @param $relatedRecords array of records
	 * @param $params JParameter field params
	 * @return string Rendered HTML
	 */
	function loadTemplate($template, &$relatedFields, &$relatedRecords, &$params) 
	{	
		$templateFile = JPATH_ROOT.DS.'plugins'.DS.'joomsuite_content_fields'.DS.'related_fields_templates'.DS.$template.'.php';
		jimport ('joomla.filesystem.file');
		if (!JFile::exists($templateFile))
			JError::raiseError('R_01', JText::_('Cannot find template').' : '.$template.' <b>plugins'.DS.'joomsuite_content_fields'.DS.'related_fields_templates'.DS.$template.'.php</b> is missing ');
		
		$item_id    = $params->get( 'link_itemid', JRequest::getInt( 'Itemid' ) );
		$document	= & JFactory::getDocument();
		$document->addStyleSheet(JURI::root().'components/com_resource/helpers/style.css');
		
		// Enable javascript for controls
		JHTML::_('behavior.mootools');

		// unique css class for records to use with javascript
		$this->set('relatedRecordCssClass', uniqid('rel_'));
		$this->set('uid', uniqid('rel_controls'));
		$this->includeControlsJavascript($params);
		
		// INCLUDE the template
		ob_start();
		include $templateFile;
		
		$out = ob_get_contents();
		ob_end_clean();
		
		return $out;
	}
	
	/**
	 * Fetches control buttons for displaying in template, must be used with Relate_Fields_Helper_v1::includeControlsJavascript
	 * @param $record The related record
	 * @param $params JParameter Field params
	 * @return string
	 */
	function getControlButtons($record, &$params) {
		$itemId = $params->get('link_itemid', JRequest::getInt('Itemid'));
		$toPrint = array();
		
		if (!$this->_checkControlButtonAccess($params))
			return '';
		
		if ($params->get('show_edit_button', 1)) {
			$editLink = JRoute::_('index.php?option=com_resource&controller=article&article='.$record->id.'&category_id='.$record->category_id.'&view=article&layout=form&Itemid='.$itemId);
			$toPrint[] = '<a href="'. $editLink. '">' . JText::_('Edit') .'</a>';
		}
		if ($params->get('show_delete_button', 1)) {
			$toPrint[] = '<a href="javascript:void(0)" rel="'.$record->id.'">' . JText::_('Detach') .'</a>';
		}
		
		if (empty($toPrint))
			return '';
		return '<span style="filter: alpha(opacity:0); opacity: 0; padding-left: 10px" class="small relatedRecordsControlBar"> '. implode(' | ', $toPrint). ' </span>';
	}
	
	/**
	 * Include the javascript for controls, must first define $this->uid.
	 * @param $params
	 * @return unknown_type
	 */
	function includeControlsJavascript(& $params) {
		static $registered = 0;
		if (!$registered) 
			$registered = array();
		
		$uid = $this->get('uid');
		
		if (!$this->_checkControlButtonAccess($params))
			return '';
		
		// Check if javascript is already included.
		if (isset($registered[ $uid ]))
			return;
		$registered[ $uid ] = 1;
		
		if ($params->get('show_edit_button', 1) || $params->get('show_delete_button', 1)) {
			ob_start();
			?>
			// Used by xajax as callback
			function delete_related_record<?php echo $uid; ?>(recordId) {
				$$('li.<?php echo $this->get('relatedRecordCssClass'); ?>').each(function( e ) {
					if (e.getProperty('rel') == recordId) {
						var myFx = new Fx.Style(e, 'opacity', {duration: 400});
						var fxHeight = new Fx.Style(e, 'height', {duration: 400});
						
						myFx.start(1, 0).chain(
						function() {
							fxHeight.start(e.offsetHeight, 0).chain(
								function() {
									e.remove();
								}
							);
						});
					}
				});
			}
			
			window.addEvent('domready', function() {
				$$('li.<?php echo $this->get('relatedRecordCssClass'); ?>').each(function( e ){
					var els = $E('span.relatedRecordsControlBar', e);
					if (els[ 0 ])
						els = els[ 0 ];
			
					if (els) {
						e.addEvent('mouseover', function()  {
							els.setStyle('opacity', 1);
						});
						e.addEvent('mouseout', function()  {
							els.setStyle('opacity', 0);
						});
					}
				});
			});
			<?php
			
			$document = & JFactory::getDocument();
			$document->addScriptDeclaration(ob_get_contents());
			ob_end_clean();
		}
	}
	
	/**
	 * Includes events for each related record
	 * @param $params JParameter
	 * @param $record
	 * @param $callback string Javascript code
	 * @return unknown_type
	 */
	function includeEventsJavascript(& $params, & $record, $callback = false) 
	{	
		if (!$this->_checkControlButtonAccess($params))
			return false;
		
		$uid = $this->get('uid');
		
		if (!$callback)
			$callback = '\'delete_related_record'.$uid.'(\' + i.rel + \')\'';
		
		// Set the child/parent record id for generating controls 
		if ($this->get('isParent'))
			$this->set('childRecordId', $record->id);
		else
			$this->set('parentRecordId', $record->id);
		
		if ($params->get('show_edit_button', 1) || $params->get('show_delete_button', 1)) {
			ob_start();
			?>
			window.addEvent('domready', function() {
				$$('li.<?php echo $this->get('relatedRecordCssClass'); ?>').each(function( e ){
					$ES('a', e).each(function( i ) {
						if ( i.rel == <?php echo $record->id; ?> ) {
							i.addEvent('click', function() {
								if (confirm('<?php echo addslashes(JText::_('Detach?')); ?>')) {
									xajax_jsCallPlugin(
										'joomsuite_content_fields', 
										'relate_child2',
										'onXajaxDeleteArticleRelation', 
										[ 
											<?php echo (int)$this->get('childFieldId'); ?>,	
											<?php echo (int)$this->get('childRecordId'); ?>, 
											<?php echo (int)$this->get('parentType'); ?>,
											<?php echo (int)$this->get('parentRecordId'); ?>, 
											<?php echo $callback; ?>
										]
									);
								}
							});
						}
					})
				});
			});
			<?php
			
			$document = & JFactory::getDocument();
			$document->addScriptDeclaration(ob_get_contents());
			ob_end_clean();
		}
	}
	
	function includeEventsJavascriptForCompactTemplate(&$params) {
		$params->get('show_edit_button');
		$params->get('show_delete_button');
		
		if (!$this->_checkControlButtonAccess($params) || 
			(!$params->get('show_edit_button') && !$params->get('show_delete_button'))
		)
			return '';
		
		ob_start();
?>
		window.addEvent('domready', function() {
			$$('span.<?php echo $this->get('relatedRecordCssClass'); ?>').each(function( e ) {
				e.addEvent('mouseover', function() {
					JS_Rel_Controls_v1.captureElement( e );
					JS_Rel_Controls_v1.displayControls( e );
				});
				e.addEvent('mouseout', function() {
					JS_Rel_Controls_v1.hideControls();
				});
			});
		});
<?php
		$document = & JFactory::getDocument();
		$document->addScriptDeclaration(ob_get_clean());
		
		$document->addScript(JURI::root().'plugins/joomsuite_content_fields/related_fields_templates/compact.js');
	}
	
	/**
	 * Returns the javascript for 'compact' template
	 * @param $params
	 * @param $record
	 * @param $callback
	 * @return unknown_type
	 */
	function getCompactModeJson(& $params, & $record, $callback = false) {
		if (!$this->_checkControlButtonAccess($params))
			return '';
		
		if (!$callback)
			$callback = 'javascript:void(0);';
		
		// Set the child/parent record id for generating controls 
		if ($this->get('isParent'))
			$this->set('childRecordId', $record->id);
		else
			$this->set('parentRecordId', $record->id);
			
		$deleteFunction = "['joomsuite_content_fields',	'relate_child2', 'onXajaxDeleteArticleRelation',[". 
			$this->get('childFieldId').",".(int)$this->get('childRecordId').",".(int)$this->get('parentType').",".
			(int)$this->get('parentRecordId').",'".$callback."']]";
			
		$itemId = $params->get('link_itemid', JRequest::getInt('Itemid'));	
		$editLink = JRoute::_('index.php?option=com_resource&controller=article&article='.$record->id.'&category_id='.$record->category_id.'&view=article&layout=form&Itemid='.$itemId);
		
		$options = array();
		if ($params->get('show_edit_button', 1))
			$options [] = 'edit: 1';
		else
			$options [] = 'edit: 0';
		if ($params->get('show_delete_button', 1))
			$options [] = 'del: 1';
		else
			$options [] = 'del: 0';
			
		return ('{deleteFunction: '.$deleteFunction.', editLink: \''.$editLink.'\', controls: {'.implode(',', $options).'}}');
	}
	
	/**
	 * Delete relation between articles.
	 * 
	 * @param $childFieldId
	 * @param $childRecordId
	 * @param $parentType
	 * @param $parentRecordId
	 * @return unknown_type
	 */
	function deleteArticleRelation($childFieldId, $childRecordId, $parentType, $parentRecordId) {
		// Here is how the related fields use `#__js_res_field_extra` table:
		//
		//		`user_id` int(10) unsigned NOT NULL default '0', // parent_type
		//  	`field_id` int(10) unsigned NOT NULL default '0', // child field id
		//  	`field_value_id` int(10) unsigned NOT NULL default '0', // child record id
		//  	`record_id` int(10) unsigned NOT NULL default '0', // Parent record id
		$db = & JFactory::getDBO();
		
		$childRecordValueId = 0;
		$q = 'SELECT rv.id FROM `#__js_res_record_values` AS rv WHERE rv.record_id = '.(int)$childRecordId .' AND rv.field_id = '.(int)$childFieldId;
		$db->setQuery( $q );
		$childRecordValueId = $db->loadResult();
		
		if (!$childRecordValueId)
			return false;
		
		$q = 'DELETE FROM `#__js_res_field_extra` WHERE user_id = '.(int)$parentType.' AND field_id = '.(int)$childFieldId.
			' AND field_value_id = '.(int)$childRecordId. ' AND record_id = '.(int)$parentRecordId;

		$db->setQuery( $q );
		
		if (!$db->query())
			return false;
			
		$q = 'SELECT field_value FROM `#__js_res_record_values` AS rv WHERE rv.id = '.$childRecordValueId;
		$db->setQuery( $q );
		$fieldValue = $db->loadResult();
		
		$fieldValue = explode(',', $fieldValue);
		JArrayHelper::toInteger($fieldValue);
		
		$key = array_search($parentRecordId, $fieldValue);
		if ($key !== false) {
			unset($fieldValue[ $key ]);
		}
		
		if (!count($fieldValue))
			$fieldValue = '__PLG_RC_DUMB_';
		else
			$fieldValue = implode(',', $fieldValue);
		
		// Update child record values.
		$q = 'UPDATE #__js_res_record_values AS b '.
		' SET b.field_value = '.$db->Quote($fieldValue).
		' where b.id = '.$childRecordValueId;
		
		$db->setQuery( $q );
		if (!$db->query())
			return false;
		
		return true;
	}
	
	/**
	 * Add rating to given articles
	 * @param $userId
	 * @param $recordIds
	 * @param $howMuch
	 * @param $howManyTimes
	 * @return unknown_type
	 */
	function addRating($userId, $recordIds, $howMuch, $howManyTimes) {
		static $fieldCount = false;
		
		$userId 		= (int)$userId;
		$howMuch 		= min((int)$howMuch, 100);
		$howManyTimes 	= (int)$howManyTimes;
		
		settype($recordIds, 'array');
		JArrayHelper::toInteger($recordIds);
		
		if (!$howManyTimes)
			return;
		
		$db = & JFactory::getDBO();
		
		if ($fieldCount === false) {
			$db->setQuery('DESCRIBE #__js_res_vote');
			$res = $db->loadObjectList();
			
			$fieldCount = count($res);
		}
		
		$q = "INSERT INTO #__js_res_vote VALUES ";
		
		$values = array();
		
		foreach ($recordIds as $recordId) {
			$insert = "(NULL, '{$userId}', '$recordId', '$howMuch', NOW() ";
			if ($fieldCount == 6)
				$insert .= ', '.$db->Quote($_SERVER['REMOTE_ADDR']).")";
			else
				$insert .= ')';
			
			
			for ($i = 0; $i < $howManyTimes; $i++) {
				$values [] = $insert;
			}
		}
		
		$db->setQuery( $q. implode(',', $values) );
		$db->query();
	}
	
	function isShowAllCategoryClients($catid) {
		// Category Client filters
		$sectionShowAllClients = false;
		if ($catid) {
			$section_id = ResHelper::getCategorySection($catid);
			
			$sec_params = ResHelper::getSectionParams($section_id);
			$cat_params = ResHelper::getSectionParams($catid);
			
			$sectionShowAllClients = $cat_params->get('list_clients', $sec_params->get('list_clients', 0));
		}
		
		return $sectionShowAllClients;
	}
	
	/**
	 * Fetches the SQL filter by publish/expire dates
	 * @param $params JParameter
	 * @return unknown_type
	 */
	function _getTimeWhereSQL(&$params) {
		// Filter articles by expiration/creation dates 
		$timeWhere = array();
		if ($params->get('show_record_future', 1))
			$timeWhere [] = '(NOW() < r.ctime)';
			
		if ($params->get('show_record_current', 1))
			$timeWhere [] = '(r.ctime < NOW() AND (NOW() < r.extime OR r.extime = "0000-00-00 00:00:00"))';
			
		if ($params->get('show_record_expired', 1))
			$timeWhere [] = '(r.extime < NOW() AND r.extime <> "0000-00-00 00:00:00")';
			
		if (count($timeWhere) == 3)
			$timeWhere = '';
		elseif (count($timeWhere))
			$timeWhere = ' (' .implode(' OR ', $timeWhere) .') ';
		else
			$timeWhere = ' 0 ';
		
		return $timeWhere;
	}
	
	/**
	 * 
	 * @param $record
	 * @param $params JParameter
	 * @return unknown_type
	 */
	function _checkControlButtonAccess(&$params)
	{
		$user = & JFactory::getUser();
		$isOwner = ($user->get('id') == $this->get('owner', -1));
		$access = $params->get('control_buttons_access', 1);
		
		if (!$isOwner) {
			if ($user->get('aid') < $access)
				return false;
		}
		return true;
	}
}

?>
