<?php
/**
 * @fileID: $Id: relate_helper3.php 7799 2012-02-13 06:44:52Z kostya $
 * @changedDate: $LastChangedDate: 2012-02-13 13:44:52 +0700 (Пн, 13 фев 2012) $
 * @changedBy: $LastChangedBy: kostya $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined ('_JEXEC') or die('Restricted access');

/**
 * Related fields helper.
 * @author Nurlan
 *
 */
class FieldRelateHelper extends JObject
{
	function __construct() {
		parent::__construct();
	}
	
	/**
	 * Returns RelateFieldHelper instance.
	 * @return Relate_Fields_Helper_v3
	 */
	function & getInstance() {
		static $instance = 0;
		if (!$instance) {
			$instance = new FieldRelateHelper();
		}
		return $instance;
	}
	
	function getControlButtons($id, &$params) {
		$itemId = $params->get('link_itemid', JRequest::getInt('Itemid'));
		$toPrint = array();
		
		if (!$this->_checkControlButtonAccess($params))
			return '';
		
		if ($params->get('show_edit_button', 1)) {
			$editLink = JRoute::_('index.php?option=com_resource&controller=article&article='.$id.'&category_id='.$params->get('category_id').'&view=article&layout=form&Itemid='.$itemId);
			//$toPrint[] = '<a href="'. $editLink. '">' . JText::_('Edit') .'</a>';
		}
		if ($params->get('show_delete_button', 1)) {
			$toPrint[] = '<a href="javascript:void(0)" rel="'.$id.'">' . JText::_('Detach') .'</a>';
		}
		
		if (empty($toPrint))
			return '';
		return '<span style="filter: alpha(opacity:0); opacity: 0; padding-left: 10px" class="small relatedRecordsControlBar3"> '. implode(' | ', $toPrint). ' </span>';
	}
	
	/**
	 * Include the javascript for controls, must first define $this->uid.
	 * @param $params
	 * @return unknown_type
	 */
	function includeControlsJavascript(& $params) {
		static $registered = 0;
		if (!$registered) 
			$registered = array();
		
		$uid = $this->get('uid');
		
		if (!$this->_checkControlButtonAccess($params))
			return '';
		
		// Check if javascript is already included.
		if (isset($registered[ $uid ]))
			return;
		$registered[ $uid ] = 1;
		
		if ($params->get('show_edit_button', 1) || $params->get('show_delete_button', 1)) {
			ob_start();
			?>
			// Used by xajax as callback
			function delete_related_record<?php echo $uid; ?>(recordId) {
				$$('li.<?php echo $this->get('relatedRecordCssClass'); ?>').each(function( e ) {
					if (e.getProperty('rel') == recordId) {
						var myFx = new Fx.Style(e, 'opacity', {duration: 400});
						var fxHeight = new Fx.Style(e, 'height', {duration: 400});
						
						myFx.start(1, 0).chain(
						function() {
							fxHeight.start(e.offsetHeight, 0).chain(
								function() {
									e.remove();
								}
							);
						});
					}
				});
			}
			
			window.addEvent('domready', function() {
				$$('li.<?php echo $this->get('relatedRecordCssClass'); ?>').each(function( e ){
					var els = $E('span.relatedRecordsControlBar3', e);
					if (els[ 0 ])
						els = els[ 0 ];
			
					if (els) {
						e.addEvent('mouseover', function()  {
							els.setStyle('opacity', 1);
						});
						e.addEvent('mouseout', function()  {
							els.setStyle('opacity', 0);
						});
					}
				});
			});
			<?php
			
			$document = & JFactory::getDocument();
			$document->addScriptDeclaration(ob_get_contents());
			ob_end_clean();
		}
	}
	
	/**
	 * Includes events for each related record
	 * @param $params JParameter
	 * @param $record
	 * @param $callback string Javascript code
	 * @return unknown_type
	 */
	function includeEventsJavascript(&$params, $id, $callback = false) 
	{	
		if (!$this->_checkControlButtonAccess($params))
			return false;
		
		$uid = $this->get('uid');
		
		if (!$callback)
			$callback = '\'delete_related_record'.$uid.'(\' + i.rel + \')\'';
		
		// Set the child/parent record id for generating controls 
		if ($this->get('isParent'))
			$this->set('childRecordId', $id);
		else
			$this->set('parentRecordId', $id);
		
		if ($params->get('show_edit_button', 1) || $params->get('show_delete_button', 1)) {
			ob_start();
			?>
			window.addEvent('domready', function() {
				$$('li.<?php echo $this->get('relatedRecordCssClass'); ?>').each(function( e ){
					$ES('a', e).each(function( i ) {
						if ( i.rel == <?php echo $id; ?> ) {
							i.addEvent('click', function() {
								if (confirm('<?php echo addslashes(JText::_('Detach?')); ?>')) {
									xajax_jsCallPlugin(
										'joomsuite_content_fields', 
										'relate_child3',
										'onXajaxDeleteArticleRelation', 
										[ 
											<?php echo (int)$this->get('childFieldId'); ?>,	
											<?php echo (int)$this->get('childRecordId'); ?>, 
											<?php echo (int)$this->get('parentType'); ?>,
											<?php echo (int)$this->get('parentRecordId'); ?>, 
											<?php echo $callback; ?>
										]
									);
								}
							});
						}
					})
				});
			});
			<?php
			
			$document = & JFactory::getDocument();
			$document->addScriptDeclaration(ob_get_contents());
			ob_end_clean();
		}
	}
	
    function _checkControlButtonAccess(&$params)
	{
		$user = & JFactory::getUser();
		$isOwner = ($user->get('id') == $this->get('owner', -1));
		$access = $params->get('control_buttons_access', 1);
		
		if (!$isOwner) {
			if ($user->get('aid') < $access)
				return false;
		}
		return true;
	}
	
	function getDecoratedList($list, $params)
	{
	    JHTML::_('behavior.mootools');

		// unique css class for records to use with javascript
		$this->set('relatedRecordCssClass', uniqid('rel_'));
		$this->set('uid', uniqid('rel_controls'));
		$this->includeControlsJavascript($params);
		$li_class = $this->get('relatedRecordCssClass');
		
		$class = $params->get('ul_class', '');
		if ($class)
			$class = ' class="'.$class.'" ';
		else
			$class = '';
		$html = '';
						
        /*if(count($list) > 1)*/ $html = '<ul'.$class.'>';
        foreach ( $list as $li )
        {	
        		
        	/*if(count($list) > 1)*/ $html .= '<li class="'.$li_class.'" rel="'.$li->id.'">';
        	$html .= $li->link;
        	
        	$this->includeEventsJavascript($params, $li->id);
        	
        	// "Edit | Remove from list" controls
        	$controlButtons = $this->getControlButtons($li->id, $params);
        	if ($controlButtons)
        		$html .= $controlButtons;
        	

        	/*if(count($list) > 1)*/ $html .= '</li>';
        }

       /*if(count($list) > 1)*/ $html .= '</ul>';
       return $html;
	}
	
}