var SRElementHelper =
{
  "background" : null,
  "tmp_div" : null,
  "td_container" : null,
  "param_id" : null,
  "dump_values" : null,
  "buttonsTd" : null,
  "add_img_path" : "",
  "remove_img_path" : "",
  "lang_ROOT" : "ROOT",
  "lang_child" : "child",
  "lang_sibling" : "sibling",
  "lang_remove" : "remove",
  "lang_cancel" : "cancel",
  "lang_apply" : "apply",
  
  setParams : function ( params )
  {
    for( var key in params ) {
      this[key] = params[key];
    }
  },
  
  switchToConstructor : function( )
  {
    this.hidingBody();
    this.createConstructorView( );
  },
  
  hidingBody : function ()
  {
    if( this.tmp_div == null ) {
      this.tmp_div = document.createElement( "div" );
    }
    this.tmp_div.style.display = "none";
    this.tmp_div.id = "felix_sr_tmp_div"; 
    
    var exception = 0;
    while( document.body.childNodes.length > exception ) {
      if( document.body.childNodes[exception] == this.tmp_div || document.body.childNodes[exception] == this.background  ) {
        exception ++;
        continue;
      }
      this.tmp_div.appendChild( document.body.childNodes[exception] );
    }
    document.body.appendChild( this.tmp_div );
  },
  
  createConstructorView : function ()
  {
    this.createBackground();
    this.createConstructorContainer();
    
    this.dump_values = this.parseValues();
    
    this.createValuesTree();
    this.createApplyCancelButtons();
  },
  
  createValuesTree : function ()
  {
    var first_branch_value_div = document.createElement( "div" );
    first_branch_value_div.id = "felix_sr_constructor_value_null";
    
    first_branch_value_div.appendChild( document.createTextNode( this.lang_ROOT ) );
    first_branch_value_div.style.paddingLeft = "30px";
    first_branch_value_div.style.paddingRight = "2px";
    
    first_branch_value_div.appendChild( this.createAddButtons( null ) );
    
    var first_branch_children_div = document.createElement( "div" );
    
    first_branch_children_div.id = "felix_sr_constructor_children_null";
    first_branch_children_div.style.textAlign = "left";
    
    first_branch_value_div.appendChild( first_branch_children_div );
    this.td_container.appendChild( first_branch_value_div );
    this.drawBranch( null );
  },
  
  getIndexesByParent : function ( parent )
  {
    var result = new Array();
    for( var key = 0; this.dump_values.length > key; key ++ ) {
      if( this.dump_values[key].parent == parent ) {
        result[result.length] = key;
      }
    }
    return result;
  },
  
  drawBranch : function ( parent )
  {
    var current_indexes = this.getIndexesByParent( parent );
    
    var div_id = 'felix_sr_constructor_children_' + parent;
    
    var div = document.getElementById( div_id );
    
    for( var key = 0; current_indexes.length > key; key ++ ) {
      var cindex = current_indexes[key];
      var new_value_div = document.createElement( 'div' );
      new_value_div.appendChild( document.createTextNode( this.dump_values[cindex].value ) );
      new_value_div.style.paddingLeft = "30px";
      new_value_div.style.paddingRight = "2px";
      new_value_div.id = "felix_sr_constructor_value_" + cindex;
      
      new_value_div.appendChild( this.createAddButtons( cindex, this.dump_values[cindex].parent ) );
      new_value_div.appendChild( this.createRemoveButtons( cindex ) );
      
      var new_subvalue_div = document.createElement( 'div' ); 
      new_subvalue_div.id = "felix_sr_constructor_children_" + cindex;
      
      new_value_div.appendChild( new_subvalue_div );
      
      div.appendChild( new_value_div );
       
      if( this.dump_values[cindex].children ) {
        this.drawBranch( cindex );
      }
    }
  },
  
  createAddButtons : function ( index, parent_index )
  {
    var buttons_span = document.createElement( "span" );
    
    buttons_span.appendChild( document.createTextNode( "  " ) );
    
    var button_addChild = document.createElement( "a" );
    
    var addChild_img = document.createElement( "img" );
    addChild_img.src = this.add_img_path;
    addChild_img.align = "absmiddle";
    button_addChild.appendChild( addChild_img );
    
    button_addChild.href = "javascript:SRElementHelper.addNew( "+index+" )";
    button_addChild.appendChild( document.createTextNode( this.lang_child ) );
    buttons_span.appendChild( button_addChild );
    
    if( typeof parent_index != "undefined" ) {
      buttons_span.appendChild( document.createTextNode( " " ) );
    
      var button_addSister = document.createElement( "a" );
      
      var addSiter_img = document.createElement( "img" );
      addSiter_img.src = this.add_img_path;
      addSiter_img.align = "absmiddle";
      button_addSister.appendChild( addSiter_img );
      
      button_addSister.href = "javascript:SRElementHelper.addNew( " + parent_index + " )";
      button_addSister.appendChild( document.createTextNode( this.lang_sibling ) );
      buttons_span.appendChild( button_addSister );
    }
    
    buttons_span.appendChild( document.createTextNode( " " ) );
    return buttons_span;
     
  },
  
  createRemoveButtons : function ( index )
  {
    var buttons_span = document.createElement( "span" );
    
    buttons_span.appendChild( document.createTextNode( " " ) );
    
    var button_addChild = document.createElement( "a" );
    
    var remove_img = document.createElement( "img" );
    remove_img.src = this.remove_img_path;
    remove_img.align = "absmiddle";
    button_addChild.appendChild( remove_img );
    
    button_addChild.href = "javascript:SRElementHelper.remove( " + index + " )";
    button_addChild.appendChild( document.createTextNode( this.lang_remove ) );
    buttons_span.appendChild( button_addChild );
    buttons_span.appendChild( document.createTextNode( " " ) );
    
    return buttons_span;
  },
  
  addNew : function ( parent )
  {

    var div_id = 'felix_sr_constructor_children_' + parent;
    
    var div = document.getElementById( div_id );
    
    var cindex = this.dump_values.length;
    
    if( parent == null ) {
      var level = 1;
    } else {
      var level = this.dump_values[parent].level + 1;
      this.dump_values[parent].children = true;
    }
    
    this.dump_values[cindex] = { 'value' : "", 'level' : level, 'parent' : parent, "children" : false, "removed" : false, "is_new" : true };
    
    var new_value_div = document.createElement( 'div' );
    
    var field = document.createElement( "input" );
    field.type = "text";
    field.id = 'felix_sr_newvalue_' + cindex;
    
    new_value_div.appendChild( field );
    new_value_div.style.paddingLeft = "30px";
    new_value_div.style.paddingRight = "2px";
    new_value_div.id = "felix_sr_constructor_value_" + cindex;
    
    new_value_div.appendChild( this.createAddButtons( cindex, this.dump_values[cindex].parent ) );
    new_value_div.appendChild( this.createRemoveButtons( cindex ) );
    
    var new_subvalue_div = document.createElement( 'div' ); 
    new_subvalue_div.id = "felix_sr_constructor_children_" + cindex;
    
    new_value_div.appendChild( new_subvalue_div );
    
    div.appendChild( new_value_div );    
  },
  
  remove : function ( index ) 
  {
    this.dump_values[index].removed = true;
    
    var div = document.getElementById("felix_sr_constructor_value_" + index );
    div.parentNode.removeChild( div );
  },
  
  createApplyCancelButtons : function ()
  {
    var applyButton = document.createElement( "span" );
    applyButton.appendChild( document.createTextNode( this.lang_apply ) );
    applyButton.style.background = "#D4D0C8";
    applyButton.style.padding = "3px";
    applyButton.style.paddingLeft = "10px";
    applyButton.style.paddingRight = "10px";
    
    var link_apply = document.createElement( "a" );
    link_apply.href = "javascript:SRElementHelper.apply()";
    link_apply.appendChild( applyButton );

    this.buttonsTd.appendChild( link_apply );
    
    this.buttonsTd.appendChild( document.createTextNode( " " ) );
    
    var cancelButton = document.createElement( "span" );
    cancelButton.appendChild( document.createTextNode( this.lang_cancel ) );
    cancelButton.style.background = "#D4D0C8";
    cancelButton.style.margin = "2px";
    cancelButton.style.padding = "3px";
    cancelButton.style.paddingLeft = "10px";
    cancelButton.style.paddingRight = "10px";
    
    var link_cancel = document.createElement( "a" );
    link_cancel.href = "javascript:SRElementHelper.cancel()";
    link_cancel.appendChild( cancelButton );
    
    this.buttonsTd.appendChild( link_cancel );
  }, 
  
  setEvent : function( element, event, f )
  {
    if( element.addEventListener && navigator.appName != 'Opera' ) {
      element.addEventListener( event, f, true);
    } else {
      element.attachEvent( 'on'+event, f);
    }
  },
  
  createConstructorContainer : function ()
  {
    var table = document.createElement( 'table' );
    table.height = "100%";
    table.border = 1;
    table.style.margin = "0 auto";
    var tr = document.createElement( "tr" );
    table.appendChild( tr );
    this.td_container = document.createElement( "td" );
    tr.appendChild( this.td_container );
    
    this.td_container.valign = "middle";
    this.td_container.id = "felix_sr_container";
    this.td_container.style.background = "#FFFFFF";
    this.td_container.style.overflow = "auto";
    
    var buttonsTr = document.createElement( "tr" );
    this.buttonsTd = document.createElement( "td" );
    this.buttonsTd.style.border = "none";
    table.appendChild( buttonsTr );
    buttonsTr.appendChild( this.buttonsTd );
    
    this.background.appendChild( table );    
  },
  
  createBackground : function ()
  {
    if( this.background == null ) {
	  this.background = document.createElement( "div" );
	  this.background.style.background = "#8080aa";
	  this.background.id="felix_sr_background_div";
	  document.body.appendChild( this.background );
    }
    this.background.style.display = "block";
  },
  
  cancel : function ()
  {
    this.switchToTextarea();
  },
  
  apply : function ()
  {
    this.refreshTextareaValues();
    this.switchToTextarea();
  },
  
  switchToTextarea : function ()
  {
    this.destroyConstructorView();
    
    while( this.tmp_div.childNodes.length > 0 ) {
      document.body.appendChild( this.tmp_div.childNodes[0] );
    }    
  },
  
  refreshTextareaValues : function ()
  {
    document.getElementById( this.param_id ).value = this.getBranchAsText( null );
  },
  
  getBranchAsText : function ( parent )
  {
    var result = "";
    var indexes = this.getIndexesByParent( parent );
    
    for( var key = 0; key < indexes.length; key ++ ) {
      var cindex = indexes[ key ];
      if( this.dump_values[ cindex ].removed ) {
        continue;
      }
      
      if( this.dump_values[ cindex ].is_new ) {
        this.dump_values[ cindex ].value = document.getElementById( "felix_sr_newvalue_" + cindex ).value;
      }
      
      if( ! this.dump_values[ cindex ].value ) {
        continue;
      }
      
      
      result += this.str_repeat( ">", this.dump_values[ cindex ].level - 1 ) + this.dump_values[ cindex ].value + "\n";
      
      if( this.dump_values[ cindex ].children ) {
        result += this.getBranchAsText( cindex ); 
      }
      
    }
    return result;
  },
  
  str_repeat : function ( text, count )
  {
    var result = "";
    
    for( var key = 1; key <= count; key ++ ) {
      result += text;
    }
    
    return result;
  },
  
  destroyConstructorView : function ()
  {
    while( this.background.childNodes.length > 0 ) {
      this.background.removeChild( this.background.childNodes[0] );
    }
    
    this.background.style.display = "none";
  },
  
  parseValues : function ()
  {
    var textarea = document.getElementById( this.param_id );
    var param_text = textarea.value.replace( "\r", "" );
    var lines = param_text.split( "\n" );
    
    chain = new Array( null );
    result = new Array();
    var parent = null;
    
    for( var key = 0; lines.length > key; key ++ ) {
      var chain_level = chain.length - 1;
      var line = lines[key].replace( /^[ \r\n]*([^\n\r]*)[ \r\n]*$/, "$1" );
      if( !line ) continue;
      var matches = line.match( /^([> ]*)([^>]*)$/ );
      
      var value_level = matches[1].replace( " ", "" ).length + 1;
      var value = matches[2];
       
      //alert( value_level + " " + chain_level + " " + value + " " + parent );
      
      if( value_level > chain_level ) {
        if( value_level - chain_level > 1 ) {
          alert( 'Params sintacsis is not correct!' );
          return false;
        }
        chain[chain.length] = result.length;
        if( typeof result[chain[chain.length - 2]] != "undefined" ) {
          result[chain[chain.length - 2]].children = true;
        }
      }
      
      if( value_level == chain_level ) {
        chain[chain.length-1] = result.length;
      }
      
      if( value_level < chain_level ) {
        while( chain.length - 1 != value_level && chain.length != 0 ) {
          chain.pop();
        }
        chain[chain.length - 1] = result.length;
      }
      
      parent = chain[chain.length - 2];
      
      result[result.length] = { 'value' : value, 'level' : value_level, 'parent' : parent, "children" : false, "removed" : false, "is_new" : false };
    }
    
    return result;
  }
}