<?php
/**
 * @fileID: $Id: set_location.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );
class plgJoomsuite_content_fieldsSet_location extends JPlugin
{
	function plgJoomsuite_content_fieldsSet_location( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField(&$obj, &$params, $type)
	{
		if($type != 'set_location') return;
		$def = JRequest::getVar('fields', array(), 'default', 'array');
		if(key_exists($obj->id, $def)) $obj->field_value = $def[$obj->id];
		if($obj->field_value)
		{
			$value = str_replace(array(' ', '(', ')'), '', $obj->field_value);
			$values = explode(',', $value);
			$params->set('lat', $values[0]);
			$params->set('lng', $values[1]);
			$params->set('zoom', 11);
		}
		static $load = FALSE;
		
		if(!$load)
		{
    		$document = & JFactory::getDocument();
    		$document->addScript("http://maps.googleapis.com/maps/api/js?sensor=false");
    		$load = TRUE;
		}
		
		?>
<div id="map_canvas_<?php echo $obj->id?>" style="width: <?php echo $params->get('width') ?>px; height: <?php echo $params->get('height') ?>px"></div>
<script type="text/javascript">
    function initialize_<?php echo $obj->id ?>() {
      var myLatlng = new google.maps.LatLng(<?php echo $params->get('lat', '42.293564192170095') ?>, <?php echo $params->get('lng', '-33.33983659744263') ?>);
      var myOptions = {
        zoom: <?php echo $params->get('zoom', 10) ?>,
        center: myLatlng,
        mapTypeId: google.maps.MapTypeId.ROADMAP
      }
      var map = new google.maps.Map(document.getElementById("map_canvas_<?php echo $obj->id?>"), myOptions);
      var marker = new google.maps.Marker(
    	      {'position' : myLatlng, 
        	   'map' : map,
        	   'cursor' : 'move', 'draggable' : true});
      google.maps.event.addListener(map, 'click', function(event) {
		marker.setPosition(event.latLng);	
        //map.setCenter(location);
  	  	document.getElementById('ln_text_<?php echo $obj->id ?>').value = event.latLng.toString();
      });
    }
</script>

<script type="text/javascript">
	initialize_<?php echo $obj->id ?>();
</script>
<p class="small"><?php echo JText::_('Scroll to zoom, drag to pan, and click to place marker on th map.')?></p>
<input type="hidden"
	name="fields[<?php echo $obj->id ?>]"
	value="<?php echo $obj->field_value; ?>"
	id="ln_text_<?php echo $obj->id ?>" />
		<?php
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'set_location') return;
		if(!$value) return;
		$value = str_replace(array(' ', '(', ')'), '', $value);
	}


	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		if(!$field->field_value) return;
		if($field->type != 'set_location') return;
		
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		
		static $load = FALSE;
		
		//$out = $field->field_value;
		
		if($params->get('show_location'))
		{
			//$out = array();
			
			if($field->field_value)
			{
				$value = str_replace(array(' ', '(', ')'), '', $field->field_value);
				$values = explode(',', $value);
				$params->set('lat', $values[0]);
				$params->set('lng', $values[1]);
				//$params->set('zoom', 11);
			}
			else
			{
				return;
			}
				
			if(!$load)
			{
    			$document = & JFactory::getDocument();
    			$document->addScript("http://maps.googleapis.com/maps/api/js?sensor=false");
    			$load = TRUE;
			}

			$out[] = '<div id="map_canvas_'.$field->id.'" style="width:'.$params->get('width').'px; height:'.$params->get('height').'px"></div>';
			
			$out[] = '<script type="text/javascript">';
			$out[] = 'function initialize_'.$field->id.'()';
			$out[] = "{";
            $out[] = "	var myLatlng = new google.maps.LatLng(".$params->get('lat').", ".$params->get('lng').");";
            $out[] = "	var map = new google.maps.Map(document.getElementById(\"map_canvas_".$field->id."\"), {zoom:".$params->get('sl_zoom', 14).",center:myLatlng, mapTypeId: google.maps.MapTypeId.ROADMAP, draggable:0, scrollwheel:0});";
            $out[] = "	var marker = new google.maps.Marker({position:myLatlng, map:map});";
			$out[] = "}";
			$out[] = 'initialize_'.$field->id.'()';
			$out[] = "</script>";
			$out = implode("\n", $out);
		}
	}
}?>