<?php
/**
 * @fileID: $Id: status_mailer.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsStatus_Mailer extends JPlugin
{
	var $_entries = array();

	function plgJoomsuite_content_fieldsStatus_Mailer( &$subject, $params )
	{
		parent::__construct( $subject, $params );
		$this->_entries = array(
			'open',
			'on_hold',
			'revised',
			'assigned',
			'in_progress',
			'closed'
			);
	}

	function onRenderField( &$obj, &$params, $type)
	{
		if ($type != 'status_mailer') return;

		$user = & JFactory::getUser();
		//$value = @unserialize($obj->field_value);
		$value = $obj->field_value;

		//echo $value;
		$options = array();

		$selectedStateWasShown = false;

		foreach ($this->_entries as $e) {
			// -1 for none
			if ($params->get('status_'.$e) == -1)
			continue;

			if ($params->get('status_'.$e) > $user->get('aid')) {
				continue;
			}

			$label = $params->get('label_'.$e);
			$color = $params->get('color_'.$e);

			$style = '';
			if (@$color) $style = ' style="color: '.$color.'" ';

			$selected = '';
			if (@$value == $e) {
				$selected = ' selected="selected" ';
				$selectedStateWasShown = true;
			}
			$options [] = '<option '.$style .$selected .' value="'.$e.'">'.JText::_($label).'</option>';
		}

		if (count($options)) {
			echo '<select name="fields['.$obj->id.']">';
			foreach ($options as $opt) {
				echo $opt;
			}
			echo '</select>';
		}
		else
		{
			if($value)
			{
				$label = $params->get('label_'.$value);
				echo JText::_($label);
			}
			else
			{
				echo JText::_('Status');
			}

			echo '<input type="hidden" name="fields[', $obj->id, ']" value="1" />';
		}

		//echo '<input type="hidden" name="fields[', $obj->id, '][old]" value="', htmlspecialchars(@$value['value'], ENT_QUOTES, 'UTF-8'), '" />';
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if ($type != 'status_mailer') return;
		if(!$value) return;
		
		//echo $value; 

		$db = & JFactory::getDBO();
		$sql = "SELECT field_value FROM #__js_res_record_values WHERE record_id = {$row->id} AND field_id = {$id}";
		$db->setQuery($sql);
		$old_value = $db->loadResult();
		
		$user 		= & JFactory::getUser();
		$author 	= & JFactory::getUser($row->user_id);

		if (!in_array($value, $this->_entries)) {
			$old_value ? $value = $old_value : $value = 'open';
			return;
		}

		$sendAlertsOn = $params->get('send_alerts_on');
		settype($sendAlertsOn, 'array');
		
		if(in_array($value, $sendAlertsOn) && ($author->id != $user->id) && $old_value && ($old_value != $value))
		{
			$label = $params->get('label_'.$value);
			
			$body = JText::_($params->get('mail_body'));
			$body = str_replace('[STATUS]', $label, $body);
			$body = str_replace('[EDITOR]', $user->username, $body);
			
			MEAlerts::custom($row, 'Status Changed - '.JText::_($label), $body, null, array('email_field' => 1, 'cusotm_email' => $params->get('mail_recepients')));
		}
		
		if ($params->get('disable_comment_on_close') && ($value == 'closed'))
		{
			//echo 345;
			$record_params = new JParameter($row->params);
			$record_params->set('comments_access', 3);
			$sql = "UPDATE #__js_res_record SET `params` = '".$record_params->toString()."' WHERE id = {$row->id}";
			$db->setQuery($sql);
			$db->query();
		}
		//exit;
	}

	function onCommentSubmit($post, $article, $iparams)
	{
		$db = & JFactory::getDBO();

		$q = 'SELECT v.id AS vid, f.* '.
		' FROM 			#__js_res_fields 		f '. 
		'	LEFT JOIN 	#__js_res_types 		t ON f.type_id = t.id '. 
		'	LEFT JOIN 	#__js_res_record_values v ON v.field_id = f.id AND v.record_id = '.($article->id).
		' WHERE '.
		'	t.id = '.$article->type_id.' AND f.type = "status_mailer" ';

		$db->setQuery( $q );

		$results = $db->loadObjectList();
		
		if (empty($results)) return;
			
		foreach ($results as $f) {
			$params = new JParameter($f->params);
				
			if ($params->get('open_on_comment'))
			{
				$recordValue = & JTable::getInstance('Record_Values', 'Res');
				if ($recordValue->load($f->vid)) {
					$recordValue->field_value = 'open';
					if (!$recordValue->store() ) {
						JError::raiseError(404, 'Cannot store record value');
					}
				}
			}
		}
	}

	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$type = $field->type;

		if($type != 'status_mailer') return;
		if(!$field->field_value) return;

		$params = new JParameter($field->params);
		$color = $params->get('color_'.$field->field_value);
		$label = $params->get('label_'.$field->field_value);

		$output = sprintf('<span style="color:%s">%s</span>', $color, JText::_($label));
		$out = ResHelper::cleanFilterValue($output, base64_encode($field->field_value), $field, $params, $record);
	}
	function onFilter($out, $type)
	{
		if($type != 'status_mailer') return;
		$out = true;
	}
	function onFilterWhere(&$sql, $type, $filter, $value)
	{
		if( $type->type != 'status_mailer' ) return;
		if( !$value ) return;
		$sql = "field_value = '{$value}'";
	}
	function onFilterWornLabel(&$label, &$filter, $value, &$params, $category_id)
	{
		
		if ($filter->type != 'status_mailer') return;
		$fparams = new JParameter($filter->params);
		$label = $fparams->get('label_'.$value);
		$label = JText::_($label);
	}
	function onRenderFilter(&$get, &$filter, &$params, $category)
	{
		global $mainframe, $option;
		static $results = array();

		$filters_type = $filter->type;

		if($filters_type != 'status_mailer')
		return;

		$fparam = new JParameter($filter->params);
		$get = false;

		$itemid = JRequest::getVar('Itemid');
		$db = & JFactory::getDBO();

		$where = getFilterWhere($params);
			
		switch ($params->get('filters_mode', 1))
		{
			case 1:
				$sql = "SELECT fv.field_value AS value,
				COUNT(r.id) as total
				FROM #__js_res_record_values as fv
				LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id
				LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = fv.record_id
				WHERE fv.field_id = {$filter->id}
				AND rc.catid = {$category}
				{$where}
				GROUP BY fv.field_value";
				break;
			case 3:
				$category = JRequest::getInt('category_id', $category);
				$ids = ResHelper::getCategoryChildrenIds($category);
				$sql = "SELECT fv.field_value AS value,
				COUNT(r.id) AS total
				FROM #__js_res_record_values as fv
				LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id
				LEFT JOIN #__js_res_record_category AS rc ON rc.record_id = fv.record_id
				WHERE fv.field_id = {$filter->id}
				AND rc.catid IN ({$ids})
				{$where}
				GROUP BY fv.field_value";
				break;

			case 2:
				$sql = "SELECT fv.field_value AS value,
				COUNT(r.id) AS total
				FROM #__js_res_record_values as fv
				LEFT JOIN #__js_res_record AS r ON r.id = fv.record_id
				WHERE fv.field_id = {$filter->id}
				{$where}
				GROUP BY fv.field_value";
				break;
		}

		if ($fparam->get('order_by'))
		$sql .= ' ORDER BY ' . $fparam->get('order_by');

		if(!key_exists($sql, $results))
		{
			$db->setQuery($sql);
			$get = $db->loadObjectList();
		}
		else
		{
			$get = $results[$sql];
			return;
		}

		if(is_array($get))
		{
			foreach ($get AS $key => $val)
			{
				$label = $fparam->get('label_'.$val->value);
				$get[$key]->text = ResHelper::translateValue($label)." ({$val->total})";
				$get[$key]->value = base64_encode($val->value);
			}
		}
		$results[$sql] = $get;
	}
}