<?php
/**
 * @fileID: $Id: subscription.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

define ('PLG_SUBS_DUMMY_FIELD', 'plg_subscr_dummy');
define ('PLG_SUBS_DUMMY_FIELD_VALUE', '1');

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsSubscription extends JPlugin
{
	function plgJoomsuite_content_fieldsSubscription( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}

	function onRenderField(&$obj, &$params, $type)
	{	
		if($type != 'subscription') return;
		$default = JRequest::getVar('fields', null, 'default', 'array');
		
		if (isset($default[$obj->id]))
			$default = $default[$obj->id];
		else
			$default = @unserialize($obj->field_value);
			
		if (!isset($default['apply']))
			$default['apply'] = 1;
			
		$user = & JFactory::getUser();
		if ($user->get('aid') >= $params->get('access_for_edit')) {
			?>
			<label><?php echo JText::_('Yes');?> <input type="radio" name="fields[<?php echo $obj->id; ?>][apply]" value="1" <?php echo $default['apply']=='1' ? 'checked' : ''; ?> /> </label>
			<label><?php echo JText::_('No');?> <input type="radio" name="fields[<?php echo $obj->id; ?>][apply]" value="0" <?php echo $default['apply']=='0' ? 'checked' : ''; ?> /> </label>
			<?php
		}
		else {
			echo JText::_('The article is subscription protected');
			?>
			<input type="hidden" name="fields[<?php echo $obj->id; ?>][<?php echo PLG_SUBS_DUMMY_FIELD; ?>]" value="<?php echo PLG_SUBS_DUMMY_FIELD_VALUE; ?>" />
			<?php
		}
	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'subscription') return;
		if(!$value) return;
		
		$value = serialize($value);
	}


	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		static $viewedId = array();
		$type = $field->type;
		
		
		if($type != 'subscription') return;
		if(!$field->field_value) 				 {return;}
		if($field->field_value == 'none'){return;}
		
		
		$params = new JParameter($field->params);
		$user = $record->user_id;

		$itemid 	= $params->get('Itemid');
		$alertText	= $params->get('alertText');
		$linkName 	= $params->get('linkname');
		$data 		= @unserialize($field->field_value);
		$viewSp 	= $params->get('viewSp');
		
		$isPublic = !is_array($viewSp) && $viewSp == -1;
		
		if ((isset($data['apply']) && $data['apply'] == 0) || $isPublic)
		{
			return;
		}
		
		// Halt only on articles.
		$articleId = JRequest::getInt('article');
		
		if ($articleId > 0) {
			// We'll have 'true' here, if the user doesn't have a subscription.
			if (!$isPublic && !jscCheckSubscription(
				$viewSp,
				$alertText,
				$itemid,
				true,
				$params->get('count_mode')))
			{
				if (!isset($viewedId[ $articleId ])) {
					jscCountLimit($viewSp, $params->get('count_mode'));
					$viewedId[ $articleId ] = 1;
				}
			}
		}
		else {
			$userHasSubscriptions = true;
			if (!$isPublic) {
				// See if the user has the demanded subscriptions
				$userHasSubscriptions = !jscCheckSubscription(
					$viewSp,
					'',
					'',
					false,
					$params->get('count_mode')
				);
			}
			
			if (!$userHasSubscriptions)
			{
				$id = $viewSp;
				if (is_array($viewSp))
					$id = implode(',', $viewSp);
				$url = JRoute::_('index.php?option=com_jcs&view=jcs&layout=form&Itemid='.$itemid.'&id='.$id);
				$out = $linkName. '<a href="'.$url.'"> '. JText::_('List subscriptions'). '</a>';
			}
		}
	}
	

}
