<?php
/**
 * @fileID: $Id: youtube.php 7311 2011-08-19 11:18:02Z shitz $
 * @changedDate: $LastChangedDate: 2011-08-19 17:18:02 +0600 (Пт, 19 авг 2011) $
 * @changedBy: $LastChangedBy: shitz $
 * MightyResources Field plugin by Mighty Extensions
 * a plugin for Joomla! 1.5 CMS (http://www.joomla.org)
 * Author Website: http://www.mightyextensions.com/
 * @copyright Copyright (C) 2006 - 2011 MightyExtensions (http://www.mightyextensions.com). All rights reserved.
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
*/
defined( '_JEXEC' ) or die( 'Restricted access' );

jimport( 'joomla.plugin.plugin' );

class plgJoomsuite_content_fieldsYouTube extends JPlugin
{
	function plgJoomsuite_content_fieldsYouTube( &$subject, $params )
	{
		parent::__construct( $subject, $params );
	}
	
	/*
		This function extracts the Youtube code from the full Youtube url, 
		ie stripping "http://www.youtube.com/watch?v=" from
		"http://www.youtube.com/watch?v=LDTK6xw8y10"
		function added by Mikael Skoldemar, iSay Consulting (www.isayconsulting.com)
	*/
	function extractYouTubeCode($val) {
			$patterns[0] = '/http:\/\//';
			$patterns[1] = '/www.youtube.com\//';
			$patterns[2] = '/watch\?v=/';
			$patterns[3] = '/v\//';		
			return preg_replace($patterns, '', $val);
	}

/*
<object width="425" height="349"><param name="movie" value="http://www.youtube.com/v/NQgJl9d5KCQ&hl=en&rel=0&color1=0x006699&color2=0x54abd6&border=1"></param><embed src="http://www.youtube.com/v/NQgJl9d5KCQ&hl=en&rel=0&color1=0x006699&color2=0x54abd6&border=1" type="application/x-shockwave-flash" width="425" height="349"></embed></object>
<object width="425" height="349"><param name="movie" value="http://www.youtube.com/v/NQgJl9d5KCQ&hl=en&color1=0x006699&color2=0x54abd6&border=1"></param><embed src="http://www.youtube.com/v/NQgJl9d5KCQ&hl=en&color1=0x006699&color2=0x54abd6&border=1" type="application/x-shockwave-flash" width="425" height="349"></embed></object>
<object width="425" height="349">
<param name="movie" value="http://www.youtube.com/v/20QBe43tyVM&hl=en&color1=0x006699&color2=0x54abd6&border=1"></param>
<embed src="http://www.youtube.com/v/20QBe43tyVM&hl=en&color1=0x006699&color2=0x54abd6&border=1" type="application/x-shockwave-flash" width="425" height="349"></embed>
</object>
*/

	function onRenderField(&$obj, &$params, $type)
	{
		if ($type != 'youtube') 
			return;

		$def = JRequest::getVar('fields', null, 'default', 'array');
		if($def[$obj->id]) {$obj->field_value = $def[$obj->id];}
		
		$value = $obj->field_value ? $obj->field_value : 'http://';
		$value = htmlspecialchars($value, ENT_QUOTES, 'UTF-8');
		
		print '<input type="text" name="'. "fields[$obj->id]".'" size="20" value="'.$value.'" />';

	}

	function onBeforeSave(&$value, &$params, $type, $id, $row, &$error)
	{
		if($type != 'youtube') return;
		if(!$value) return;
		$db = &JFactory::getDBO();
		$value = $this->extractYouTubeCode(trim($value));
	}


	function onRenderFieldValue(&$out, &$field, &$record, $category)
	{
		$params = new JParameter($field->params);
		$user = $record->user_id;
		$type = $field->type;
		$options = array();
		if($record->client_id)
		{
			$options['client'] = $record->client;
			$options['client_id'] = $record->client_id;
		}
	
		if ($type != 'youtube') return;
		if (!$field->field_value) return;

		
		$related = $params->get('related') ? 'rel=0' : '';
		
		$value 		= htmlspecialchars($field->field_value, ENT_QUOTES, 'UTF-8');
		
		if (JRequest::getWord('view') == 'list' && $params->get('video_thumb', 0) == 1)
		{
			$link 	= JRoute::_(MEUrl::link_record($field->record_id, $category));

			$thumb_width	= (int)$params->get ( 'thumb_width',  120);
			$thumb_height 	= (int)$params->get ( 'thumb_height', 90 );
			preg_match('~([0-9a-z_-]+)~i', $value, $matches);
			$value=$matches[1];
			if ($params->get ( 'video_thumb_link'))
			{
				$linkage_start = '<a title="'.JText::_('Click to view video').'" href="'.$link.'">';
				$linkage_end = '</a>';
			}

			$out .= $linkage_start.'<img src="http://img.youtube.com/vi/'.$value.'/1.jpg" width="'.$thumb_width.'" height="'.$thumb_height.'">'.$linkage_end;
		}
		else
		{
			$outcolor 	= $params->get('outcolor');
			$incolor 	= $params->get('incolor');
			$border 	= $params->get('border');
			
			$width	 	= (int)$params->get ( 'width', 	425 );
			$height 	= (int)$params->get ( 'height', 349 );
				
			if (!$params->get('iecomp'))
				$iefx = '<object width="'.$width.'" height="'.$height.'"><param name="movie" value="http://www.youtube.com/v/'.$value.'&hl=en&'.$related.'&color1='.$incolor.'&color2='.$outcolor.'&border='.$border.'"></param>';
			else 
				$iefx = null;
				
			$out = $iefx.'<embed src="http://www.youtube.com/v/'.$value.'&hl=en&'.$related.'&color1='.$incolor.'&color2='.$outcolor.'&border='.$border.'" type="application/x-shockwave-flash" width="'.$width.'" height="'.$height.'"></embed>';
			
			if ($iefx) 
				$out .= '</object>';
		}
	}

}
?>
